
// デフォルトで Voodoo モード（フルスクリーン、-w 640 -h 480 等）
//#define VOODOO_MODE

//#define WIN32_CONSOLE_APP

//BeOS

#include <Application.h>

#define NO_SELECT
//#define NO_SLEEP

#ifdef   WIN32
#define  WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <tchar.h>
// IMEツールバー消去用
#include "winnls32.h"
#define  NM_RESOLUTION	11
#else
#include <unistd.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <math.h>
#include <time.h>
#include <limits.h>

#include "Option.H"
#include "GLObject.H"
#include "PNMIO.H"

#include<OS.h> //jun
#include<Alert.h> //jun

#define TITLE_VER		"glclcok-4.6"
#define StartingMessage do { cout << TITLE_VER ", February 1999 by Masaki Kawase (g93088@isc.chubu.ac.jp)" << endl << endl ; } while (FALSE)

#define SIGN	"Presented by Masa."

// RGBA フォーマット使用時のアルファ値
#define DEFAULT_ALPHA		1.0f

//#define GIFF_DEMO
#define GIFF_DEMO_HOUR		3
#define GIFF_DEMO_MINUTE	55
#define GIFF_DEMO_SECOND	32
#define GIFF_SPIN_X			-10.0f

// glclock イメージパス指定環境変数
#define ENV_IMAGE_PATH		"GLCLOCK_IMAGE_PATH"

// スピン関係初期値
#define SPIN_X		-18.0f
#define SPIN_Y		0.0f

#ifdef GIFF_DEMO
#define ROTATE_Y	0.0f
#define ROTATE_X	0.0f
#else
#define ROTATE_Y	-30.0f
#define ROTATE_X	-14.0f
#endif

#define N_ANTI		8
#define N_MOTION	6

#define METAL_RATIO	2.0f

#ifndef VOODOO_MODE
static int WIDTH  = 320 ;
static int HEIGHT = 320 ;
#define SPEED		160.0f
#else
static int WIDTH  = 640 ;
static int HEIGHT = 480 ;
#define SPEED		160.0f
#endif

#define IS_SET_WIDTH	FALSE
#define IS_SET_HEIGHT	FALSE

// スクリーンセーバ時の時計サイズ
#define CLOCK_SIZE		0.6f

// アルファグロー使用しないフラグ
static int DONOT_USE_ALPHA_GOURAUD = FALSE ;
static int DONOT_USE_GL_READ_BUFFER = FALSE ;

#define BITS_RADIUS	11.2f
#define HDRN_RADIUS	11.0f

#define ROOF_RAD	150.0f
#define ROOF_MOVE	11.0f

#define QUALITY		4
#define ANTI		0
#define MOTION		0
#define S_MOTION	0
#define SHUTTER		0.5f
#define S_SHUTTER	1.0f

#define S_MOTION_ALPHA	(2.0f - (2.0f / s_motion))
#define PRE_S_MOTION_A	(2.0f - (2.0f / pre_s_motion))

#define BG_COLOR	0
#define DITHER		1
#define LIGHT		5
//#define LOCAL		1
#define ENV_FILE	"sky.ppm"
#define SOLID_FILE	"wood.ppm"
#define SLD2_FILE	""
#define ENV_TEX		0
#define SOLID_TEX	0
#define MIN_FILTER	"LL"
#define SPECULAR	1.0f
#define CRYSTAL		0
#define CRYSTAL_A	0.5f
#define POL_MODE	"F"
#define REALITY		0
#define PERS_CORR	"D"
#define TEX_SCALE	41.0f
#define TEX_SIZE	0
#define U_SMOOTH	-1
#define V_SMOOTH	-1
#define M_SLEEP		0
#define SLEEP_RATIO	0.0f
#define N_D_WIDTH	1.4f
#define N_WIDTH		1.0f
#define FOUT_FPS	""

#define TEX_FORMAT	"RGB"

#define Z_OFFSET	0.0f
#define Z_OFFSET_TNT_FIX	0.1f

#define SHELL_VTX	21
#define SHELL2_VTX	13
#define ROOF_VTX	7
#define ROOF2_VTX	5
#define M_VTX		9

#define B_DIST		-80.0f
#define T_RATIO		0.2f
#define I_RATIO		0.8f
#define T_MAX		40.0f
#define P_MIN		0.05f
#define P_MAX		20.0f
#define IR_RATIO	0.95f

#define BPPIXEL		0

#define IS_SET_M_RATIO	(texture == 2 || solid)
#define SOLID_M_RATIO	(0.75f - solid * 0.1f)
#define METAL_R_M_RATIO	(reality ? 0.1f : SOLID_M_RATIO)

#define U_SMOOTH_FLAG	(u_smooth == -1 ? (divide >= 12) : u_smooth)
#define V_SMOOTH_T(t)	(v_smooth == -1 ? (t) : NULL)

#define FOG_MODE	GL_EXP2
#define FOG_DENSITY	0.001f

// ６０ループまたは２秒を超えたらＦＰＳ計算
#define F_COUNT			60
#define F_TIME_COUNT	1

// OpenGLドライバおよびビデオカード種別
enum
{
	GENERIC, MESA_LIB, VOODOO_MESA,
	VOODOO, VOODOO2, VOODOO2_SLI,
	VOODOO_RUSH, VOODOO_BANSHEE,
	PERMEDIA2, RIVA, RIVA_TNT_FIX
} ;

// ディスプレイリスト識別ナンバ
static GLuint ROOF_LIST, SHELL_LIST, MIRROR_WALL_LIST, HEDRON_LIST, HEDRON_LIST2, HEDRON_LIST3, BOARD_LIST, BOARD_DETAIL_LIST,
	HOUR_LIST, MINUTE_LIST, SECOND_LIST, SECOND_E3_LIST, MIRROR_HOUR_LIST, MIRROR_MINUTE_LIST, MIRROR_SECOND_LIST,
	POINT_LIST, GLASS_LIST, M_LIST, GOLDEN_OBJECT_LIST,

	ENV_ROOF_LIST, ENV_ROOF_ANTI_LIST, ENV_ROOF_MOTION_LIST, ENV_ROOF_OVER_LIST, ENV_SHELL_LIST, ENV_MIRROR_WALL_LIST, ENV_BOARD_LIST, ENV_BOARD_DETAIL_LIST, ENV_GLASS_LIST,
	ENV_HOUR_LIST, ENV_MINUTE_LIST, ENV_SECOND_LIST, ENV_MIRROR_HOUR_LIST, ENV_MIRROR_MINUTE_LIST, ENV_MIRROR_SECOND_LIST, ENV_GOLDEN_OBJECTS_LIST,

	MATERIAL_GOLD, MATERIAL_IRON, MATERIAL_GLASS, MATERIAL_GLASS2, MATERIAL_GLASS3,
	MATERIAL_GLASS4, MATERIAL_METAL_RED, MATERIAL_RED_GRAY, MATERIAL_METAL_BLUE, 
	MATERIAL_METAL_GREEN, MATERIAL_MAT_IRON, MATERIAL_MAT_GOLD,
	MATERIAL_MAT_METAL_GREEN, MATERIAL_MAT_METAL_BLUE,
	MATERIAL_SPECULAR, MATERIAL_SEC_SPECULAR, // MATERIAL_MAT_SPECULAR,

//	MATERIAL_BLUE_DIFFUSE, MATERIAL_GREEN_DIFFUSE, MATERIAL_GOLD_DIFFUSE,
//	MATERIAL_RED_DIFFUSE, MATERIAL_IRON_DIFFUSE,

	MATERIAL_MIRROR_RED_GRAY,
	MATERIAL_IRON_SPECULAR, MATERIAL_RED_SPECULAR, MATERIAL_BLUE_SPECULAR, MATERIAL_GREEN_SPECULAR, MATERIAL_GOLD_SPECULAR, MATERIAL_RED_GRAY_SPECULAR,

//	METAL_LIGHT_ATTRIBUTE,

	ENV_TEXTURE_LIST, ENV_GLASS_TEXTURE_LIST, SOLID_TEXTURE_LIST, SOLID2_TEXTURE_LIST, CHROME_TEXTURE_LIST,

	CLOCK_LIST, SIGN_LIST ;

// テクスチャネーム
static GLuint TEXTURE_NAME ;

struct TimeAngle
{
	float	hour, minute, second ;
} ;

// 時間計算用構造体
struct TimeData
{
	time_t	t ;
	struct	tm	*t_area ;
	int	n_hour, n_minute, n_second, p_hour, p_minute, p_second, fp_hour, fp_minute, fp_second ;
	TimeAngle angle ;
} ;

struct ClockState
{
	TimeAngle tm ;
	GLfloat  h_rotate, g_spin, pers, clock_z, roof ;

	// 秒針だけのモーションブラー用スタート角度とステップ角度
	GLfloat  start_angle, step_angle ;
} ;

// グローバル変数
static GLfloat	scr_w, scr_h, spin_x, spin_y, dist_y, z_step, p_step, fps, sleepRatio,
				m_speed, t_ratio, i_ratio, t_max, p_min, p_max, ir_ratio, norm_ratio,
				fog_density, t_roof, near_clip, far_clip, h_rotate, shutter, s_shutter, specular, spec,
				crystal_a, s_scale, t_scale, sum_fps = 0.0f, radius_ratio, n_width ;

static GLint	sum_polygons = 0, r_polygons, DragL, DragL_t, DragR, xsize, ysize, fog_mode, base, f_cnt, f_polygons, f_time, f_prn, f_cal_flag,
				clock_quality, clock_hedron, clock_glass, clock_div, clock_point, clock_mesh, gold_depth,
				anti, default_anti, motion, s_motion, default_motion, pre_motion, pre_s_motion, lid,
				stop, start, nm_polygons, ngrad, n_golden, no_sign, no_message,
				bg_color, grad_flag, dither, light, local, texture, solid, crystal, reality, full, reflection, max_tex, benchmark ;

static int		last_x, last_y, sign_x, sign_y, fps_x, fps_y, mouse_x, mouse_y, tex_size, u_smooth, v_smooth,
				fps_count = -5, env, loop_count = 0, is_set_width, is_set_height, m_sleep ;
static GLenum	gl_min_filter, gl_mag_filter, gl_pol_mode, gl_pers_corr ;
static unsigned int glut_buff, us_sleep ;
static String	sign(SIGN), title, env_file, solid_file, sld2_file, s_fps, tex_format, fout_fps ;
static Vector2d *jitter = NULL ;
static TimeData	timeData ;
static ClockState now, pre ;
static TRUEIMAGE *solid_image = NULL, *env_image = NULL, *solid2_image = NULL, *create_image = NULL ;
static Vector3d s(1.0f, 0.0f, 1.0f), l(0.0f, 1.0f, 0.0f), t, ms, mt ;

static int		envOpenGL, voodoo = FALSE, mesa = FALSE, fxOpenGL = FALSE ;
static int		saver, winIDglut, firstReshapeTime = -1 ;

static float	clockSize = 1.0f, zOffset ;
static int		scissorSize, viewportX, viewportY, viewportVX, viewportVY, polygon_offset = FALSE ;

#ifdef WIN32
static HANDLE	g_hFileMap = NULL ;
static char		*g_pFps = NULL ;
static int		bpp ;
#endif

// 色データ
static GLfloat  currentBG[4], currentLC[4], currentCL[4], currentGC[4], currentFG[4] ;

static Vector3d bgColor[] = { Vector3d( 0.0f, 0.4f, 1.0f ),
							  Vector3d( 0.7f, 0.2f, 0.1f ),
							  Vector3d( 0.0f, 0.0f, 0.2f ),
							  Vector3d( 0.0f, 0.4f, 1.0f ),
							  Vector3d( 0.0f, 0.0f, 0.0f ) },
				lightCl[] = { Vector3d( 1.0f, 1.0f, 1.0f ),
							  Vector3d( 1.5f, 0.7f, 0.5f ),
							  Vector3d( 0.7f, 0.8f, 1.5f ) } ;

static GLfloat lpos[][4] = { { -1.2f,  1.2f,  1.0f,  0.0f },
//                             {  1.0f, -1.0f, -1.0f,  0.0f },
                             {  1.0f,  0.3f, -0.5f,  0.0f },
                             {  1.0f,  -1.0f, -1.0f,  0.0f },
                             { -1.0f,  0.0f, -0.3f,  0.0f },
                             { -0.5f, -1.0f,  0.0f,  0.0f } },

			   lcol[][4] = { { 1.0f, 1.0f, 1.0f, 1.0f },
                             { 1.0f, 0.7f, 0.7f, 1.0f },
                             { 0.5f, 0.6f, 0.5f, 1.0f },
                             { 0.6f, 0.4f, 0.6f, 1.0f },
							 { 0.6f, 0.6f, 0.9f, 1.0f } },
//							 { 0.8f, 0.8f, 0.8f, 1.0f } },

			   black[4] = { 0.0f, 0.0f, 0.0f, 1.0f } ;

//			   metal_light_attribute = { 4.0f, 4.0f, 4.0f, 1.0f } ;

static Vector3d *rgrad, *rgrad_motion, *rgrad_anti,
				rcol[4] = { Vector3d(1.0f, 1.0f, 0.0f),	// 蓋の裏面のカラー
							Vector3d(1.0f, 0.0f, 1.0f),
							Vector3d(0.0f, 1.0f, 1.0f),
							Vector3d(0.7f, 0.7f, 0.7f) } ;

// 時計用三次元形状データ
static GLfloat n_v[][3] = { { 0.0f, 0.0f, 0.5f }, { 0.1f, 0.0f, 0.4f },
						     { 0.25f,0.0f, 0.3f }, { 0.5f, 0.0f, 0.2f },
						     { 0.75f,0.0f, 0.15f}, { 0.9f, 0.0f, 0.1f },
						     { 1.0f, 0.0f, 0.0f }, { 0.0f, 0.0f, 0.0f },
						     { 0.0f, 5.0f, 0.0f } },

				p_v[][3] = { { 0.0f, 0.0f, 0.2f }, { 0.0f,-0.4f, 0.0f },
							 { 0.2f, 0.2f, 0.0f }, {-0.2f, 0.2f, 0.0f } },
				mw_v[][2] = { { 14.0f, 0.0f }, { 14.3f, 3.8f } },

				s_v[][2] = { { 14.0f, 0.0f }, { 14.3f, 4.8f }, { 14.5f, 5.0f }, { 15.2f,  4.8f }, { 15.7f, 4.2f },	// -e -r の時 s_v[4] = (16.4f, 3.4f) に
							 { 17.0f, 1.5f }, { 17.4f, 1.92f}, { 17.6f, 2.0f }, { 20.0f,  0.0f }, { 20.4f,-0.5f },	// -e -r の時 s_v[8] = (19.0f, 1.2f) に
							 { 20.5f,-1.2f }, { 20.3f,-1.86f}, { 20.1f,-2.0f }, { 19.0f, -2.1f }, { 18.7f,-2.6f },
							 { 18.1f,-3.0f }, { 17.0f,-3.0f }, { 17.0f,-3.4f }, { 16.86f,-3.6f }, { 13.0f,-4.0f },
							 {  0.0f,-3.8f } },
				s2_v[][2] = { { 14.0f, 0.0f }, { 14.5f, 5.0f }, { 15.2f, 4.8f }, { 17.0f, 1.5f }, { 17.6f, 2.1f },
							  { 20.4f,-0.5f }, { 20.5f,-2.0f }, { 19.0f,-2.1f }, { 18.5f,-2.8f }, { 17.0f,-3.0f },
							  { 17.0f,-3.6f }, { 13.0f,-4.0f }, {  0.0f,-3.8f } },

				r_v[][2] = { {  0.0f, 6.6f }, {  8.8f, 6.0f }, { 14.3f, 5.2f }, { 14.4f, 5.0f },
							 { 14.2f, 4.6f }, { 13.7f, 4.6f }, { 13.5f, 5.0f } },
				r2_v[][2] = { { 0.0f, 6.6f }, {  8.8f, 6.0f }, { 14.3f, 5.2f }, { 14.4f, 5.0f }, { 13.7f, 4.6f } },

				m_v[][3] = { {  0.0f, 0.0f, 0.0f }, { -2.0f, 3.0f, 0.0f }, { -5.0f,-2.0f, 0.0f },
							 { -2.0f, 1.0f, 0.0f }, { -2.0f, 2.0f, 1.0f }, { 2.0f, 1.0f, 0.0f },
							 {  5.0f,-2.0f, 0.0f }, {  2.0f, 3.0f, 0.0f }, { 2.0f, 2.0f, 1.0f } },

				g_v[][3] = { {  0.0f, 3.0f, 3.0f }, { -5.0f, 0.0f, 0.0f }, { 5.0f, 0.0f, 0.0f }, { 0.0f, 4.5f, -0.6f }, { 0.0f, 0.0f, 4.0f } },

//				glass_v[][2] = { { 0.0f, 1.0f }, { 7.0f, 0.9f }, { 11.0f, 0.7f }, { 13.0f, 0.4f }, { 14.0f, 0.2f }, { 14.4f, 0.0f } } ;
//				glass_v[][2] = { { 0.0f, 1.8f }, { 7.0f, 1.6f }, { 11.0f, 1.2f }, { 13.0f, 0.6f }, { 14.0f, 0.2f }, { 14.4f, -0.2f } } ;
				glass_v[][2] = { { 0.0f, 1.8f }, { 10.0f, 1.62f }, { 12.0f, 1.35f }, { 13.3f, 0.9f }, { 13.9f, 0.45f }, { 14.4f, -0.2f } } ;

static int s_a[][2] = { { 0, 0 }, { 1, 1 }, { 0, 1 }, { 1, 1 }, { 1, 0 },
						{ 0, 0 }, { 1, 1 }, { 0, 1 }, { 1, 1 }, { 1, 1 },
						{ 1, 0 }, { 1, 1 }, { 0, 0 }, { 0, 1 }, { 1, 1 },
						{ 1, 0 }, { 0, 0 }, { 1, 1 }, { 0, 0 }, { 0, 0 } },	// [4] & [7] は、-e, -r 時は (1, 1) に設定される
		   s2_a[][2] = { { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 1 }, { 1, 0 },
						 { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 } },
/*
static int s_a[][2] = { { 0, 0 }, { 1, 1 }, { 0, 1 }, { 1, 1 }, { 1, 0 },
						{ 0, 0 }, { 1, 1 }, { 0, 1 }, { 1, 1 }, { 1, 1 },
						{ 1, 0 }, { 1, 1 }, { 0, 0 }, { 0, 1 }, { 1, 1 },
						{ 1, 0 }, { 0, 0 }, { 1, 1 }, { 0, 0 }, { 0, 0 } },
		   s2_a[][2] = { { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 1 }, { 1, 0 },
						 { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 } },
*/
/*
		   s_a2[][2] = { { 0, 0 }, { 0, 0 }, { 0, 1 }, { 1, 1 }, { 1, 0 },
						 { 0, 0 }, { 1, 1 }, { 0, 1 }, { 1, 1 }, { 1, 1 },
						 { 1, 0 }, { 1, 1 }, { 0, 0 }, { 0, 1 }, { 1, 1 },
						 { 1, 0 }, { 0, 0 }, { 1, 1 }, { 0, 0 }, { 0, 0 } },
		   s2_a2[][2] = { { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 1 }, { 1, 0 },
						  { 0, 0 }, { 0, 1 }, { 1, 0 }, { 0, 0 }, { 0, 0 }, { 0, 0 } },
*/
		   r_a[][2] = { { 0, 1 }, { 1, 0 }, { 1, 1 }, { 1, 1 }, { 1, 1 }, { 1, 1 }, { 1, 0 } },
		   r2_a[][2] = { { 0, 1 }, { 1, 0 }, { 1, 1 }, { 1, 0 } },

		   m_o[][3] = { { 0, 1, 4 }, { 1, 2, 4 }, { 2, 3, 4 }, { 3, 0, 4 },
						{ 0, 5, 8 }, { 5, 6, 8 }, { 6, 7, 8 }, { 7, 0, 8 } },

		   g_o[][3] = { { 0, 1, 4 }, { 0, 4, 2 }, { 0, 3, 1 }, { 0, 2, 3 } },

		   quality[][6] = { { 0,  6, 0, 0, 0, 0 }, { 0,  8, 1, 1, 0, 0 }, { 0, 16, 1, 1, 0, 1 }, { 1, 24, 1, 1, 1, 1 },
							{ 1, 32, 2, 1, 1, 2 }, { 1, 48, 2, 1, 1, 2 }, { 1, 64, 3, 1, 1, 2 }, { 1, 96, 3, 1, 1, 3 } },

		   n_s_vtx[] = { SHELL2_VTX, SHELL_VTX },
		   n_r_vtx[] = { ROOF2_VTX, ROOF_VTX } ;


#ifdef WIN32	// Windows なら
void u_sleep(unsigned long usecs)
{
    Sleep(usecs / 1000) ;
    return ;
}
#endif

#if !defined WIN32 && defined NO_SELECT && !defined NO_SLEEP	// WIN32 ではなく select を使わない場合
void u_sleep(unsigned long usecs)
{
//    usleep(usecs) ; jun
    snooze(usecs) ;
    return ;
}
#endif

#if !defined WIN32 && !defined NO_SELECT && !defined NO_SLEEP	// WIN32 ではなく select を使う場合
void u_sleep(unsigned long usecs)
{
    struct timeval tv ;
    tv.tv_sec  = usecs / 1000000L ;
    tv.tv_usec = usecs % 1000000L ;

    select (0, 0, 0, 0, &tv) ;
    return ;
}
#endif

#if !defined WIN32 && defined NO_SLEEP	// WIN32 ではなく NO_SLEEP が定義されている場合
void u_sleep(unsigned long usecs)
{
    return ;
}
#endif


// 回転累積用行列 
GLfloat aRotate[16] ;

inline void FreeImage(TRUEIMAGE **fimage)
{
	if (*fimage) { freeimage(*fimage) ; *fimage = NULL ; }
}

inline void FreeUsedImages()
{
	if ( solid_image) FreeImage(&solid_image) ;
	if (   env_image) FreeImage(&env_image) ;
	if (solid2_image) FreeImage(&solid2_image) ;
	if (create_image) FreeImage(&create_image) ;
}

#ifdef WIN32
void SetDisplayBPP(int b = 0, int w = 0, int h = 0)
{
	// フルスクリーンでなければ無視
	if (!full) return ;

	// bpp を適切な値に
	if      (bpp <= 0) return ;	// 0 は変更なし
//	else if (bpp <  4) b =  1 ;
//	else if (bpp <  8) b =  4 ;
	else if (bpp < 15) b =  8 ;
	else if (bpp < 24) b = 16 ;
	else if (bpp < 32) b = 24 ;
	else               b = 32 ;

	LONG ret ;
	DEVMODE dm ;
	dm.dmSize=sizeof(dm);
	dm.dmFields = DM_BITSPERPEL ;
	dm.dmBitsPerPel = (DWORD)bpp ;

	// w, h がゼロ以外なら、解像度も変更
	if (w)
	{
		dm.dmFields |= DM_PELSWIDTH | DM_PELSHEIGHT ;
		dm.dmPelsWidth  = w ;
		dm.dmPelsHeight = h ;
	}

	ret = ChangeDisplaySettings(&dm, CDS_FULLSCREEN) ;

	// リブートの必要時または成功時または 256以下に変更した場合
	if (ret == DISP_CHANGE_SUCCESSFUL || ret == DISP_CHANGE_RESTART || b <= 8)
		return ;

	// 変更に失敗した時
	if (ret != DISP_CHANGE_SUCCESSFUL)
	{
		// 似たモードで再度テスト
		if      (b = 15) dm.dmBitsPerPel = 16 ;
		else if (b = 16) dm.dmBitsPerPel = 15 ;
		else if (b = 24) dm.dmBitsPerPel = 32 ;
		else if (b = 32) dm.dmBitsPerPel = 24 ;

		ret = ChangeDisplaySettings(&dm, CDS_FULLSCREEN) ;
		if (ret != DISP_CHANGE_SUCCESSFUL)
		{
			// 似たモードで再度テスト
			if (b == 15 || b == 16) dm.dmBitsPerPel = 24 ;
			else                    dm.dmBitsPerPel = 15 ;

			ret = ChangeDisplaySettings(&dm, CDS_FULLSCREEN) ;
			if (ret != DISP_CHANGE_SUCCESSFUL)
			{
				// 似たモードで再度テスト
				if (dm.dmBitsPerPel == 15) dm.dmBitsPerPel = 16 ;
				else                       dm.dmBitsPerPel = 32 ;
				ChangeDisplaySettings(&dm, CDS_FULLSCREEN) ;
			}
		}
	}
}

void SetDisplayMode(int w, int h, int& cw, int& ch)
{
	static int scr[NM_RESOLUTION][2] =
		{ { 320, 200 }, {  320, 240 }, { 400, 300 }, {  512, 384 },
		  { 640, 400 }, {  640, 480 }, { 800, 600 }, { 1024, 768 },
		  { 1280, 1024 }, { 1600, 1200 }, { 2048, 1536 } } ;

	if (!is_set_width || !is_set_height || !full) return ;

	// Voodooモードの場合は適切な値に
	if (voodoo)
	{
		if      (w <  640) { w =  512 ; h = 384 ; }
		else if (w <  800) { w =  640 ; h = 480 ; }
		else if (w < 1024) { w =  800 ; h = 600 ; }
		else               { w = 1024 ; h = 768 ; }
	}

	DEVMODE dm ;
	dm.dmSize=sizeof(dm);
	dm.dmFields = DM_PELSWIDTH | DM_PELSHEIGHT ;

	int d_mode ;
	if (voodoo) d_mode = 2 ; // scr[2 + 1] = { 512, 384 }
	else        d_mode = -1 ;

	if (w > scr[NM_RESOLUTION - 1][0] || h > scr[NM_RESOLUTION - 1][1])
		d_mode = NM_RESOLUTION - 1 - 1 ;
	else
	{
		while (scr[d_mode + 1][0] < w || scr[d_mode + 1][1] < h) d_mode ++ ;
	}

	int allFail = FALSE ;
	do
	{
		d_mode ++ ;
		if (d_mode >= NM_RESOLUTION)
		{
			allFail = TRUE ;
			break ;
		}

		dm.dmPelsWidth  = scr[d_mode][0] ;
		dm.dmPelsHeight = scr[d_mode][1] ;

	} while (ChangeDisplaySettings(&dm, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL) ;

	// 全て失敗したら（つまり、元々最大値よりも大きい指定がされていた場合）
	if (allFail)
	{
		allFail = FALSE ;
		do
		{
			d_mode -- ;
			if (d_mode > NM_RESOLUTION)
			{
				allFail = TRUE ;
				break ;
			}

			dm.dmPelsWidth  = scr[d_mode][0] ;
			dm.dmPelsHeight = scr[d_mode][1] ;

		} while (ChangeDisplaySettings(&dm, CDS_FULLSCREEN) != DISP_CHANGE_SUCCESSFUL) ;
	}

	if (!allFail)
	{
		// 成功した場合は cw, xy に実際に変更したサイズをセット
		cw = dm.dmPelsWidth ;
		ch = dm.dmPelsHeight ;
	}
	else
	{
		// 全て失敗した場合（カレントのまま）は cw, xy にゼロをセット
		cw = 0 ;
		ch = 0 ;
	}
}

void SetDefaultDisplayMode()
{
	ChangeDisplaySettings(NULL, CDS_FULLSCREEN) ;
}
#endif


// 終了処理
void EndProc()
{
	DeleteSampleJitter(jitter) ;
	glutDestroyWindow(winIDglut) ;
	if (rgrad) delete [] rgrad ;

#if defined WIN32 // && defined VOODOO_MODE
	SetDefaultDisplayMode() ;
	if (voodoo) UpdateWindow(HWND_BROADCAST) ;
//		PostMessage(HWND_BROADCAST, WM_PAINT, 0, 0) ;
//		SendMessage(HWND_BROADCAST, WM_PAINT, 0, 0) ;
#endif

#ifdef WIN32
	if (g_pFps) UnmapViewOfFile(g_pFps) ;
#endif
}

// clock_div 時計の形によって基本的な半径の比率を変化（７角形以上なら 1.0f）
GLfloat RadiusRatio()
{
	switch (clock_div)
	{
	case 3:  return 0.55f ;
	case 4:  return 0.75f ;
	case 5:  return 0.86f ;
	case 6:  return 0.95f ;
	default: return 1.0f ;
	}
}

GLuint AllocAList(GLuint& list)
{
	if (!(list = glGenLists(1)))
	{
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T("Can't allocate Display Lists"), _T("glclock error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "Can't allocate Display Lists." << endl ;
		exit(1) ;
	}
	return list ;
}

/*
GLuint AllocATexture(GLuint& texture)
{
	glGenTextures(1, &texture) ;
	return texture ;
}
*/

GLenum GetHintMode(String m)
{
	if (m == String("F")) return GL_FASTEST ;
	if (m == String("N")) return GL_NICEST ;
	else                  return GL_DONT_CARE ;
}

// 文字盤上の小さな粒描画
void DrawClockPoint(GLfloat x, GLfloat y, GLfloat z)
{
	GLfloat       m[] = {   x, 0.0f, 0.0f, 0.0f,
					       0.0f,   y, 0.0f, 0.0f,
					       0.0f, 0.0f,   z, 0.0f,
						   0.0f, 0.0f, 0.0f, 1.0f } ;

	Object point(3) ;

	point.MakePolygon(0, 0,2,3, p_v, m) ;
	point.MakePolygon(1, 0,3,1, p_v, m) ;
	point.MakePolygon(2, 0,1,2, p_v, m) ;

	point.AverageNormal(0, 0, 0,1,2) ;
	point.AverageNormal(0, 1, 0,2) ;
	point.AverageNormal(0, 2, 0,1) ;
	point.AverageNormal(1, 0, 0,1,2) ;
	point.AverageNormal(1, 1, 0,1) ;
	point.AverageNormal(1, 2, 1,2) ;
	point.AverageNormal(2, 0, 0,1,2) ;
	point.AverageNormal(2, 1, 1,2) ;
	point.AverageNormal(2, 2, 0,2) ;

	glBegin(GL_TRIANGLE_FAN) ;

		glNormal3fv(point.polygon[0].normal[0].v) ;
		glVertex3fv(point.polygon[0].vertex[0].v) ;

		glNormal3fv(point.polygon[0].normal[1].v) ;
		glVertex3fv(point.polygon[0].vertex[1].v) ;

		glNormal3fv(point.polygon[1].normal[1].v) ;
		glVertex3fv(point.polygon[1].vertex[1].v) ;

		glNormal3fv(point.polygon[2].normal[1].v) ;
		glVertex3fv(point.polygon[2].vertex[1].v) ;

		glNormal3fv(point.polygon[0].normal[1].v) ;
		glVertex3fv(point.polygon[0].vertex[1].v) ;

	glEnd() ;
}

// Ｍ描画
void DrawM(GLfloat x = 1.0f, GLfloat y = 1.0f, GLfloat z = 1.0f)
{
	int    i ;
	Object objM(8) ;
	GLfloat m[] = {   x, 0.0f, 0.0f, 0.0f,
					 0.0f,   y, 0.0f, 0.0f,
					 0.0f, 0.0f,   z, 0.0f,
					 0.0f, 0.0f, 0.0f, 1.0f } ;

	for (i = 0 ; i < M_VTX - 1 ; i ++) objM.MakePolygon(i, m_o[i][0],m_o[i][1],m_o[i][2], m_v, m) ;
	objM.DrawTriangles() ;
}

// 文字盤上の１２個の粒の１つ描画
void DrawPolyhedron(GLfloat x = 1.0f, GLfloat y = 1.0f, GLfloat z = 1.0f, int depth = FALSE, int average = TRUE, int smooth = FALSE)
{
	if (clock_hedron)
	{
//		Icosahedron obj(x,y,z, depth, average, smooth) ;
//		obj.Draw(NONE, NONE, TRUE) ;

		Icosahedron::DrawPolyhedron(x) ;
	}
	else
	{
//		Octahedron obj(x,y,z, depth, average, smooth) ;
//		obj.Draw(NONE, NONE, TRUE) ;

		Octahedron::DrawPolyhedron(x) ;
	}
}

// 文字盤上の１２個の点描画
inline void DrawHedrons(GLfloat radius, GLfloat h_rotate)
{
	int	     i ;
	GLfloat rad ;

	glShadeModel(GL_FLAT) ;
	glCallList(MATERIAL_GOLD) ;

	for (i = 0 ; i < 12 ; i ++)
	{
		glPushMatrix() ;

			rad = 30.0f * i ;

			glRotatef(rad, 0.0f,0.0f,-1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glRotatef(h_rotate, 0.0f,1.0f,0.0f) ;	// 毎回ｚ軸回転

			if (i == 0)
			{
				glPushAttrib(GL_LIGHTING_BIT) ;
					glCallList(MATERIAL_METAL_RED) ;
					glCallList(HEDRON_LIST2) ;
				glPopAttrib() ;
			}
			else if (i == 6)
			{
				glPushAttrib(GL_LIGHTING_BIT) ;
					glCallList(MATERIAL_IRON) ;
					glCallList(HEDRON_LIST3) ;
				glPopAttrib() ;
			}
			else
				glCallList(HEDRON_LIST) ;

		glPopMatrix() ;
	}
}


// 鏡用、文字盤上の１２個の点描画（オーバサンプリング用）
inline void DrawMirrorHedronsWithOverSampling(GLfloat radius, GLfloat h_rotate, GLfloat alpha_weight = 1.0f)
{
	int	     i ;
	GLfloat rad ;

	glShadeModel(GL_FLAT) ;
	glColor4f(currentCL[0], currentCL[1]*0.9f, currentCL[2]*0.05f, alpha_weight) ;

	for (i = 0 ; i < 12 ; i ++)
	{
		glPushMatrix() ;

			rad = 30.0f * i ;

			glRotatef(rad, 0.0f,0.0f,-1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glRotatef(h_rotate, 0.0f,1.0f,0.0f) ;	// 毎回ｚ軸回転

			if (i == 0)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0], currentCL[1]*0.1f, currentCL[2]*0.2f, alpha_weight) ;
					glCallList(HEDRON_LIST2) ;
				glPopAttrib() ;
			}
			else if (i == 6)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0], currentCL[1], currentCL[2], alpha_weight) ;
					glCallList(HEDRON_LIST3) ;
				glPopAttrib() ;
			}
			else
				glCallList(HEDRON_LIST) ;

		glPopMatrix() ;
	}
}


// 鏡用、文字盤上の１２個の点描画
inline void DrawMirrorHedrons(GLfloat radius, GLfloat h_rotate, GLfloat color_weight = 1.0f)
{
	int	     i ;
	GLfloat rad ;

	glShadeModel(GL_FLAT) ;
	glColor4f(currentCL[0] * color_weight, currentCL[1]*0.9f * color_weight, currentCL[2]*0.05f * color_weight, 0.4f * color_weight) ;

	for (i = 0 ; i < 12 ; i ++)
	{
		glPushMatrix() ;

			rad = 30.0f * i ;

			glRotatef(rad, 0.0f,0.0f,-1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glRotatef(h_rotate, 0.0f,1.0f,0.0f) ;	// 毎回ｚ軸回転

			if (i == 0)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0] * color_weight, currentCL[1]*0.1f * color_weight, currentCL[2]*0.2f * color_weight, 0.4f) ;
					glCallList(HEDRON_LIST2) ;
				glPopAttrib() ;
			}
			else if (i == 6)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0] * color_weight, currentCL[1] * color_weight, currentCL[2] * color_weight, 0.4f) ;
					glCallList(HEDRON_LIST3) ;
				glPopAttrib() ;
			}
			else
				glCallList(HEDRON_LIST) ;

		glPopMatrix() ;
	}
}

// クリスタルの１２個の点描画
inline void DrawCrystalHedrons(GLfloat radius, GLfloat h_rotate, GLfloat color_weight = 1.0f)
{
	int	     i ;
	GLfloat rad ;

	glShadeModel(GL_FLAT) ;
	glColor4f(currentCL[0] * color_weight, currentCL[1]*0.9f * color_weight, currentCL[2]*0.05f * color_weight, 0.4f) ;

	for (i = 0 ; i < 12 ; i ++)
	{
		glPushMatrix() ;

			rad = 30.0f * i ;

			glRotatef(rad, 0.0f,0.0f,-1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glRotatef(h_rotate, 0.0f,1.0f,0.0f) ;	// 毎回ｚ軸回転

			if (i == 0)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0] * color_weight, currentCL[1]*0.1f * color_weight, currentCL[2]*0.2f * color_weight, 0.4f) ;
					glCallList(HEDRON_LIST2) ;
				glPopAttrib() ;
			}
			else if (i == 6)
			{
				glPushAttrib(GL_CURRENT_BIT) ;
					glColor4f(currentCL[0] * color_weight, currentCL[1] * color_weight, currentCL[2] * color_weight, 0.4f) ;
					glCallList(HEDRON_LIST3) ;
				glPopAttrib() ;
			}
			else
				glCallList(HEDRON_LIST) ;

		glPopMatrix() ;
	}
}

// 鏡用、文字盤上の１２個の点描画（-real オプション）
inline void DrawMirrorHedrons2(GLfloat radius, GLfloat h_rotate, int blend = FALSE)
{
	int	     i ;
	GLfloat rad ;

	if (!blend) glDisable(GL_BLEND) ;
	glShadeModel(GL_FLAT) ;
//	glColorMaterial(GL_AMBIENT_AND_DIFFUSE) ;
//	glCallList(MATERIAL_GOLD_DIFFUSE) ;
	glCallList(MATERIAL_GOLD_SPECULAR) ;

	for (i = 0 ; i < 12 ; i ++)
	{
		glPushMatrix() ;

			rad = 30.0f * i ;

			glRotatef(rad, 0.0f,0.0f,-1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glRotatef(h_rotate, 0.0f,1.0f,0.0f) ;	// 毎回ｚ軸回転

			if (i == 0)
			{
				glPushAttrib(GL_LIGHTING_BIT) ;
//					glCallList(MATERIAL_RED_DIFFUSE) ;
					glCallList(MATERIAL_RED_SPECULAR) ;
					glCallList(HEDRON_LIST2) ;
				glPopAttrib() ;
			}
			else if (i == 6)
			{
				glPushAttrib(GL_LIGHTING_BIT) ;
					glCallList(MATERIAL_IRON_SPECULAR) ;
					glCallList(HEDRON_LIST3) ;
				glPopAttrib() ;
			}
			else
				glCallList(HEDRON_LIST) ;

		glPopMatrix() ;
	}

//	if (!blend) glEnable(GL_BLEND) ;
}

// Glass1
void DrawGlass1(GLfloat radius)
{
	int	  i, flag = TRUE, divide = 60 ;

	glTranslatef(0.0f, 0.0f, 2.4f) ;
	glDisable(GL_LIGHTING) ;

//	glDisable(GL_FOG) ;
	glFogfv(GL_FOG_COLOR, black) ;
	for (i = 0 ; i < divide ; i ++)
	{
		GLfloat alpha, rad = -2.0f * PAI / divide * i ;
		alpha = Pow(sin(rad*1.3f), 32.0f + i) ;

		if (alpha <= 0.3f)
		{
			rad = -2.0f * PAI / divide * (i + 1) ;
//			glColor4f(currentGC[0],currentGC[1],currentGC[2], 0.0f) ;
			glColor3f(0.0f, 0.0f, 0.0f) ;
			glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;
			glEnd() ;
			flag = TRUE ;
			continue ;
		}

		if (flag)
		{
			GLfloat pRad = -2.0f * PAI / divide * (i - 1) ;
			flag = FALSE ;
			glBegin(GL_TRIANGLE_FAN) ;
			glVertex3f(0.0f, 0.0f, 0.0f) ;	// 時計文字盤中心座標
//			glColor4f(currentGC[0],currentGC[1],currentGC[2], 0.0f) ;
			glColor3f(0.0f, 0.0f, 0.0f) ;
			glVertex3f(sin(pRad) * radius, cos(pRad) * radius, 0.0f) ;
		}

//		glColor4f(currentGC[0],currentGC[1],currentGC[2], alpha) ;
		glColor3f(currentGC[0]*alpha,currentGC[1]*alpha,currentGC[2]*alpha) ;
		glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;
	}
	if (!flag) glEnd() ;

//	glEnable(GL_FOG) ;
	glFogfv(GL_FOG_COLOR, currentBG) ;

	glEnable(GL_LIGHTING) ;
}

// 表面ガラス描画（使用したポリゴン数を返す）
int DrawGlass(GLint divide, GLfloat radius, GLint light_switch = TRUE)
{
	int	  i, flag = TRUE, n_pols = 0 ;

//	glDisable(GL_FOG) ;
	glFogfv(GL_FOG_COLOR, black) ;

	switch (clock_glass)
	{
	case 0:
		break ;

	case 1:
		glDisable(GL_LIGHTING) ;

		for (i = 0 ; i < divide ; i ++)
		{
			GLfloat alpha, rad = -2.0f * PAI / divide * i ;
			alpha = Pow(sin(rad*1.3f), 32.0f + i) ;

			if (alpha <= 0.3f)
			{
				rad = -2.0f * PAI / divide * (i + 1) ;
				glColor4d(1.0f,1.0f,1.0f, 0.0f) ;
				glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;
				glEnd() ;
				flag = TRUE ;
				continue ;
			}

			if (flag)
			{
				GLfloat pRad = -2.0f * PAI / divide * (i - 1) ;
				flag = FALSE ;
				glBegin(GL_TRIANGLE_FAN) ;
//				glColor4d(1.0f,1.0f,1.0f, 0.0f) ;
				glVertex3f(0.0f, 0.0f, 0.0f) ;	// 時計文字盤中心座標
				glColor4d(1.0f,1.0f,1.0f, 0.0f) ;
				glVertex3f(sin(pRad) * radius, cos(pRad) * radius, 0.0f) ;

				n_pols ++ ;
			}

			glColor4d(1.0f,1.0f,1.0f, alpha) ;
			glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;

			n_pols ++ ;
		}
		if (!flag) glEnd() ;

		glEnable(GL_LIGHTING) ;
		break ;

	case 2:
		glBegin(GL_TRIANGLE_FAN) ;

			if (light_switch) glCallList(MATERIAL_GLASS) ;
//			if (light_switch) glCallList(MATERIAL_GLASS2) ;
			glNormal3f(0.0f, 0.0f, 1.0f) ;	// 中心点法線ベクトル
			glVertex3f(0.0f, 0.0f, 0.0f) ;	// 時計文字盤中心座標

			if (light_switch) glCallList(MATERIAL_GLASS2) ;
/*
			for (i = 0 ; i < divide ; i ++)
			{
				GLfloat rad = -2.0f * PAI / divide * i ;
				glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;
			}
			glVertex3f(0.0f, radius, 0.0f) ;	// 開始点と終了点を連結 
*/
			for (i = 0 ; i <= divide ; i ++)
			{
				GLfloat rad = -2.0f * PAI / divide * i ;
				if (i == divide) rad = 0.0f ;
				GLfloat x = sin(rad), y = cos(rad) ;
				Vector3d norm(x * 0.15f * norm_ratio, y * 0.15f * norm_ratio, 1.0f) ;

				glNormal3fv(norm.Unit().v) ;	// 法線ベクトルは少し外向きに
				glVertex3f(x * radius, y * radius, 0.0f) ;
			}

		glEnd() ;
		if (light_switch) glEnable(GL_LIGHTING) ;

		n_pols = divide ;
		break ;

	case 3:
/*
		glBegin(GL_TRIANGLE_FAN) ;

			if (light_switch) glCallList(MATERIAL_GLASS3) ;
//			if (light_switch) glCallList(MATERIAL_GLASS4) ;
			glNormal3f(0.0f, 0.0f, 1.0f) ;	// 中心点法線ベクトル
			glVertex3f(0.0f, 0.0f, 0.0f) ;	// 時計文字盤中心座標

			if (light_switch) glCallList(MATERIAL_GLASS2) ;
			for (i = 0 ; i <= divide ; i ++)
			{
				GLfloat rad = -2.0f * PAI / divide * i ;
				if (i == divide) rad = 0.0f ;
				GLfloat x = sin(rad), y = cos(rad) ;
				Vector3d norm(x * 0.15f * norm_ratio, y * 0.15f * norm_ratio, 1.0f) ;

				glNormal3fv(norm.Unit().v) ;	// 法線ベクトルは少し外向きに
				glVertex3f(x * radius, y * radius, 0.0f) ;
			}
//			glVertex3f(0.0f, radius, 0.0f) ;	// 開始点と終了点を連結 

		glEnd() ;
		if (light_switch) glEnable(GL_LIGHTING) ;

		n_pols = divide ;
		break ;
*/
		{
			if (light_switch) glCallList(MATERIAL_GLASS4) ;

			RollingObject glass3(divide * (6 - 1)) ;
			glass3.MakeRollingPolygons(divide, 6, glass_v) ;
			glass3.AverageNormals(TRUE, TRUE) ;
			glass3.TopNormal() ;

			glPushAttrib(GL_CULL_FACE) ;
				glDisable(GL_CULL_FACE) ;
				glass3.DrawObject() ;
			glPopAttrib() ;

			if (light_switch) glEnable(GL_LIGHTING) ;

			n_pols = divide * 9 ;
			break ;
		}
	}

//	glEnable(GL_FOG) ;
	glFogfv(GL_FOG_COLOR, currentBG) ;

	return n_pols ;
}


// 秒針だけモーションブラー用のスタートアングルおよびステップ値を計算
void CalcNeedleMotionBlurAngles(ClockState& pre, ClockState& now)
{
	now.start_angle = pre.tm.second ;

	// 今回の角度の方が小さい場合は、１２を通っているため、スタート - 360
//	if (now.tm.second >= start) now.start_angle = pre.tm.second ;
//	else			    now.start_angle = pre.tm.second - 360.0f ;

	now.start_angle = pre.tm.second ;

	// シャッターによってスタート角度を調整
	now.start_angle += (now.tm.second - now.start_angle) * (1.0f - s_shutter) ;
	// ステップ値 = (現在角度 - スタート角度) / (レンダリング回数 - 1 + 1)
	// shutter == 1.0f でも一回分ずらすため
	now.step_angle = (now.tm.second - now.start_angle) / (s_motion) ;
	now.start_angle += now.step_angle ;
}

// 金飾り１つ描画
void DrawGoldenObject(GLfloat x = 1.0f, GLfloat y = 1.0f, GLfloat z = 1.0f, int depth = FALSE, int average = TRUE, int smooth = FALSE)
{
	int      i ;
	Object   gold(4) ;
	GLfloat m[] = {   x, 0.0f, 0.0f, 0.0f,
					 0.0f,   y, 0.0f, 0.0f,
					 0.0f, 0.0f,   z, 0.0f,
					 0.0f, 0.0f, 0.0f, 1.0f } ;

	for (i = 0 ; i < 4 ; i ++) gold.MakePolygon(i, g_o[i][0],g_o[i][1],g_o[i][2], g_v, m) ;

	if (smooth)
	{
		// ポリゴン０の法線
		gold.AverageNormal(0, 0,  0,1,2,3) ;
		gold.AverageNormal(0, 1,  0,2) ;
		gold.AverageNormal(0, 2,  0,1) ;

		// ポリゴン１の法線
		gold.AverageNormal(1, 0,  0,1,2,3) ;
		gold.AverageNormal(1, 1,  0,1) ;
		gold.AverageNormal(1, 2,  1,3) ;

		// ポリゴン２の法線
		gold.AverageNormal(2, 0,  0,1,2,3) ;
		gold.AverageNormal(2, 1,  2,3) ;
		gold.AverageNormal(2, 2,  0,2) ;

		// ポリゴン３の法線
		gold.AverageNormal(3, 0,  0,1,2,3) ;
		gold.AverageNormal(3, 1,  1,3) ;
		gold.AverageNormal(3, 2,  2,3) ;

		gold.DrawTriangles(depth, average) ;
	}
	else
		gold.DrawTriangles(depth, average, TRUE) ;	// フラット指定
}

// 金飾り描画
void DrawGoldenObjects(GLfloat radius, GLfloat div = 6)
{
	int i ;
	for (i = 0 ; i < div ; i ++)
	{
		glPushMatrix() ;
			glRotatef(-360.0f / div * i, 0.0f,0.0f,1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
			glCallList(GOLDEN_OBJECT_LIST) ;
//			DrawGoldenObject(1.1f,1.1f,1.0f, gold_depth, TRUE, texture) ;
		glPopMatrix() ;
	}
}


// カラーで変調した時計描画（シェーディングなし）
void DrawModulateClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
	glColor3f(currentCL[0], currentCL[1], currentCL[2]*0.8f) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
	glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
	glColor3f(currentCL[0], currentCL[1]*0.8f, currentCL[2]*0.8f) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glColor3f(currentCL[0]*0.6f, currentCL[1]*0.2f, currentCL[2]) ;	// MATERIAL_MAT_METAL_BLUE 色セット
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glColor3f(currentCL[0]*0.2f, currentCL[1] * 0.8f, currentCL[2]*0.3f) ;	// MATERIAL_MAT_METAL_GREEN 色セット
		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;//, center_angle ;

			glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

				// アルファ値を考慮した MATERIAL_MAT_GOLD 色セット
				glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, 1.0f / s_motion * S_MOTION_ALPHA) ;

				for (int i = 0 ; i < s_motion - 1; i ++, sec_angle += st.step_angle)
				{
					// 中央の位置を記憶しておき、最後に普通に描画する（半透明を避けるため）
//					if (i == (s_motion + 1) / 2)
//					{
//						center_angle = sec_angle ;
//						continue ;
//					}
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}
			glPopAttrib() ;
#ifdef WIN32 // FX_GL_BETA_2
			glBlendFunc(GL_ONE, GL_ONE) ;
#endif

			// 秒針モーションブラー実行時も、中央の一回だけは素でレンダリング
//			glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
//			glPushMatrix() ;
//				glRotatef(center_angle, 0.0f,0.0f,-1.0f) ;
//				glCallList(ENV_SECOND_LIST) ;
//			glPopMatrix() ;

			// 最後の１回は素でレンダリング
			glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
			glPushMatrix() ;
				glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}
		else
		{
			glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}

		// 表面ガラス描画
		if (clock_glass)
		{
			glBlendFunc(GL_ONE, GL_ONE) ;
			switch (env)
			{
			case 0:
				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;

//				if (clock_glass == 2) glColor3f(currentCL[0] * 0.4f, currentCL[1] * 0.4f, currentCL[2] * 0.4f) ;
//				else                  glColor3f(currentCL[0] * 0.2f, currentCL[1] * 0.2f, currentCL[2] * 0.2f) ;
				glColor3f(currentCL[0] * 0.4f, currentCL[1] * 0.4f, currentCL[2] * 0.4f) ;

				glCallList(ENV_GLASS_LIST) ;

				glDisable(GL_BLEND) ;
				glDepthMask(GL_TRUE) ;

				break ;

			case 1:
				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;

				glMatrixMode(GL_TEXTURE) ;
				glPushMatrix() ;
					glCallList(ENV_GLASS_TEXTURE_LIST) ;

					glMatrixMode(GL_MODELVIEW) ;
//					if (clock_glass == 2) glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
//					else                  glColor3f(currentCL[0]*0.4f, currentCL[1]*0.4f, currentCL[2]*0.4f) ;
					glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
					glCallList(ENV_GLASS_LIST) ;

					glMatrixMode(GL_TEXTURE) ;
				glPopMatrix() ;
				glMatrixMode(GL_MODELVIEW) ;

				glDisable(GL_BLEND) ;
				glDepthMask(GL_TRUE) ;

				break ;

			default:	// env == 2 の時
//				if (clock_glass == 2) glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
//				else                  glColor3f(currentCL[0]*0.4f, currentCL[1]*0.4f, currentCL[2]*0.4f) ;
				glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
				glCallList(ENV_GLASS_LIST) ;
				break ;
			}

		}
		else
			glDepthMask(GL_TRUE) ;

	glPopMatrix() ;
}


// オーバサンプリング付きカラーで変調した時計描画（シェーディングなし）
void DrawModulateClockWithOverSampling(ClockState& st, GLfloat alpha_weight = 1.0f)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glColor4f(currentCL[0], currentCL[1], currentCL[2]*0.8f, alpha_weight) ;
//			glColor4f(currentCL[0]*0.9, currentCL[1]*0.9, currentCL[2]*0.9, alpha_weight) ;
			glCallList(ENV_ROOF_OVER_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
//	glColor4f(currentCL[0], currentCL[1], currentCL[2]*0.8f, alpha_weight) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
	glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, alpha_weight) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
	glColor4f(currentCL[0], currentCL[1]*0.8f, currentCL[2]*0.8f, alpha_weight) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawMirrorHedronsWithOverSampling(radius_ratio * HDRN_RADIUS, st.h_rotate, alpha_weight) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glColor4f(currentCL[0]*0.6f, currentCL[1]*0.2f, currentCL[2], alpha_weight) ;	// MATERIAL_MAT_METAL_BLUE 色セット
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glColor4f(currentCL[0]*0.2f, currentCL[1] * 0.8f, currentCL[2]*0.3f, alpha_weight) ;	// MATERIAL_MAT_METAL_GREEN 色セット
		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, alpha_weight) ;	// MATERIAL_MAT_GOLD 色セット
		glPushMatrix() ;
			glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_SECOND_LIST) ;
		glPopMatrix() ;

		// 表面ガラス描画
		if (clock_glass)
		{
			glEnable(GL_BLEND) ;
			glBlendFunc(GL_ONE, GL_ONE) ;
			switch (env)
			{
			case 0:
//				if (clock_glass == 2) glColor3f(currentCL[0] * 0.4f * alpha_weight, currentCL[1] * 0.4f * alpha_weight, currentCL[2] * 0.4f * alpha_weight) ;
//				else                  glColor3f(currentCL[0] * 0.2f * alpha_weight, currentCL[1] * 0.2f * alpha_weight, currentCL[2] * 0.2f * alpha_weight) ;
				glColor3f(currentCL[0] * 0.4f * alpha_weight, currentCL[1] * 0.4f * alpha_weight, currentCL[2] * 0.4f * alpha_weight) ;
				glCallList(ENV_GLASS_LIST) ;

				break ;

			case 1:
				glMatrixMode(GL_TEXTURE) ;
				glPushMatrix() ;
					glCallList(ENV_GLASS_TEXTURE_LIST) ;

					glMatrixMode(GL_MODELVIEW) ;
//					if (clock_glass == 2) glColor3f(currentCL[0]*0.6f * alpha_weight, currentCL[1]*0.6f * alpha_weight, currentCL[2]*0.6f * alpha_weight) ;
//					else                  glColor3f(currentCL[0]*0.3f * alpha_weight, currentCL[1]*0.3f * alpha_weight, currentCL[2]*0.3f * alpha_weight) ;
					glColor3f(currentCL[0]*0.6f * alpha_weight, currentCL[1]*0.6f * alpha_weight, currentCL[2]*0.6f * alpha_weight) ;
					glCallList(ENV_GLASS_LIST) ;

					glMatrixMode(GL_TEXTURE) ;
				glPopMatrix() ;
				glMatrixMode(GL_MODELVIEW) ;

				break ;

			default:	// env == 2 の時
//				if (clock_glass == 2) glColor3f(currentCL[0]*0.6f * alpha_weight, currentCL[1]*0.6f * alpha_weight, currentCL[2]*0.6f * alpha_weight) ;
//				else                  glColor3f(currentCL[0]*0.3f * alpha_weight, currentCL[1]*0.3f * alpha_weight, currentCL[2]*0.3f * alpha_weight) ;
				glColor3f(currentCL[0]*0.6f * alpha_weight, currentCL[1]*0.6f * alpha_weight, currentCL[2]*0.6f * alpha_weight) ;
				glCallList(ENV_GLASS_LIST) ;
				break ;
			}
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
		}

	glPopMatrix() ;
}


// -e 3 の一回目の描画
void DrawMirrorClock2(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		// MATERIAL_GOLD 色セット
//		glColor3f(currentCL[0]*0.5f, currentCL[1]*0.45f, currentCL[2]*0.03f) ;
		glColor3f(currentCL[0]*0.3f*1.0f, currentCL[1]*0.3f*0.75f, currentCL[2]*0.3*0.05f) ;

		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
	glColor3f(currentCL[0]*0.5f, currentCL[1]*0.5f, currentCL[2]*0.4f) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
//	glColor3f(currentCL[0], currentCL[1]*0.9f, currentCL[2]*0.05f) ;
	glColor3f(currentCL[0]*0.7f*1.0f, currentCL[1]*0.7f*0.75f, currentCL[2]*0.7f*0.05f) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
	glColor3f(currentCL[0]*0.8f, currentCL[1]*0.5f, currentCL[2]*0.5f) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glColor3f(currentCL[0]*0.5f, currentCL[1]*0.1f, currentCL[2]) ;	// MATERIAL_MAT_METAL_BLUE 色セット
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glColor3f(currentCL[0]*0.1f, currentCL[1]*0.6f,  currentCL[2]*0.2f) ;	// MATERIAL_MAT_METAL_GREEN 色セット
		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ; //, center_angle ;

			glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
				glEnable(GL_BLEND) ;
//				glDisable(GL_DEPTH_TEST) ;
				glDepthMask(GL_FALSE) ;
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

				// アルファ値を考慮した MATERIAL_MAT_GOLD 色セット
				glColor4f(currentCL[0]*1.0f, currentCL[1]*0.75f, currentCL[2]*0.05f, 1.0f / s_motion * S_MOTION_ALPHA) ;

				for (int i = 0 ; i < s_motion - 1 ; i ++, sec_angle += st.step_angle)
				{
//					// 中央の位置を記憶しておき、最後に普通に描画する（半透明を避けるため）
//					if (i == (s_motion + 1) / 2)
//					{
//						center_angle = sec_angle ;
//						continue ;
//					}
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}
			glPopAttrib() ;

//			// 秒針モーションブラー実行時も、中央の一回だけは素でレンダリング
//			glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
//			glPushMatrix() ;
//				glRotatef(center_angle, 0.0f,0.0f,-1.0f) ;
//				glCallList(ENV_SECOND_LIST) ;
//			glPopMatrix() ;

			glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
			glPushMatrix() ;
				glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}
		else
		{
			glColor3f(currentCL[0]*1.0f, currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}

/*
		// 表面ガラス描画
		if (clock_glass)
		{
			glEnable(GL_BLEND) ;
			glDepthMask(GL_FALSE) ;

			glColor3f(currentCL[0] * 0.4f, currentCL[1] * 0.4f, currentCL[2] * 0.4f) ;
			glCallList(ENV_GLASS_LIST) ;

			glDisable(GL_BLEND) ;
			glDepthMask(GL_TRUE) ;
		}
*/

	glPopMatrix() ;
}

// オーバサンプリング付き水晶時計描画（ステータスで）
void DrawCrystalClockWithOverSampling(ClockState& st)
{
	// アンティエイリアシング・モーションブラー用に色変化
	float color_weight = 1.0f ;
/*
	if (anti)
	{
		if (motion)
			color_weight = 1.0f / (motion * anti) ;
		else
			color_weight = 1.0f / anti ;
	}
	else if (motion)
		color_weight = 1.0f / motion ;
*/
	if (anti)
		color_weight = 1.0f / anti ;
	else
		color_weight = 1.0f / motion ;

	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glColor4f(currentCL[0]*0.75f * color_weight, currentCL[1]*0.75f * color_weight, currentCL[2]*0.75f * color_weight, crystal_a) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
	glColor4f(currentCL[0] * color_weight, currentCL[1] * color_weight, currentCL[2] * 0.8f * color_weight, crystal_a) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
	glColor4f(currentCL[0] * color_weight, currentCL[1]*0.6f * color_weight, currentCL[2]*0.15f * color_weight, crystal_a) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
	glColor4f(currentCL[0]*0.8f * color_weight, currentCL[1]*0.6f * color_weight, currentCL[2]*0.6f * color_weight, crystal_a) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawCrystalHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate, color_weight) ;
//		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glColor4f(currentCL[0]*0.75f * color_weight, currentCL[1]*0.2f * color_weight, currentCL[2] * color_weight, crystal_a) ;	// MATERIAL_MAT_METAL_BLUE 色セット
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glColor4f(currentCL[0]*0.2f * color_weight, currentCL[1] * color_weight, currentCL[2]*0.3f * color_weight, crystal_a) ;	// MATERIAL_MAT_METAL_GREEN 色セット
		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		glColor4f(currentCL[0] * color_weight, currentCL[1]*0.75f * color_weight, currentCL[2]*0.05f * color_weight, crystal_a) ;	// MATERIAL_MAT_GOLD 色セット
		glPushMatrix() ;
			glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_SECOND_LIST) ;
		glPopMatrix() ;

		// ブレンドの仕方を変更
		if (crystal == 2) glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;

		// 表面ガラス描画
		if (clock_glass)
		{
/*
			glEnable(GL_LIGHTING) ;
			glCallList(GLASS_LIST) ;
			glDisable(GL_LIGHTING) ;
*/
			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(ENV_GLASS_TEXTURE_LIST) ;

				glMatrixMode(GL_MODELVIEW) ;
//				if (clock_glass == 2) glColor3f(currentCL[0]*0.6f * color_weight, currentCL[1]*0.6f * color_weight, currentCL[2]*0.6f * color_weight) ;
//				else                  glColor3f(currentCL[0]*0.3f * color_weight, currentCL[1]*0.3f * color_weight, currentCL[2]*0.3f * color_weight) ;
				glColor3f(currentCL[0]*0.6f * color_weight, currentCL[1]*0.6f * color_weight, currentCL[2]*0.6f * color_weight) ;
				glCallList(ENV_GLASS_LIST) ;

				glMatrixMode(GL_TEXTURE) ;
			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;
		}

	glPopMatrix() ;
}

// 水晶時計描画（ステータスで）
void DrawCrystalClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glColor4f(currentCL[0]*0.75f, currentCL[1]*0.75f, currentCL[2]*0.75f, crystal_a) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
	glColor4f(currentCL[0], currentCL[1], currentCL[2] * 0.8f, crystal_a) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
	glColor4f(currentCL[0], currentCL[1]*0.6f, currentCL[2]*0.15f, crystal_a) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
	glColor4f(currentCL[0]*0.8f, currentCL[1]*0.6f, currentCL[2]*0.6f, crystal_a) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawCrystalHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
//		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glColor4f(currentCL[0]*0.75f, currentCL[1]*0.2f, currentCL[2], crystal_a) ;	// MATERIAL_MAT_METAL_BLUE 色セット
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glColor4f(currentCL[0]*0.2f, currentCL[1], currentCL[2]*0.3f, crystal_a) ;	// MATERIAL_MAT_METAL_GREEN 色セット
		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;

			for (int i = 0 ; i < s_motion ; i ++, sec_angle += st.step_angle)
			{
				// アルファ？を考慮した MATERIAL_MAT_GOLD 色セット
				glColor4f(currentCL[0]/s_motion, currentCL[1]*0.75f/s_motion, currentCL[2]*0.05f/s_motion, crystal_a) ;
				glPushMatrix() ;
					glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
					glCallList(ENV_SECOND_LIST) ;
				glPopMatrix() ;
			}
		}
		else
		{
			glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, crystal_a) ;	// MATERIAL_MAT_GOLD 色セット
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}
		// ブレンドの仕方を変更
		if (crystal == 2) glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;

		// 表面ガラス描画
		if (clock_glass)
		{
/*
			glEnable(GL_LIGHTING) ;
			glCallList(GLASS_LIST) ;
			glDisable(GL_LIGHTING) ;
*/
			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(ENV_GLASS_TEXTURE_LIST) ;

				glMatrixMode(GL_MODELVIEW) ;
//				if (clock_glass == 2) glColor3f(currentCL[0]*0.6f, currentCL[1]*0.6f, currentCL[2]*0.6f) ;
//				else                  glColor3f(currentCL[0]*0.3f, currentCL[1]*0.3f, currentCL[2]*0.3f) ;
				glColor3f(currentCL[0]*0.6f, currentCL[1]*0.6f, currentCL[2]*0.6f) ;
				glCallList(ENV_GLASS_LIST) ;

				glMatrixMode(GL_TEXTURE) ;
			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;
		}

	glPopMatrix() ;
}

// ソリッドテクスチャの上から、ハイライトを重ねる
void DrawSpecularClock(ClockState& st)
{
#ifdef GL_VERSION_1_1
	if (polygon_offset) glEnable(GL_POLYGON_OFFSET_FILL) ;
#endif

	glEnable(GL_BLEND) ;
	glDepthMask(GL_FALSE) ;

	glCallList(MATERIAL_SPECULAR) ;

	glDisable(GL_CULL_FACE) ;
	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
//			glCallList(ROOF_LIST) ;	// Roofだけはハイライト色をグラデーション
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
//	glCallList(MATERIAL_MAT_SPECULAR) ;
	glCallList(ENV_SHELL_LIST) ;

	// MATERIAL_GOLD 色セット
//	glCallList(MATERIAL_SPECULAR) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;

	// MATERIAL_RED_GRAY 色セット
//	glCallList(MATERIAL_MAT_SPECULAR) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
//		glCallList(MATERIAL_SPECULAR) ;
		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
//		glCallList(MATERIAL_MAT_SPECULAR) ;

		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

/* うーん、これは無い方が良いかなぁ...
		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;

			glPushAttrib(GL_LIGHTING_BIT) ;
				glCallList(MATERIAL_SEC_SPECULAR) ;

				for (int i = 0 ; i < s_motion ; i ++, sec_angle += st.step_angle)
				{
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}
			glPopAttrib() ;
		}
		// 秒針モーションブラー実行時も、最後の一回だけは素でレンダリング は、なし！
		else
		{
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(ENV_SECOND_LIST) ;
			glPopMatrix() ;
		}
*/
		glPushMatrix() ;
			glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_SECOND_LIST) ;
		glPopMatrix() ;

#ifdef GL_VERSION_1_1
		if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
#endif

		// 表面ガラス描画
		if (clock_glass) glCallList(GLASS_LIST) ;

	glPopMatrix() ;

	glDisable(GL_BLEND) ;
	glDepthMask(GL_TRUE) ;
}


void DrawEnvSpecularModulateChrome(ClockState& st)
{
	glFogfv(GL_FOG_COLOR, currentBG) ;

	// 金飾り描画
	glDisable(GL_BLEND) ;
	glMatrixMode(GL_TEXTURE) ;
	glPushMatrix() ;
		glCallList(CHROME_TEXTURE_LIST) ;
		glMatrixMode(GL_MODELVIEW) ;

		// MATERIAL_GOLD 色セット
		glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;
		glCallList(ENV_GOLDEN_OBJECTS_LIST) ;
//		DrawGoldenObjects(14.6f, n_golden) ;

		glMatrixMode(GL_TEXTURE) ;
	glPopMatrix() ;
	glMatrixMode(GL_MODELVIEW) ;
	glEnable(GL_BLEND) ;

	if (!reflection)	// 反射なし時
	{
		glColor3f(currentCL[0]*0.5f, currentCL[1]*0.5f, currentCL[2]*0.5f) ;
		glFogfv(GL_FOG_COLOR, black) ;
		glCallList(ENV_BOARD_LIST) ;
		glFogfv(GL_FOG_COLOR, currentBG) ;

		glPushMatrix() ;

			glDisable(GL_BLEND) ;
			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(CHROME_TEXTURE_LIST) ;
				glMatrixMode(GL_MODELVIEW) ;

				// １２個の球描画
				glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
				DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
				glShadeModel(GL_SMOOTH) ;

				// 時計針描画
				glDepthMask(GL_TRUE) ;

				glColor3f(currentCL[0]*0.6f, currentCL[1]*0.1f, currentCL[2]) ;	// MATERIAL_MAT_METAL_BLUE 色セット
				glPushMatrix() ;
					glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
					glCallList(ENV_HOUR_LIST) ;
				glPopMatrix() ;

				glColor3f(currentCL[0]*0.2f, currentCL[1]*0.8f, currentCL[2]*0.3f) ;	// MATERIAL_MAT_METAL_GREEN 色セット
				glPushMatrix() ;
					glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
					glCallList(ENV_MINUTE_LIST) ;
				glPopMatrix() ;

				if (s_motion && !motion)
				{
					// 秒針だけモーションブラーの処理
					GLfloat sec_angle = st.start_angle ;//, center_angle ;

					glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
						glEnable(GL_BLEND) ;
						glDepthMask(GL_FALSE) ;
						glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

						// アルファ値を考慮した MATERIAL_MAT_GOLD 色セット
						glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, 1.0f / s_motion * S_MOTION_ALPHA) ;

						for (int i = 0 ; i < s_motion - 1 ; i ++, sec_angle += st.step_angle)
						{
							// 中央の位置を記憶しておき、最後に普通に描画する（半透明を避けるため）
//							if (i == (s_motion + 1) / 2)
//							{
//								center_angle = sec_angle ;
//								continue ;
//							}
							glPushMatrix() ;
								glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
								glCallList(ENV_SECOND_LIST) ;
							glPopMatrix() ;
						}
					glPopAttrib() ;
#ifdef WIN32 // FX_GL_BETA_2
					glBlendFunc(GL_ONE, GL_ONE) ;
#endif

					// 秒針モーションブラー実行時も、中央の一回だけは素でレンダリング
//					glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
//					glPushMatrix() ;
//						glRotatef(center_angle, 0.0f,0.0f,-1.0f) ;
//						glCallList(ENV_SECOND_LIST) ;
//					glPopMatrix() ;
					glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}
				else
				{
					glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
					glPushMatrix() ;
						glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}

				glMatrixMode(GL_TEXTURE) ;

			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;

			glDepthMask(GL_FALSE) ;
			glEnable(GL_BLEND) ;

			// 表面ガラス描画
			if (clock_glass)
			{
//				if (clock_glass == 2) glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
//				else                  glColor3f(currentCL[0]*0.4f, currentCL[1]*0.4f, currentCL[2]*0.4f) ;
				glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
				glCallList(ENV_GLASS_LIST) ;
			}

		glPopMatrix() ;
	}
	else	// -reflect オプション指定時
	{
		glColor4f(currentCL[0]*0.5f, currentCL[1]*0.5f, currentCL[2]*0.5f, 0.2f) ;
		glPushMatrix() ;
			glTranslatef(0.0f, 0.0f, -3.8f) ;
			glFogfv(GL_FOG_COLOR, black) ;
			glCallList(ENV_BOARD_LIST) ;
			glFogfv(GL_FOG_COLOR, currentBG) ;
		glPopMatrix() ;

		// 映り込み部分描画
		if (envOpenGL != VOODOO_MESA)
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
		else
		// 3Dfx Mesa では、テクスチャ時に上のファクタは使用できない
			glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE_MINUS_SRC_COLOR) ;

		glEnable(GL_BLEND) ;

		glPushMatrix() ;
			glScalef(1.0f, 1.0f, -1.0f) ;
			glFrontFace(GL_CW) ;

			glPushMatrix() ;


			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(CHROME_TEXTURE_LIST) ;
				glMatrixMode(GL_MODELVIEW) ;


//				glColor4f(currentCL[0], currentCL[1]*0.2f, currentCL[2]*0.2f) ;
				glFogfv(GL_FOG_COLOR, black) ;
				glCallList(ENV_BOARD_DETAIL_LIST) ;
				glFogfv(GL_FOG_COLOR, currentBG) ;

				// １２個の球描画
				glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
				DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
				glShadeModel(GL_SMOOTH) ;

				glPushMatrix() ;
					glScalef(1.0f, 1.0f, -1.0f) ;
					glFrontFace(GL_CCW) ;

					// 時計針描画
					glDepthMask(GL_TRUE) ;

					glColor4f(currentCL[0]*0.6f, currentCL[1]*0.2f, currentCL[2], 0.4f) ;	// MATERIAL_MAT_METAL_BLUE 色セット
					glPushMatrix() ;
						glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_MIRROR_HOUR_LIST) ;
					glPopMatrix() ;

					glColor4f(currentCL[0]*0.2f, currentCL[1]*0.8f, currentCL[2]*0.3f, 0.35f) ;	// MATERIAL_MAT_METAL_GREEN 色セット
					glPushMatrix() ;
						glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_MIRROR_MINUTE_LIST) ;
					glPopMatrix() ;

					if (s_motion && !motion)
					{
						// 秒針だけモーションブラーの処理
						GLfloat sec_angle = st.start_angle ;

						glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
							glEnable(GL_BLEND) ;
							glDepthMask(GL_FALSE) ;
							glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

							// アルファ値を考慮した MATERIAL_MAT_GOLD 色セット
							glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, 0.3f / s_motion * S_MOTION_ALPHA) ;

							for (int i = 0 ; i < s_motion ; i ++, sec_angle += st.step_angle)
							{
								glPushMatrix() ;
									glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
									glCallList(ENV_MIRROR_SECOND_LIST) ;
								glPopMatrix() ;
							}
						glPopAttrib() ;
//#ifdef WIN32 // FX_GL_BETA_2
//						glBlendFunc(GL_ONE, GL_ONE) ;
//#endif
					}
					else
					{
						glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, 0.3f) ;	// MATERIAL_MAT_GOLD 色セット
						glPushMatrix() ;
							glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
							glCallList(ENV_MIRROR_SECOND_LIST) ;
						glPopMatrix() ;
					}

					glDepthMask(GL_FALSE) ;
					glFrontFace(GL_CW) ;
				glPopMatrix() ;


				glMatrixMode(GL_TEXTURE) ;

			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;



			glPopMatrix() ;

			glBlendFunc(GL_ONE, GL_ONE) ;//glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE) ;
//			glColor3f(currentCL[0], currentCL[1], currentCL[2]) ;
			glColor3f(currentCL[0]*0.4f, currentCL[1]*0.4f, currentCL[2]*0.4f) ;

			glFogfv(GL_FOG_COLOR, black) ;
			glCallList(ENV_MIRROR_WALL_LIST) ;

			glFrontFace(GL_CCW) ;
		glPopMatrix() ;

//		glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;
		// 映り込み部分描画終了

		// 本体描画
		glPushMatrix() ;
//			glCallList(BOARD_DETAIL_LIST) ;
			glCallList(ENV_BOARD_DETAIL_LIST) ;
			glFogfv(GL_FOG_COLOR, currentBG) ;
		glPushMatrix() ;

			glPushMatrix() ;

				// 時計針描画
				glDepthMask(GL_TRUE) ;
				glDisable(GL_BLEND) ;


			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(CHROME_TEXTURE_LIST) ;
				glMatrixMode(GL_MODELVIEW) ;



				// １２個の球描画
				glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
				DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
				glShadeModel(GL_SMOOTH) ;

				glColor3f(currentCL[0]*0.6f, currentCL[1]*0.2f, currentCL[2]) ;	// MATERIAL_MAT_METAL_BLUE 色セット
				glPushMatrix() ;
					glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
					glCallList(ENV_HOUR_LIST) ;
				glPopMatrix() ;

				glColor3f(currentCL[0]*0.2f, currentCL[1]*0.8f, currentCL[2]*0.3f) ;	// MATERIAL_MAT_METAL_GREEN 色セット
				glPushMatrix() ;
					glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
					glCallList(ENV_MINUTE_LIST) ;
				glPopMatrix() ;

				glColor3f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f) ;	// MATERIAL_MAT_GOLD 色セット
				if (s_motion && !motion)
				{
					// 秒針だけモーションブラーの処理
					GLfloat sec_angle = st.start_angle ; //, center_angle ;

					glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
						glEnable(GL_BLEND) ;
						glDepthMask(GL_FALSE) ;
						glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

						// アルファ値を考慮した MATERIAL_MAT_GOLD 色セット
						glColor4f(currentCL[0], currentCL[1]*0.75f, currentCL[2]*0.05f, 1.0f / s_motion * S_MOTION_ALPHA) ;

						for (int i = 0 ; i < s_motion - 1 ; i ++, sec_angle += st.step_angle)
						{
//							// 中央の位置を記憶しておき、最後に普通に描画する（半透明を避けるため）
//							if (i == (s_motion + 1) / 2)
//							{
//								center_angle = sec_angle ;
//								continue ;
//							}
							glPushMatrix() ;
								glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
								glCallList(ENV_SECOND_LIST) ;
							glPopMatrix() ;
						}
					glPopAttrib() ;
#ifdef WIN32 // FX_GL_BETA_2
					glBlendFunc(GL_ONE, GL_ONE) ;
#endif

					// 秒針モーションブラー実行時も、中央の一回だけは素でレンダリング
//					glPushMatrix() ;
//						glRotatef(center_angle, 0.0f,0.0f,-1.0f) ;
//						glCallList(ENV_SECOND_LIST) ;
//					glPopMatrix() ;
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}
				else
				{
					glPushMatrix() ;
						glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
						glCallList(ENV_SECOND_LIST) ;
					glPopMatrix() ;
				}

				glMatrixMode(GL_TEXTURE) ;

			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;

			glFogfv(GL_FOG_COLOR, black) ;

				glDepthMask(GL_FALSE) ;
				glEnable(GL_BLEND) ;

#ifdef GL_VERSION_1_1
				if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
#endif

				// 表面ガラス描画
				if (clock_glass)
				{
//					if (clock_glass == 2) glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
//					else                  glColor3f(currentCL[0]*0.4f, currentCL[1]*0.4f, currentCL[2]*0.4f) ;
					glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
					glCallList(ENV_GLASS_LIST) ;
				}

			glPopMatrix() ;

		glPopMatrix() ;
		glPopMatrix() ;

		glPopMatrix() ;
	}

	glDisable(GL_BLEND) ;
	glDepthMask(GL_TRUE) ;
}


// ソリッドテクスチャの上から、環境マッピングハイライトを重ねる（real オプション）
void DrawEnvSpecularModulateClock(ClockState& st)
{
#ifdef GL_VERSION_1_1
	if (polygon_offset) glEnable(GL_POLYGON_OFFSET_FILL) ;
#endif

	glEnable(GL_BLEND) ;
	glDepthMask(GL_FALSE) ;

	glDisable(GL_CULL_FACE) ;

	// スペキュラーは光源の色
	glColor3f(currentCL[0]*spec*0.7f, currentCL[1]*spec*0.7f, currentCL[2]*spec*0.7f) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

/*
	// スペキュラーは光源の色
	if (reality == 1) glColor3f(currentCL[0]*0.8f, currentCL[1]*0.8f, currentCL[2]*0.8f) ;
	else              glColor3f(currentCL[0]*0.5f, currentCL[1]*0.5f, currentCL[2]*0.5f) ;
*/
	// スペキュラーは光源の色
//	glColor3f(currentCL[0]*spec*0.7f, currentCL[1]*spec*0.7f, currentCL[2]*spec*0.7f) ;
	glCallList(ENV_SHELL_LIST) ;

#ifdef GL_VERSION_1_1
	if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
#endif

	DrawEnvSpecularModulateChrome(st) ;
}


// 環境マッピングの上から、シェーディングを重ねる
void DrawShadeWrapClock(ClockState& st)
{
#ifdef GL_VERSION_1_1
	if (polygon_offset) glEnable(GL_POLYGON_OFFSET_FILL) ;
#endif

	glDisable(GL_CULL_FACE) ;
	glEnable(GL_BLEND) ;
	glDepthMask(GL_FALSE) ;

	if (!lid)
	{
		glPushMatrix() ;

			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ROOF_LIST) ;

		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	glCallList(SHELL_LIST) ;
	glCallList(BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(HOUR_LIST) ;
		glPopMatrix() ;

		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(MINUTE_LIST) ;
		glPopMatrix() ;

		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;
			for (int i = 0 ; i < s_motion ; i ++, sec_angle += st.step_angle)
			{
				glPushMatrix() ;
					glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
					glCallList(SECOND_E3_LIST) ;
				glPopMatrix() ;
			}
		}
		// 秒針モーションブラー実行時も、最後の一回だけは素でレンダリング は、なし！
		else
		{
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(SECOND_LIST) ;
			glPopMatrix() ;
		}

#ifdef GL_VERSION_1_1
		if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
#endif

		// 表面ガラス描画
		if (clock_glass)
		{
			glEnable(GL_TEXTURE_2D) ;
			glDisable(GL_LIGHTING) ;
			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(ENV_GLASS_TEXTURE_LIST) ;

				glMatrixMode(GL_MODELVIEW) ;
				glColor3f(currentCL[0]*0.6f, currentCL[1]*0.6f, currentCL[2]*0.6f) ;
				glCallList(ENV_GLASS_LIST) ;

				glMatrixMode(GL_TEXTURE) ;
			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;
		}

	glPopMatrix() ;

	glDisable(GL_BLEND) ;
	glDepthMask(GL_TRUE) ;

//	if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
}


// 時計描画（ステータスで）
void DrawStandardClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;

			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ROOF_LIST) ;

		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	glCallList(SHELL_LIST) ;
	glCallList(BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動

		DrawHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;
		glShadeModel(GL_SMOOTH) ;

		// 時計針描画
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(HOUR_LIST) ;
		glPopMatrix() ;

		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(MINUTE_LIST) ;
		glPopMatrix() ;

		if (s_motion && !motion)
		{
			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;//, center_angle ;

			glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
				glEnable(GL_BLEND) ;
//				glDisable(GL_DEPTH_TEST) ;
				glDepthMask(GL_FALSE) ;
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

				for (int i = 0 ; i < s_motion - 1; i ++, sec_angle += st.step_angle)
				{
//					// 中央の位置を記憶しておき、最後に普通に描画する（半透明を避けるため）
//					if (i == (s_motion + 1) / 2)
//					{
//						center_angle = sec_angle ;
//						continue ;
//					}
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(SECOND_LIST) ;
					glPopMatrix() ;
				}
			glPopAttrib() ;

#if defined WIN32 // FX_GL_BETA_2 || defined FX_GL_ALPHA
			glBlendFunc(GL_ONE, GL_ONE) ;
#endif
			// 秒針モーションブラー実行時も、中央の一回だけは素でレンダリング
//			glPushMatrix() ;
//				glRotatef(center_angle, 0.0f,0.0f,-1.0f) ;
//				glCallList(SECOND_LIST) ;
//			glPopMatrix() ;
			glPushMatrix() ;
				glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
				glCallList(SECOND_LIST) ;
			glPopMatrix() ;

/*

			// 秒針だけモーションブラーの処理
			GLfloat sec_angle = st.start_angle ;

			glPushAttrib(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;
				glEnable(GL_BLEND) ;
//				glDisable(GL_DEPTH_TEST) ;
				glDepthMask(GL_FALSE) ;
				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;

				for (int i = 0 ; i < s_motion - 1 ; i ++, sec_angle += st.step_angle)
				{
					glPushMatrix() ;
						glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
						glCallList(SECOND_LIST) ;
					glPopMatrix() ;
				}
			glPopAttrib() ;

#if defined WIN32 // FX_GL_BETA_2 || defined FX_GL_ALPHA
			glBlendFunc(GL_ONE, GL_ONE) ;
#endif
			// 秒針モーションブラー実行時も、最後の一回だけは素でレンダリング
			glPushMatrix() ;
				glRotatef(sec_angle, 0.0f,0.0f,-1.0f) ;
				glCallList(SECOND_LIST) ;
			glPopMatrix() ;
*/
		}
		else
		{
			glPushMatrix() ;
				glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
				glCallList(SECOND_LIST) ;
			glPopMatrix() ;
		}

		// 表面ガラス描画
		if (clock_glass && !(solid && texture == 3))
		{
			if (solid)	// -t 2 で、-so の時
			{
				glDisable(GL_TEXTURE_2D) ;

				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;

				glCallList(GLASS_LIST) ;

				glDisable(GL_BLEND) ;
				glDepthMask(GL_TRUE) ;

				glEnable(GL_TEXTURE_2D) ;
			}
			else
			{
				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;

				if (clock_glass == 1)
				{
					glRotatef(st.g_spin, 0.0f,0.0f,1.0f) ;

					if ((timeData.n_second == 42 && timeData.p_second != timeData.n_second) || start)
					{
						//jun
						//glDeleteLists doesn't work at BeOS.
						//glDeleteLists(GLASS_LIST, 1) ;
						
						glNewList(GLASS_LIST, GL_COMPILE_AND_EXECUTE) ;

						DrawGlass1(14.4f) ;		// １分毎にリスト再定義
						glEndList() ;
					}
					else
						glCallList(GLASS_LIST) ;
				}
				else
					glCallList(GLASS_LIST) ;

				glDisable(GL_BLEND) ;
				glDepthMask(GL_TRUE) ;
			}
		}

	glPopMatrix() ;
}


// Zバッファ描画用
void DrawDepthClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;
			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;
		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	glCallList(ENV_SHELL_LIST) ;
	glCallList(ENV_GOLDEN_OBJECTS_LIST) ;
	glCallList(ENV_BOARD_LIST) ;

	glPushMatrix() ;

		// １２個の球描画
		glTranslatef(0.0f, 0.0f, 1.2f) ;	// 球体を手前に移動
		DrawMirrorHedrons(radius_ratio * HDRN_RADIUS, st.h_rotate) ;

		// 時計針描画
		glPushMatrix() ;
			glRotatef(st.tm.hour, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_HOUR_LIST) ;
		glPopMatrix() ;

		glPushMatrix() ;
			glRotatef(st.tm.minute, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_MINUTE_LIST) ;
		glPopMatrix() ;

		glPushMatrix() ;
			glRotatef(st.tm.second, 0.0f,0.0f,-1.0f) ;
			glCallList(ENV_SECOND_LIST) ;
		glPopMatrix() ;

	glPopMatrix() ;
}


// 時計描画（-real 1 オプションの一回目の描画）
void DrawSolidModulateClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;

			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ENV_ROOF_LIST) ;

		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	// MATERIAL_MAT_IRON 色セット
	glColor3f(currentCL[0], currentCL[1], currentCL[2]*0.8f) ;
	glCallList(ENV_SHELL_LIST) ;

	if (!reflection)	// 反射なし時
	{
		glMatrixMode(GL_TEXTURE) ;
		// MATERIAL_RED_GRAY 色セット
		glColor4f(currentCL[0]*1.0f, currentCL[1]*0.7f, currentCL[2]*0.7f, 0.2f) ;
		glPushMatrix() ;
			glCallList(SOLID2_TEXTURE_LIST) ;
			glMatrixMode(GL_MODELVIEW) ;

//			glCallList(BOARD_LIST) ;
			glCallList(ENV_BOARD_LIST) ;

			glMatrixMode(GL_TEXTURE) ;
		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;
	}
	else	// -reflect オプション指定時
	{
		glDepthMask(GL_FALSE) ;
		// MATERIAL_RED_GRAY 色セット
		glColor4f(currentCL[0], currentCL[1]*0.7f, currentCL[2]*0.7f, 0.2f) ;

		glMatrixMode(GL_TEXTURE) ;
		glPushMatrix() ;
			glCallList(SOLID2_TEXTURE_LIST) ;
			glMatrixMode(GL_MODELVIEW) ;

			glCallList(ENV_BOARD_LIST) ;
			glDepthMask(GL_TRUE) ;

			glMatrixMode(GL_TEXTURE) ;
		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;
//		glCallList(ENV_BOARD_LIST) ;

		glDepthMask(GL_TRUE) ;

		// 映り込み部分描画
		if (envOpenGL != VOODOO_MESA)
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
		else
		// 3Dfx Mesa では、テクスチャ時に上のファクタは使用できない
			glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE_MINUS_SRC_COLOR) ;

		glEnable(GL_BLEND) ;

//		glPushAttrib(GL_TEXTURE_BIT) ;
//			glCallList(MIRROR_PLANE_ST_LIST) ;	// s, t 座標系をｚ軸反転に
//		glCallList(MIRROR_WALL_LIST) ;

		glPushMatrix() ;

			glScalef(1.0f, 1.0f, -1.0f) ;
			glFrontFace(GL_CW) ;

/*
			glPushMatrix() ;
				glCallList(ENV_BOARD_DETAIL_LIST) ;
			glPopMatrix() ;
*/
			glPushMatrix() ;
				glMatrixMode(GL_TEXTURE) ;
				glPushMatrix() ;
					glCallList(SOLID2_TEXTURE_LIST) ;
					glMatrixMode(GL_MODELVIEW) ;
						glCallList(ENV_BOARD_DETAIL_LIST) ;
					glMatrixMode(GL_TEXTURE) ;
				glPopMatrix() ;
				glMatrixMode(GL_MODELVIEW) ;
			glPopMatrix() ;

			glColor4f(currentCL[0], currentCL[1], currentCL[2], 0.4f) ;
			glCallList(ENV_MIRROR_WALL_LIST) ;

			glFrontFace(GL_CCW) ;
		glPopMatrix() ;

//		glPopAttrib() ;	// s, t 座標系をもとに戻す

		glBlendFunc(GL_ONE, GL_ONE) ;//glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;
		glDisable(GL_BLEND) ;
		// 映り込み部分描画終了

		// 本体描画
		glPushMatrix() ;
			glColor3f(currentCL[0], currentCL[1]*0.8f, currentCL[2]*0.8f) ;
			glCallList(BOARD_DETAIL_LIST) ;
		glPopMatrix() ;
	}
}

// 時計描画（-real オプションの一回目の描画）
void DrawSolidClock(ClockState& st)
{
	glDisable(GL_CULL_FACE) ;

	if (!lid)
	{
		glPushMatrix() ;

			glTranslatef(0.0f, 14.5f, 5.2f) ;
			glRotatef(st.roof * ROOF_RAD, -1.0f,0.0f,0.0f) ;
			glCallList(ROOF_LIST) ;

		glPopMatrix() ;
	}

	glEnable(GL_CULL_FACE) ;

	glCallList(SHELL_LIST) ;

	if (!reflection)	// 反射なし時
	{
		glMatrixMode(GL_TEXTURE) ;
		glPushMatrix() ;
			glCallList(SOLID2_TEXTURE_LIST) ;
			glMatrixMode(GL_MODELVIEW) ;

			glCallList(BOARD_LIST) ;

			glMatrixMode(GL_TEXTURE) ;
		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;
	}
	else	// -reflect オプション指定時
	{
		glDepthMask(GL_FALSE) ;
		glMatrixMode(GL_TEXTURE) ;
		glPushMatrix() ;
			glCallList(SOLID2_TEXTURE_LIST) ;
			glMatrixMode(GL_MODELVIEW) ;

			glCallList(BOARD_LIST) ;	// デプス書き込み無しでソリッドのボード描画
			glDepthMask(GL_TRUE) ;

			glMatrixMode(GL_TEXTURE) ;
		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;

		// 映り込み部分描画
		if (envOpenGL != VOODOO_MESA)
			glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
		else
		// 3Dfx Mesa では、テクスチャ時に上のファクタは使用できない
			glBlendFunc(GL_ONE_MINUS_DST_COLOR, GL_ONE_MINUS_SRC_COLOR) ;

		glEnable(GL_BLEND) ;

		glPushMatrix() ;

			glScalef(1.0f, 1.0f, -1.0f) ;
			glFrontFace(GL_CW) ;

			glPushMatrix() ;

				glMatrixMode(GL_TEXTURE) ;
				glPushMatrix() ;
					glCallList(SOLID2_TEXTURE_LIST) ;
					glMatrixMode(GL_MODELVIEW) ;

						glCallList(MATERIAL_MIRROR_RED_GRAY) ;
						glCallList(ENV_BOARD_DETAIL_LIST) ;

					glMatrixMode(GL_TEXTURE) ;
				glPopMatrix() ;
				glMatrixMode(GL_MODELVIEW) ;

			glPopMatrix() ;

			glCallList(MIRROR_WALL_LIST) ;

			glFrontFace(GL_CCW) ;
		glPopMatrix() ;

//		glPopAttrib() ;	// s, t 座標系をもとに戻す

		glBlendFunc(GL_ONE, GL_ONE) ;//glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;
		glDisable(GL_BLEND) ;
		// 映り込み部分描画終了

		// 本体描画
		glPushMatrix() ;
			glCallList(BOARD_DETAIL_LIST) ;
		glPopMatrix() ;
	}
}


// 時計描画（ステータスで）
void DrawClock(ClockState& st)
{
	GLint tmp_glass ;

	switch (texture)
	{
	case 0:
		DrawStandardClock(st) ;
		break ;
	case 1:
		DrawModulateClock(st) ;			// ブレンドは元に戻る
		break ;
	case 2:
		if (solid) DrawStandardClock(st) ;
		else
		{

			tmp_glass = clock_glass ;
			clock_glass = 0 ;

			DrawModulateClock(st) ;
			clock_glass = tmp_glass ;

			glMatrixMode(GL_TEXTURE) ;
			glPushMatrix() ;
				glCallList(ENV_GLASS_TEXTURE_LIST) ;
				glMatrixMode(GL_MODELVIEW) ;

				glEnable(GL_BLEND) ;
				glDepthMask(GL_FALSE) ;
				glDepthFunc(GL_LEQUAL) ;

				glFogfv(GL_FOG_COLOR, black) ;
#ifdef GL_VERSION_1_1
				if (polygon_offset) glEnable(GL_POLYGON_OFFSET_FILL) ;
#endif
				DrawModulateClock(st) ;

#ifdef GL_VERSION_1_1
				if (polygon_offset) glDisable(GL_POLYGON_OFFSET_FILL) ;
#endif
				glFogfv(GL_FOG_COLOR, currentBG) ;

				glDepthFunc(GL_LESS) ;
				glDisable(GL_BLEND) ;
				glDepthMask(GL_TRUE) ;

			glMatrixMode(GL_TEXTURE) ;
			glPopMatrix() ;
			glMatrixMode(GL_MODELVIEW) ;
		}
		break ;
	case 3:
		if (crystal)	// -C クリスタル
		{
			glEnable(GL_BLEND) ;

			glDepthMask(GL_FALSE) ;
			glDisable(GL_DEPTH_TEST) ;

			glDisable(GL_LIGHTING) ;
			glEnable(GL_TEXTURE_2D) ;

			glFogfv(GL_FOG_COLOR, black) ;

			if ((motion || anti) && !(motion && anti))
				DrawCrystalClockWithOverSampling(st) ;	// ブレンドは元に戻る
			else    DrawCrystalClock(st) ;			// ブレンドは元に戻る

			glFogfv(GL_FOG_COLOR, currentBG) ;

			glPopAttrib() ;

		}
		else if (!solid)	// -e 3 環境マップ
		{
			glDisable(GL_LIGHTING) ;
			glEnable(GL_TEXTURE_2D) ;

			int t_glass = clock_glass ;
			clock_glass = 0 ;
			DrawMirrorClock2(st) ;
			clock_glass = t_glass ;

			glEnable(GL_LIGHTING) ;
			glDisable(GL_TEXTURE_2D) ;
			glDepthFunc(GL_LEQUAL) ;

			glFogfv(GL_FOG_COLOR, black) ;
			DrawShadeWrapClock(st) ;
			glFogfv(GL_FOG_COLOR, currentBG) ;

			glDepthFunc(GL_LESS) ;
		}
		else if (reality)	// -r リアルオプション時
		{
			// ソリッドマッピングセット
			glEnable(GL_TEXTURE_2D) ;
			glCallList(SOLID_TEXTURE_LIST) ;

			switch (reality)
			{
			case 1:
				glDisable(GL_LIGHTING) ;
				DrawSolidModulateClock(st) ;
				// 環境マッピングセット
//				glEnable(GL_TEXTURE_2D) ;
				glCallList(ENV_TEXTURE_LIST) ;

				glDepthFunc(GL_LEQUAL) ;

				glFogfv(GL_FOG_COLOR, black) ;
//////////////////////////
//				glTranslated(0.0, 0.0, -0.0000001) ; /////////////////////////////////
//////////////////////////
				DrawEnvSpecularModulateClock(st) ;
				glFogfv(GL_FOG_COLOR, currentBG) ;

				glDepthFunc(GL_LESS) ;

				break ;

			case 2:
				glEnable(GL_LIGHTING) ;
				DrawSolidClock(st) ;
				// 環境マッピングセット
//				glEnable(GL_TEXTURE_2D) ;
				glCallList(ENV_TEXTURE_LIST) ;

				glDisable(GL_LIGHTING) ;
				glDepthFunc(GL_LEQUAL) ;

				glFogfv(GL_FOG_COLOR, black) ;
				DrawEnvSpecularModulateClock(st) ;
				glFogfv(GL_FOG_COLOR, currentBG) ;

				glPopAttrib() ;

				glDepthFunc(GL_LESS) ;

				break ;
			}
		}
		else	// ソリッドマップ
		{
			glEnable(GL_TEXTURE_2D) ;
			glEnable(GL_LIGHTING) ;
			DrawStandardClock(st) ;
			glDisable(GL_TEXTURE_2D) ;

			glDepthFunc(GL_LEQUAL) ;

			glFogfv(GL_FOG_COLOR, black) ;
			DrawSpecularClock(st) ;
			glFogfv(GL_FOG_COLOR, currentBG) ;

			glDepthFunc(GL_LESS) ;
		}
		break ;
	}
}



// 時計描画
// DrawClock() のメタル時計オーバサンプリング用
// n には何回目の描画かを渡す
void DrawClock(ClockState& st, int n)
{
	// オーバサンプリング処理
	// Zバッファのみクリアし、
	// Zバッファのみ描画
	// Zバッファ読み込み only
	// bg_color != 4 の場合は背景描く
	// カラーバッファ書き込み許可
	// ADD で 背景全体に矩形描画
	// ADD で 通常描画

	if (n == 0)
	{
		// 最初の描画
		DrawModulateClockWithOverSampling(st) ;	// ブレンドは元に戻る
	}
	else
	{
		float alpha_weight = 1.0f / (n + 1) ;

		// ２回目以降
		glDepthMask(GL_TRUE) ;
		glClear(GL_DEPTH_BUFFER_BIT) ;
		glColorMask(GL_FALSE, GL_FALSE, GL_FALSE, GL_FALSE) ;
		DrawDepthClock(st) ;
		glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE) ;
		glDepthMask(GL_FALSE) ;

		glPushMatrix() ;
		glLoadIdentity() ;
		glTranslatef(0.0f, 0.0f, 0.999999f) ; // far_clip) ;

		glMatrixMode(GL_PROJECTION) ;
		glPushMatrix() ;
		glLoadIdentity() ;

//		glMatrixMode(GL_MODELVIEW) ;
		glDisable(GL_TEXTURE_2D) ;
		if (saver)
			glColor4f(0.0f, 0.0f, 0.0f, alpha_weight) ;
		else
			glColor4f(currentBG[0], currentBG[1], currentBG[2], alpha_weight) ;
		glRectf(-1.0f, -1.0f, 1.0f, 1.0f) ;
		glEnable(GL_TEXTURE_2D) ;

//		glMatrixMode(GL_PROJECTION) ;
		glPopMatrix() ;

		glMatrixMode(GL_MODELVIEW) ;
		glPopMatrix() ;

		DrawModulateClockWithOverSampling(st, alpha_weight) ;
	}
}

// 文字盤描画
void DrawBoard(GLint divide, GLfloat radius)
{
	int	  i ;

	glBegin(GL_TRIANGLE_FAN) ;

		glNormal3f(0.0f, 0.0f, 1.0f) ;	// 法線ベクトル全て同じ
		glVertex3f(0.0f, 0.0f, 0.0f) ;	// 時計文字盤中心座標
/*
		for (i = 0 ; i < divide ; i ++)
		{
			GLfloat rad = -2.0f * PAI / divide * i ;
			glVertex3f(sin(rad) * radius, cos(rad) * radius, 0.0f) ;
		}
		glVertex3f(0.0f, radius, 0.0f) ;	// 開始点と終了点を連結 
*/
		for (i = 0 ; i <= divide ; i ++)
		{
			GLfloat rad = -2.0f * PAI / divide * i ;
			if (i == divide) rad = 0.0f ;
			GLfloat x = sin(rad), y = cos(rad) ;
			Vector3d norm(x * 0.15f * norm_ratio, y * 0.15f * norm_ratio, 1.0f) ;

			glNormal3fv(norm.Unit().v) ;	// 法線ベクトルは少し外向きに
			glVertex3f(x * radius, y * radius, 0.0f) ;
		}

	glEnd() ;
}

// 文字盤上の小さな粒々描画
void DrawClockPoints(GLfloat radius)
{
	int i ;
	for (i = 0 ; i < 60 ; i ++)
	{
		if ((i % 5) == 0) i ++ ;
		glPushMatrix() ;
			glRotatef(-6.0f * i, 0.0f,0.0f,1.0f) ;
			glTranslatef(0.0f, radius, 0.0f) ;
//			DrawClockPoint(1.5f, 2.0f, 3.0f) ;
			glCallList(POINT_LIST) ;
		glPopMatrix() ;
	}
}

// 時計針描画（実際の描画）
void DrawNeedlePolygons(Object **needle)
{
	int n, i ;

	for (n = 0 ; n < 4 ; n ++)
	{
		int p = n % 2 ;

		glBegin(GL_TRIANGLE_FAN) ;

			glNormal3fv(needle[n]->polygon[1].normal[2].v) ;
			glVertex3fv(needle[n]->polygon[0].vertex[2].v) ;

			for (i = p*6 ; i != 8*(1-p)-1 ; i += 1-p*2)
			{
				glNormal3fv(needle[n]->polygon[i].normal[p].v) ;
				glVertex3fv(needle[n]->polygon[i].vertex[p].v) ;
			}

		glEnd() ;

		glBegin(GL_TRIANGLES) ;

			for (i = 0 ; i < 3 ; i ++)
			{
				glNormal3fv(needle[n]->polygon[6].normal[i].v) ;
				glVertex3fv(needle[n]->polygon[6].vertex[i].v) ;
			}

		glEnd() ;
	}
}


// 時計針描画（データ作成）
void DrawNeedle(GLfloat x = 1.0f, GLfloat y = 1.0f, GLfloat z = 1.0f)
{
	int            i, n ;
	Object **needle ;
	GLfloat       m[] = {   x, 0.0f, 0.0f, 0.0f,
					       0.0f,   y, 0.0f, 0.0f,
					       0.0f, 0.0f,   z, 0.0f,
						   0.0f, 0.0f, 0.0f, 1.0f } ;

	needle = new Object*[4] ;

	for (n = 0 ; n < 4 ; n ++)
	{
		int p = n % 2 ;

		if      (n == 1) m[0] = -x ;
		else if (n == 2) m[5] = -y ;
		else if (n == 3) m[0] =  x ;

		needle[n] = new Object(7) ;


		for (i = 0 ; i < 7 ; i ++)
			needle[n]->MakePolygon(i, i+p,i+1-p,8, n_v, m) ;

		// １～４番ポリゴンの、第０第１頂点は隣接ポリゴンの法線を平均
		for (i = 1 ; i < 5 ; i ++)
		{
			needle[n]->polygon[i].normal[2] = needle[n]->polygon[0].pNormal ;
			needle[n]->AverageNormal(i,   p, i,i-1) ;
			needle[n]->AverageNormal(i, 1-p, i,i+1) ;
		}

		needle[n]->polygon[5].normal[2] = needle[n]->polygon[0].pNormal ;
		needle[n]->AverageNormal(0, 1-p, 0,1) ;
		needle[n]->AverageNormal(5,   p, 4,5) ;
	}

	DrawNeedlePolygons(needle) ;

	for (n = 0 ; n < 4 ; n ++) delete needle[n] ;
	delete needle ;
}

// サインリスト作成
void MakeSignList()
{
	glNewList(AllocAList(SIGN_LIST), GL_COMPILE) ;
		DrawString(sign, GLUT_BITMAP_TIMES_ROMAN_10) ;
	glEndList() ;
}

// 金飾りリスト作成
void MakeGoldenObjectList()
{
	glNewList(AllocAList(GOLDEN_OBJECT_LIST), GL_COMPILE) ;
		DrawGoldenObject(1.1f,1.1f,1.0f, gold_depth, TRUE, texture) ;
	glEndList() ;
}

// 文字盤上の小さな粒リスト作成
void MakeClockPointList()
{
	if (clock_point)
	{
		glNewList(AllocAList(POINT_LIST), GL_COMPILE) ;
			DrawClockPoint(1.5f, 2.0f, 3.0f) ;
		glEndList() ;
	}
}

// Ｍリスト作成
void MakeMList()
{
	glNewList(AllocAList(M_LIST), GL_COMPILE) ;
		DrawM() ;
	glEndList() ;
}

// 時計針リスト作成
void MakeClockNeedleLists()
{
	// 本体用
	glNewList(AllocAList(HOUR_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_METAL_BLUE) ;
		else                      glCallList(MATERIAL_METAL_BLUE) ;
		glTranslatef(0.0f, 3.0f * radius_ratio, 0.6f) ;
		DrawNeedle(1.2f * N_D_WIDTH * n_width, 1.0f * radius_ratio, 0.4f) ;
	glEndList() ;
	glNewList(AllocAList(ENV_HOUR_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 3.0f * radius_ratio, 0.6f) ;
		DrawNeedle(1.2f * N_D_WIDTH * n_width, 1.0f * radius_ratio, 0.4f) ;
	glEndList() ;

	glNewList(AllocAList(MINUTE_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_METAL_GREEN) ;
		else                      glCallList(MATERIAL_METAL_GREEN) ;
		glTranslatef(0.0f, 5.0f * radius_ratio, 1.2f) ;
		DrawNeedle(0.9f * N_D_WIDTH * n_width, 1.4f * radius_ratio, 0.6f) ;
	glEndList() ;
	glNewList(AllocAList(ENV_MINUTE_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 5.0f * radius_ratio, 1.2f) ;
		DrawNeedle(0.9f * N_D_WIDTH * n_width, 1.4f * radius_ratio, 0.6f) ;
	glEndList() ;

	glNewList(AllocAList(SECOND_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_GOLD) ;
		else                      glCallList(MATERIAL_GOLD) ;
		glTranslatef(0.0f, 4.0f * radius_ratio, 1.5f) ;
		DrawNeedle(0.7f * N_D_WIDTH * n_width, 1.7f * radius_ratio, 0.9f) ;
	glEndList() ;
	// -e 3 && -sm 用の秒針リスト（輝度を 1/pre_s__motion に）
	glNewList(AllocAList(SECOND_E3_LIST), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f/pre_s_motion,0.75f/pre_s_motion,0.05f/pre_s_motion, 1.0f, 1.0f, /*0.95f*/ 2.0f * specular * spec / pre_s_motion, 128.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
		glTranslatef(0.0f, 4.0f * radius_ratio, 1.5f) ;
		DrawNeedle(0.7f * N_D_WIDTH * n_width, 1.7f * radius_ratio, 0.9f) ;
	glEndList() ;

	glNewList(AllocAList(ENV_SECOND_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 4.0f * radius_ratio, 1.5f) ;
		DrawNeedle(0.7f * N_D_WIDTH * n_width, 1.7f * radius_ratio, 0.9f) ;
	glEndList() ;

	if (!reflection) return ;

	// 文字盤への映り込み用（-real 2 以上指定時のみ）z軸反対に移動
	glNewList(AllocAList(MIRROR_HOUR_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_METAL_BLUE) ;
		else                      glCallList(MATERIAL_METAL_BLUE) ;
		glTranslatef(0.0f, 3.0f * radius_ratio, -0.6f) ;
		DrawNeedle(1.2f * N_D_WIDTH * n_width, 1.0f * radius_ratio, 0.4f) ;
	glEndList() ;
	glNewList(AllocAList(ENV_MIRROR_HOUR_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 3.0f * radius_ratio, -0.6f) ;
		DrawNeedle(1.2f * N_D_WIDTH * n_width, 1.0f * radius_ratio, 0.4f) ;
	glEndList() ;

	glNewList(AllocAList(MIRROR_MINUTE_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_METAL_GREEN) ;
		else                      glCallList(MATERIAL_METAL_GREEN) ;
		glTranslatef(0.0f, 5.0f * radius_ratio, -1.2f) ;
		DrawNeedle(0.9f * N_D_WIDTH * n_width, 1.4f * radius_ratio, 0.6f) ;
	glEndList() ;
	glNewList(AllocAList(ENV_MIRROR_MINUTE_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 5.0f * radius_ratio, -1.2f) ;
		DrawNeedle(0.9f * N_D_WIDTH * n_width, 1.4f * radius_ratio, 0.6f) ;
	glEndList() ;

	glNewList(AllocAList(MIRROR_SECOND_LIST), GL_COMPILE) ;
		if (texture < 3 || solid) glCallList(MATERIAL_MAT_GOLD) ;
		else                      glCallList(MATERIAL_GOLD) ;
		glTranslatef(0.0f, 4.0f * radius_ratio, -1.5f) ;
		DrawNeedle(0.7f * N_D_WIDTH * n_width, 1.7f * radius_ratio, 0.9f) ;
	glEndList() ;
	glNewList(AllocAList(ENV_MIRROR_SECOND_LIST), GL_COMPILE) ;
		glTranslatef(0.0f, 4.0f * radius_ratio, -1.5f) ;
		DrawNeedle(0.7f * N_D_WIDTH * n_width, 1.7f * radius_ratio, 0.9f) ;
	glEndList() ;
}

// 時計の蓋描画
void DrawRoof(int divide, int mesh = 1, int grad_sw = TRUE, float color_weight = 1.0f, Vector3d *rgrad = ::rgrad)
{
	RollingObject roof(divide * (n_r_vtx[mesh] - 1)) ;

	if (mesh)
	{
		roof.MakeRollingPolygons(divide, n_r_vtx[mesh], r_v) ;
		roof.AverageNormals(TRUE /*clock_div >= 12 */,  TRUE, r_a) ;
	}
	else
	{
		roof.MakeRollingPolygons(divide, n_r_vtx[mesh], r2_v) ;
		roof.AverageNormals(TRUE /* clock_div >= 12 */,  TRUE, r2_a) ;
	}

	roof.TopNormal() ;	// 一番上の頂点の法線は真上向きに

	glTranslatef(0.0f, -14.5f, -5.2f) ;


	// てっぺんの三角ポリゴン描画
	int i = divide - 1 ;
	int pNo = i * (n_r_vtx[mesh]  - 1), n ;

	glBegin(GL_TRIANGLE_FAN) ;

		glNormal3fv(roof.polygon[pNo].normal[0].v) ;

		if (grad_sw)
		{
			if (reality == 1) // || reality == 2)
				 glColor3f(0.35f * color_weight,0.35f * color_weight,0.35f * color_weight) ;
			else
				 glColor3f(0.7f * color_weight,0.7f * color_weight,0.7f * color_weight) ;	// ハイライトの色をグラデーション
		}
//		else if (crystal) glColor4d(0.7f * color_weight,0.7f * color_weight,0.7f * color_weight, crystal_a) ;
		glVertex3fv(roof.polygon[pNo].vertex[0].v) ;

		n = (i + 1) % divide ;
		if (grad_sw)      glColor3fv(rgrad[n % ngrad].v) ;	// ハイライトの色をグラデーション
//		else if (crystal) glColor4f(rgrad[n % ngrad].v[0] * color_weight,rgrad[n % ngrad].v[1] * color_weight,rgrad[n % ngrad].v[2] * color_weight, crystal_a) ;
		glNormal3fv(roof.polygon[pNo].normal[1].v) ;
		glVertex3fv(roof.polygon[pNo].vertex[1].v) ;

		for (i = divide - 1 ; i >= 0 ; i --)
		{
			n = i ;	// n = (i + 1 - 1) % divide ;

			glNormal3fv(roof.polygon[pNo].normal[2].v) ;
			if (grad_sw)      glColor3fv(rgrad[n % ngrad].v) ;	// ハイライトの色をグラデーション
//			else if (crystal) glColor4f(rgrad[n % ngrad].v[0] * color_weight,rgrad[n % ngrad].v[1],rgrad[n % ngrad].v[2], crystal_a) ;
			glVertex3fv(roof.polygon[pNo].vertex[2].v) ;

			pNo -= n_r_vtx[mesh]  - 1 ;
		}

	glEnd() ;


	// 通常の四角ポリゴン描画
	int u, v ;
	for (v = 1 ; v < n_r_vtx[mesh] - 1 ; v ++)
	{
		pNo = v ;

		glBegin(GL_QUAD_STRIP) ;

			n = 0 ; //	n = (-1 + 1) % divide ;
			if (grad_sw)      glColor3fv(rgrad[n % ngrad].v) ;	// ハイライトの色をグラデーション
//			else if (crystal) glColor4f(rgrad[n % ngrad].v[0] * color_weight,rgrad[n % ngrad].v[1] * color_weight,rgrad[n % ngrad].v[2] * color_weight, crystal_a) ;

			glNormal3fv(roof.polygon[pNo].normal[2].v) ;
			glVertex3fv(roof.polygon[pNo].vertex[2].v) ;

			glNormal3fv(roof.polygon[pNo].normal[3].v) ;
			glVertex3fv(roof.polygon[pNo].vertex[3].v) ;

			for (u = 0 ; u < divide ; u ++)
			{
				n = (u + 1) % divide ;
				if (grad_sw)      glColor3fv(rgrad[n % ngrad].v) ;	// ハイライトの色をグラデーション
//				else if (crystal) glColor4f(rgrad[n % ngrad].v[0] * color_weight,rgrad[n % ngrad].v[1] * color_weight,rgrad[n % ngrad].v[2] * color_weight, crystal_a) ;

				glNormal3fv(roof.polygon[pNo].normal[1].v) ;
				glVertex3fv(roof.polygon[pNo].vertex[1].v) ;

				glNormal3fv(roof.polygon[pNo].normal[0].v) ;
				glVertex3fv(roof.polygon[pNo].vertex[0].v) ;

				pNo += n_r_vtx[mesh] - 1 ;
			}

		glEnd() ;
	}
}


// 文字盤へ映り込む用の回りの壁描画
// alpha_flag がセットされている場合、アルファ値を max から min の間でグラデーション
void DrawMirrorWall(int divide, int alpha_flag = TRUE, GLfloat grad_max = 1.0f, GLfloat grad_min = 0.0f)
{
	int i ;

	RollingObject wall(divide) ;

	wall.MakeRollingPolygons(divide, 2, mw_v) ;
	wall.AverageNormals(U_SMOOTH_FLAG /* divide >= 12 */) ; //, FALSE) ;

	if (!(U_SMOOTH_FLAG))
	{
		glBegin(GL_QUADS) ;

			for (i = 0 ; i < divide ; i ++)
			{
				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_max) ;
				glNormal3fv(wall.polygon[i].normal[0].v) ;
				glVertex3fv(wall.polygon[i].vertex[0].v) ;

				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_min) ;
				glNormal3fv(wall.polygon[i].normal[1].v) ;
				glVertex3fv(wall.polygon[i].vertex[1].v) ;

				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_min) ;
				glNormal3fv(wall.polygon[i].normal[2].v) ;
				glVertex3fv(wall.polygon[i].vertex[2].v) ;

				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_max) ;
				glNormal3fv(wall.polygon[i].normal[3].v) ;
				glVertex3fv(wall.polygon[i].vertex[3].v) ;
			}

		glEnd() ;
	}
	else
	{
		glBegin(GL_QUAD_STRIP) ;

			if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_min) ;
			glNormal3fv(wall.polygon[0].normal[2].v) ;
			glVertex3fv(wall.polygon[0].vertex[2].v) ;

			if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_max) ;
			glNormal3fv(wall.polygon[0].normal[3].v) ;
			glVertex3fv(wall.polygon[0].vertex[3].v) ;

			for (i = 0 ; i < divide ; i ++)
			{
				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_min) ;
				glNormal3fv(wall.polygon[i].normal[1].v) ;
				glVertex3fv(wall.polygon[i].vertex[1].v) ;

				if (alpha_flag) glColor4f(1.0f,1.0f,0.8f, grad_max) ;
//				glNormal3fv(wall.polygon[i].normal[0].v) ;
				glVertex3fv(wall.polygon[i].vertex[0].v) ;
			}

		glEnd() ;
	}
}

// 時計の殻描画
void DrawShell(int divide, int mesh = 1)
{
	RollingObject shell(divide * (n_s_vtx[mesh] - 1)) ;

	if (mesh)
	{
		shell.MakeRollingPolygons(divide, n_s_vtx[mesh], s_v) ;
		shell.AverageNormals(U_SMOOTH_FLAG, v_smooth, V_SMOOTH_T(s_a)) ;
	}
	else
	{
		shell.MakeRollingPolygons(divide, n_s_vtx[mesh], s2_v) ;
		shell.AverageNormals(U_SMOOTH_FLAG, v_smooth, V_SMOOTH_T(s2_a)) ;
	}

	// u_smooth を行わなかった場合、底の部分をスムーズにする
	if (!(U_SMOOTH_FLAG))
	{
		for (int u = 0 ; u < divide ; u ++)
		{
			int      p0No = u * (n_s_vtx[mesh] - 1) + n_s_vtx[mesh] - 2, p1No ;
			Vector3d norm ;

			if (u == divide - 1) p1No = p0No - (n_s_vtx[mesh] - 1) * (divide - 1) ;
			else                 p1No = p0No + (n_s_vtx[mesh] - 1) ;

//			cout << p0No << ", " << p1No << endl ;

			norm = Unit(shell.polygon[p0No].normal[0] + shell.polygon[p1No].normal[2]) ;
			shell.polygon[p0No].normal[0] = shell.polygon[p1No].normal[2] = norm ;
		}
	}

	shell.BottomNormal() ;	// 一番下の頂点の法線は真下向きに

	if (!(U_SMOOTH_FLAG))
	{
		int i ;
		for (i = 0 ; i < divide ; i ++)
		{
			int pNo, j ;

			glBegin(GL_QUADS) ;
				for (j = 0 ; j < n_s_vtx[mesh] - 2 ; j ++)
				{
					pNo = i * (n_s_vtx[mesh] - 1) + j ;
					glNormal3fv(shell.polygon[pNo].normal[0].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[0].v) ;
					glNormal3fv(shell.polygon[pNo].normal[1].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[1].v) ;
					glNormal3fv(shell.polygon[pNo].normal[2].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[2].v) ;
					glNormal3fv(shell.polygon[pNo].normal[3].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[3].v) ;
				}
			glEnd() ;

			pNo ++ ;
			glBegin(GL_TRIANGLES) ;
				glNormal3fv(shell.polygon[pNo].normal[0].v) ;
				glVertex3fv(shell.polygon[pNo].vertex[0].v) ;
				glNormal3fv(shell.polygon[pNo].normal[1].v) ;
//				glNormal3f(0.0f, 0.0f, -1.0f) ;	// 一番下の頂点座標は法線を真下に
				glVertex3fv(shell.polygon[pNo].vertex[1].v) ;
				glNormal3fv(shell.polygon[pNo].normal[2].v) ;
				glVertex3fv(shell.polygon[pNo].vertex[2].v) ;
			glEnd() ;
		}
	}
	else
	{
		int u, v ;
		for (v = 0 ; v < n_s_vtx[mesh] - 1 ; v ++)
		{
/*
			if (v == 0) // てっぺんの三角形
			{
				int pNo = (divide - 1) * (n_s_vtx[mesh] - 1) ;

				glBegin(GL_TRIANGLE_FAN) ;

//					glNormal3fv(shell.polygon[pNo].normal[0].v) ;
					glNormal3f(0.0f, 0.0f, 1.0f) ;	// 一番上の頂点座標は法線を真上に
					glVertex3fv(shell.polygon[pNo].vertex[0].v) ;

					glNormal3fv(shell.polygon[pNo].normal[1].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[1].v) ;

//					for (u = 0 ; u < divide ; u ++)
					for (u = divide - 1 ; u >= 0 ; u --)
					{
						glNormal3fv(shell.polygon[pNo].normal[2].v) ;
						glVertex3fv(shell.polygon[pNo].vertex[2].v) ;

						pNo -= n_s_vtx[mesh] - 1 ;
					}

				glEnd() ;
			}
			else if (v == n_s_vtx[mesh] - 2 ) // 底の三角形
*/
			if (v == n_s_vtx[mesh] - 2 ) // 底の三角形
			{
				int pNo = v ;

				glBegin(GL_TRIANGLE_FAN) ;

					glNormal3fv(shell.polygon[pNo].normal[1].v) ;
//					glNormal3f(0.0f, 0.0f, -1.0f) ;	// 一番下の頂点座標は法線を真下に
					glVertex3fv(shell.polygon[pNo].vertex[1].v) ;

					glNormal3fv(shell.polygon[pNo].normal[2].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[2].v) ;

					for (u = 0 ; u < divide ; u ++)
					{
						glNormal3fv(shell.polygon[pNo].normal[0].v) ;
						glVertex3fv(shell.polygon[pNo].vertex[0].v) ;

						pNo += n_s_vtx[mesh] - 1 ;
					}

				glEnd() ;
			}
			else  // 通常の四角形
			{
				int pNo = v ;

				glBegin(GL_QUAD_STRIP) ;

					glNormal3fv(shell.polygon[pNo].normal[2].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[2].v) ;

					glNormal3fv(shell.polygon[pNo].normal[3].v) ;
					glVertex3fv(shell.polygon[pNo].vertex[3].v) ;

					for (u = 0 ; u < divide ; u ++)
					{
						glNormal3fv(shell.polygon[pNo].normal[1].v) ;
						glVertex3fv(shell.polygon[pNo].vertex[1].v) ;

						glNormal3fv(shell.polygon[pNo].normal[0].v) ;
						glVertex3fv(shell.polygon[pNo].vertex[0].v) ;

						pNo += n_s_vtx[mesh] - 1 ;
					}

				glEnd() ;
			}
		}
	}
}

// 文字盤上の１２個の粒
void MakePolyhedronLists()
{
	// 正多面体リスト作成
	glNewList(AllocAList(HEDRON_LIST), GL_COMPILE) ;
		DrawPolyhedron(0.6f,0.6f,0.6f) ;
	glEndList() ;

	// 正多面体リスト２作成（１２位置用）
	glNewList(AllocAList(HEDRON_LIST2), GL_COMPILE) ;
		DrawPolyhedron(1.2f,1.2f,1.2f) ;
	glEndList() ;

	// 正多面体リスト３作成（６位置用）
	glNewList(AllocAList(HEDRON_LIST3), GL_COMPILE) ;
		DrawPolyhedron(0.9f,0.9f,0.9f) ;
	glEndList() ;

/*
	// LIGHT5（文字盤を照らすスポットライト） セット
	GLfloat u_dir[3] ;
	Vector3d dir(spot[0], spot[1], spot[2]) ;
	dir.Unit() ;
	u_dir[0] = dir.X() ;
	u_dir[1] = dir.Y() ;
	u_dir[2] = dir.Z() ;

	glEnable(GL_LIGHT5);

	glDisable(GL_LIGHT0);
	glDisable(GL_LIGHT1);
	glDisable(GL_LIGHT2);
	glDisable(GL_LIGHT3);
	glDisable(GL_LIGHT4);

//	SetLight(GL_LIGHT5, lpos[5], lcol[5], FALSE);
	glLightf(GL_LIGHT5, GL_SPOT_EXPONENT, 1.0f);
	glLightf(GL_LIGHT5, GL_SPOT_CUTOFF, 90.0f);

	glNewList(AllocAList(SPOT_LIGHT_LIST), GL_COMPILE) ;
		SetLight(GL_LIGHT5, lpos[5], lcol[5], FALSE);
		glLightfv(GL_LIGHT5, GL_SPOT_DIRECTION, u_dir);
	glEndList() ;

*/
}

// Ｆｒｏｎｔ素材リスト作成
void MakeMaterialLists()
{
/*
	// METAL_LIGHT_ATTRIBUTE 環境光のみ明るく設定（-r オプションの金属スペキュラー用）
	glNewList(AllocAList(METAL_LIGHT_ATTRIBUTE), GL_COMPILE) ;

		glDisable(GL_LIGHT0);
		glDisable(GL_LIGHT1);
		glDisable(GL_LIGHT2);
		glDisable(GL_LIGHT3);
		glDisable(GL_LIGHT4);

		glLightModelfv(GL_LIGHT_MODEL_AMBIENT, metal_light_attribute) ;

	glEndList() ;
*/

	// Gold
	glNewList(AllocAList(MATERIAL_GOLD), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.75f,0.05f, 1.0f, 1.0f, /*0.95f*/ 2.0f * specular * spec, 128.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Iron
	glNewList(AllocAList(MATERIAL_IRON), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,1.0f,1.0f, 1.0f, 1.0f, /*0.9f*/ 2.0f * specular * spec, 64.0f, IS_SET_M_RATIO, SOLID_M_RATIO) ;
	glEndList() ;

	// GLASS,GLASS3 は、グラスの中心部が丸く光るのを防ぐために、中心用の薄い色用と
	// Glass
	GLfloat sl = 1.0f, r_shin = 128.0f, amb = (GLfloat)NONE ;

	if ((texture && !solid) || reality)
	{
		sl = 0.5f ;
		r_shin = 32.0f ;
		amb = 4.0f ;
	}
/*
	if ((texture == 3 && !solid) || reality)
	{
		sl = 1.0f ;
		r_shin = 128.0f ;
		amb = 4.0f ;
	}
*/
	glNewList(AllocAList(MATERIAL_GLASS), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.03f,0.05f,0.03f, 1.0f, 0.0f, sl*0.5f * spec, r_shin, FALSE, 0.0f, amb) ;
	glEndList() ;

	// Glass2
	glNewList(AllocAList(MATERIAL_GLASS2), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.1f,0.14f,0.1f, 1.0f, 0.0f, sl*1.0f * spec, r_shin, FALSE, 0.0f, amb) ;
	glEndList() ;

	// Glass3
	glNewList(AllocAList(MATERIAL_GLASS3), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.015f,0.025f,0.015f, 1.0f, 0.0f, sl*0.25f * spec, r_shin, FALSE, 0.0f, amb) ;
	glEndList() ;

/*
	// Glass4
	glNewList(AllocAList(MATERIAL_GLASS4), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.05f,0.07f,0.05f, 1.0f, 0.0f, sl*0.5f * spec, r_shin, FALSE, 0.0f, amb) ;
	glEndList() ;
*/
	// Glass4
	glNewList(AllocAList(MATERIAL_GLASS4), GL_COMPILE) ;
		SetMaterial(GL_FRONT_AND_BACK, 0.1f,0.14f,0.1f, 1.0f, 0.0f, sl*1.0f * spec, r_shin, FALSE, 0.0f, amb) ;
	glEndList() ;

/*
	// Glass5 環境マップのグラスのハイライト描画用
	glNewList(AllocAList(MATERIAL_GLASS4), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.05f,0.07f,0.05f, 1.0f, 0.0f, 0.5f, 128.0f, IS_SET_M_RATIO, SOLID_M_RATIO) ;
	glEndList() ;
*/

	// Metal Red
	glNewList(AllocAList(MATERIAL_METAL_RED), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.1f,0.1f, 1.0f, 1.0f, /*0.9f*/ 2.0f * specular * spec, 128.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Metal Blue
	glNewList(AllocAList(MATERIAL_METAL_BLUE), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.5f,0.1f,1.0f, 1.0f, 1.0f, /*0.9f*/ 2.0f * specular * spec, 128.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Metal Green
	glNewList(AllocAList(MATERIAL_METAL_GREEN), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.0f,0.6f,0.0f, 1.0f, 1.0f, /*0.9f*/ 2.0f * specular * spec, 128.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Red Gray
	glNewList(AllocAList(MATERIAL_RED_GRAY), GL_COMPILE) ;
		if (reality) SetMaterial(GL_FRONT, 0.8f,0.5f,0.5f, 0.2f, 0.2f, 0.0f) ;
		else if (texture < 3 || solid) SetMaterial(GL_FRONT, 1.0f,0.8f,0.8f, 1.0f, 0.5f, 0.5f * specular * spec, 32.0f, IS_SET_M_RATIO, SOLID_M_RATIO) ;
		else                           SetMaterial(GL_FRONT, 0.9f,0.5f,0.5f, 1.0f, 0.5f, 0.8f * spec, 128.0f) ;
	glEndList() ;

	// 文字盤映り込み用（ボードのディティール）
	if (reflection)
	{
		glNewList(AllocAList(MATERIAL_MIRROR_RED_GRAY), GL_COMPILE) ;
//			SetMaterial(GL_FRONT, 1.0f,0.6f,0.6f, 0.3f, 0.2f, 0.0f) ;
			SetMaterial(GL_FRONT, 1.0f,1.0f,1.0f, 0.3f, 0.2f, 0.0f) ;
		glEndList() ;
	}

	// Specular Iron
	glNewList(AllocAList(MATERIAL_IRON_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.8f,0.8f,0.8f, 0.5f, 1.0f, 3.0f*spec, 2.0f) ;
	glEndList() ;

	// Specular Red
	glNewList(AllocAList(MATERIAL_RED_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.1f,0.1f, 0.5f, 1.0f, 3.0f*spec, 2.0f) ;
	glEndList() ;

	// Specular Gold
	glNewList(AllocAList(MATERIAL_GOLD_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.75f,0.05f, 0.5f, 1.0f, 3.0f*spec, 2.0f) ;
	glEndList() ;

	// Specular Blue
	glNewList(AllocAList(MATERIAL_BLUE_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.5f,0.1f,1.0f, 0.5f, 1.0f, 3.0f*spec, 2.0f) ;
	glEndList() ;

	// Specular Green
	glNewList(AllocAList(MATERIAL_GREEN_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.1f,0.6f,0.2f, 0.5f, 1.0f, 3.0f*spec, 2.0f) ;
	glEndList() ;

	// Specular Red Gray
	glNewList(AllocAList(MATERIAL_RED_GRAY_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.2f,0.2f, 0.2f, 0.9f, spec, 128.0f, FALSE, 0.0f, 8.0f) ;
	glEndList() ;

	// Mat Iron
	glNewList(AllocAList(MATERIAL_MAT_IRON), GL_COMPILE) ;
		if (texture < 3 || solid) SetMaterial(GL_FRONT, 1.0f,1.0f,0.8f, 1.0f, 0.8f, 1.3f * specular * spec, 32.0f, IS_SET_M_RATIO, SOLID_M_RATIO) ;
		else                      SetMaterial(GL_FRONT, 1.0f,1.0f,0.8f, 1.0f, 0.9f, 1.0f * spec, 32.0f) ;
	glEndList() ;

	// Mat Gold
	glNewList(AllocAList(MATERIAL_MAT_GOLD), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,0.75f,0.05f, 1.0f / pre_s_motion * PRE_S_MOTION_A, 0.8f, 1.3f * specular * spec, 32.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Mat Metal Blue
	glNewList(AllocAList(MATERIAL_MAT_METAL_BLUE), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.5f,0.1f,1.0f, 1.0f, 0.8f, 1.3f * specular * spec, 32.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Mat Metal Green
	glNewList(AllocAList(MATERIAL_MAT_METAL_GREEN), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 0.1f,0.6f,0.2f, 1.0f, 0.8f, 1.3f * specular * spec, 32.0f, IS_SET_M_RATIO, METAL_R_M_RATIO) ;
	glEndList() ;

	// Specular
	GLfloat r_spec = 0.8f ;
	r_shin = 128.0f ; amb = (GLfloat)NONE ;
	if (reality) { r_spec = 0.8f ; r_shin = 16.0f ; amb = 1.0f ; }

	glNewList(AllocAList(MATERIAL_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT_AND_BACK, 1.0f,1.0f,1.0f, 1.0f, 1.0f, spec * r_spec, r_shin, FALSE, (GLfloat)NONE, amb) ;
	glEndList() ;

	glNewList(AllocAList(MATERIAL_SEC_SPECULAR), GL_COMPILE) ;
		SetMaterial(GL_FRONT_AND_BACK, 1.0f,1.0f,1.0f, 1.0f, 1.0f, spec * r_spec / pre_s_motion * PRE_S_MOTION_A, r_shin, FALSE, (GLfloat)NONE, amb) ;
	glEndList() ;
}

// 表面ガラスリスト作成
void MakeGlassList()
{
	if (clock_glass)
	{
		int div ;
		if (clock_glass == 1) div = 60 ;
		else                  div = clock_div ;

		glNewList(AllocAList(GLASS_LIST), GL_COMPILE) ;

			if (clock_glass == 3)
			{
/*
				glTranslatef(0.0f, 0.0f, 2.0f) ;
				nm_polygons += DrawGlass(div, 14.4f) ;
				glTranslatef(0.0f, 0.0f, 0.6f) ;
				nm_polygons += DrawGlass(div, 14.4f) ;
*/
				glTranslatef(0.0f, 0.0f, 2.4f) ;
				nm_polygons += DrawGlass(div, 14.4f) ;
			}
			else
			{
				glTranslatef(0.0f, 0.0f, 2.4f) ;
				nm_polygons += DrawGlass(div, 14.4f) ;
			}

		glEndList() ;

		glNewList(AllocAList(ENV_GLASS_LIST), GL_COMPILE) ;

			if (clock_glass == 3)
			{
/*
				glTranslatef(0.0f, 0.0f, 2.0f) ;
				nm_polygons += DrawGlass(div, 14.4f, FALSE) ;
				glTranslatef(0.0f, 0.0f, 0.6f) ;
				nm_polygons += DrawGlass(div, 14.4f, FALSE) ;
*/
				glTranslatef(0.0f, 0.0f, 2.4f) ;
				nm_polygons += DrawGlass(div, 14.4f, FALSE) ;
			}
			else
			{
				glTranslatef(0.0f, 0.0f, 2.4f) ;
				nm_polygons += DrawGlass(div, 14.4f, FALSE) ;
			}

		glEndList() ;
	}
}

// 時計蓋リスト作成
void MakeRoofLists()
{
	glNewList(AllocAList(ROOF_LIST), GL_COMPILE) ;
		glShadeModel(GL_SMOOTH) ;
		glCallList(MATERIAL_MAT_IRON) ;
		SetMaterial(GL_BACK, 1.0f,0.9f,0.05f, 1.0f, 0.95f, 2.0f * spec, 32.0f, IS_SET_M_RATIO, SOLID_M_RATIO) ;
		glColorMaterial(GL_BACK, GL_SPECULAR) ;
		glEnable(GL_COLOR_MATERIAL) ;
		DrawRoof(clock_div, clock_mesh) ;
		glDisable(GL_COLOR_MATERIAL) ;
	glEndList() ;

	glNewList(AllocAList(ENV_ROOF_LIST), GL_COMPILE) ;
		glShadeModel(GL_SMOOTH) ;
		DrawRoof(clock_div, clock_mesh, !(env == 3 || reality || crystal)) ;	// -e 3の時の１回目の描画と -r 1 と -r 2 の二回目とクリスタル はグラデーションなし
	glEndList() ;

/*
	// アンティエイリアシング用のリスト（輝度 = 1 / anti）
	glNewList(AllocAList(ENV_ROOF_ANTI_LIST), GL_COMPILE) ;
		glShadeModel(GL_SMOOTH) ;
		DrawRoof(clock_div, clock_mesh, !(env == 3 || reality || crystal), 1.0f / default_anti, rgrad_anti) ;	// -e 3の時の１回目の描画と -r 1 と -r 2 の二回目とクリスタル はグラデーションなし
	glEndList() ;

	// モーションブラー用のリスト（輝度 = 1 / motion）
	glNewList(AllocAList(ENV_ROOF_MOTION_LIST), GL_COMPILE) ;
		glShadeModel(GL_SMOOTH) ;
		DrawRoof(clock_div, clock_mesh, !(env == 3 || reality || crystal), 1.0f / default_motion, rgrad_motion) ;	// -e 3の時の１回目の描画と -r 1 と -r 2 の二回目とクリスタル はグラデーションなし
	glEndList() ;
*/

	// オーバサンプリング用のリスト（グラデーションを行わないだけの違い）
	glNewList(AllocAList(ENV_ROOF_OVER_LIST), GL_COMPILE) ;
		glShadeModel(GL_SMOOTH) ;
		DrawRoof(clock_div, clock_mesh, FALSE) ;	// -e 3の時の１回目の描画と -r 1 と -r 2 の二回目とクリスタル はグラデーションなし
	glEndList() ;
}

// 時計殻リスト作成
void MakeShellLists()
{
	// 金飾りリスト作成
	MakeGoldenObjectList() ;

	glNewList(AllocAList(SHELL_LIST), GL_COMPILE) ;
		glCallList(MATERIAL_MAT_IRON) ;
		DrawShell(clock_div, clock_mesh) ;

		glCallList(MATERIAL_GOLD) ;
		if (!local && !texture) glShadeModel(GL_FLAT) ;	// !local && !texture の時はフラット
		if (!reality) DrawGoldenObjects(14.6f, n_golden) ;
	glEndList() ;

	// 鏡の場合は、殻と金飾りは別のリストにする（ただし色をセットして連続で呼び出す）
	glNewList(AllocAList(ENV_SHELL_LIST), GL_COMPILE) ;
		DrawShell(clock_div, clock_mesh) ;
	glEndList() ;

	glNewList(AllocAList(ENV_GOLDEN_OBJECTS_LIST), GL_COMPILE) ;
		if (!local && !texture) glShadeModel(GL_FLAT) ;	// !local && !texture の時はフラット
		DrawGoldenObjects(14.6f, n_golden) ;
	glEndList() ;

	// 文字盤に映り込む周囲の壁リスト作成
	glNewList(AllocAList(MIRROR_WALL_LIST), GL_COMPILE) ;
		SetMaterial(GL_FRONT, 1.0f,1.0f,0.8f, 0.5f, 0.8f, 1.3f * specular * spec, 1.0f, TRUE, 0.2f) ;

		if (DONOT_USE_ALPHA_GOURAUD)
		{
			DrawMirrorWall(clock_div, FALSE) ; // アルファグローなし（RIVA, PERMEDIA2 など）
		}
		else
		{
			glColorMaterial(GL_FRONT, GL_DIFFUSE) ;
			glEnable(GL_COLOR_MATERIAL) ;
			DrawMirrorWall(clock_div, TRUE, 0.7f, 0.1f) ; // アルファグロー
			glDisable(GL_COLOR_MATERIAL) ;
		}
	glEndList() ;

	glNewList(AllocAList(ENV_MIRROR_WALL_LIST), GL_COMPILE) ;
		DrawMirrorWall(clock_div, FALSE) ;
	glEndList() ;
}

// 文字盤リスト作成
void MakeBoardLists()
{
	MakeClockPointList() ;	// 文字盤上の小さい粒々
	MakeMList() ;			// Ｍ

	glNewList(AllocAList(BOARD_LIST), GL_COMPILE) ;

		glPushMatrix() ;
			glCallList(MATERIAL_RED_GRAY) ;
			if (!local) glShadeModel(GL_SMOOTH) ;
			DrawBoard(clock_div, 15.0f) ;

			// 映り込み時はディティールを別リストに
			if (!reflection)
			{
				glPushMatrix() ;
					glTranslatef(0.0f,5.0f,0.0f) ;
					glCallList(M_LIST) ;
				glPopMatrix() ;

//				if (!local) glShadeModel(GL_SMOOTH) ;
				glTranslatef(0.0f,0.0f,0.0001f) ;
				if (clock_point) DrawClockPoints(radius_ratio * BITS_RADIUS) ;
		       	}
		glPopMatrix() ;

	glEndList() ;

	glNewList(AllocAList(ENV_BOARD_LIST), GL_COMPILE) ;

		glPushMatrix() ;
			if (!local) glShadeModel(GL_SMOOTH) ;
			DrawBoard(clock_div, 15.0f) ;

			// 映り込み時はディティールを別リストに
			if (!reflection)
			{
				glPushMatrix() ;
					glTranslatef(0.0f,5.0f,0.0f) ;
					glCallList(M_LIST) ;
				glPopMatrix() ;

//				if (!local) glShadeModel(GL_SMOOTH) ;
				glTranslatef(0.0f,0.0f,0.0001f) ;
				if (clock_point) DrawClockPoints(radius_ratio * BITS_RADIUS) ;
			}
		glPopMatrix() ;

	glEndList() ;

	// 映り込み時はディティールを別リストに
	if (reflection)
	{
		glNewList(AllocAList(BOARD_DETAIL_LIST), GL_COMPILE) ;
			glCallList(MATERIAL_RED_GRAY) ;
			glPushMatrix() ;
				glTranslatef(0.0f,5.0f,0.0f) ;
				glCallList(M_LIST) ;
			glPopMatrix() ;

//			if (!local) glShadeModel(GL_SMOOTH) ;
			glTranslatef(0.0f,0.0f,0.0001f) ;
			if (clock_point) DrawClockPoints(radius_ratio * BITS_RADIUS) ;
		glEndList() ;

		glNewList(AllocAList(ENV_BOARD_DETAIL_LIST), GL_COMPILE) ;
			glPushMatrix() ;
				glTranslatef(0.0f,5.0f,0.0f) ;
				glCallList(M_LIST) ;
			glPopMatrix() ;

//			if (!local) glShadeModel(GL_SMOOTH) ;
			glTranslatef(0.0f,0.0f,0.0001f) ;
			if (clock_point) DrawClockPoints(radius_ratio * BITS_RADIUS) ;
		glEndList() ;
	}
}

// 映り込み用の s, t 座標系をセット
void SetMirrorTexturePlaneST()
{
	glTexGenfv(GL_S, GL_OBJECT_PLANE, ms.v);
	glTexGenfv(GL_S, GL_OBJECT_PLANE, mt.v);
}

// イメージテーブルからテクスチャをセット
void SetTextureImage(TRUEIMAGE *image)
{
	GLint  err, bits = 3 ;
	GLenum tformat = GL_RGB ;

	if (tex_format == String("RGBA"))
	{
		tformat = GL_RGBA ;
		bits = 4 ;
		RGBtoRGBA(image, DEFAULT_ALPHA) ;
	}

	glPixelTransferi(GL_MAP_COLOR, GL_FALSE) ;

	if (gl_min_filter != GL_NEAREST && gl_min_filter != GL_LINEAR)
	{
		if (err = gluBuild2DMipmaps(GL_TEXTURE_2D, bits, image->width, image->height, tformat, GL_UNSIGNED_BYTE, image->dataptr))
		{
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
			exit(1) ;
		}
	}
	else
	{
//		glBindTexture(GL_TEXTURE_2D, AllocATexture(TEXTURE_NAME)) ;
		glTexImage2D(GL_TEXTURE_2D, 0, bits, image->width, image->height, 0, tformat, GL_UNSIGNED_BYTE, image->dataptr) ;
//		glBindTexture(GL_TEXTURE_2D, TEXTURE_NAME) ;
	}

	if (no_message) return ;

	if (!solid)
	{
		if (crystal == 1)
			cout << "Transparency environment mapping." << endl ;
		else
		{
			switch(texture)
			{
			case 1:
				cout << "Environment mapping." << endl ; break ;
			case 2:
				cout << "Shading environment mapping." << endl ; break ;
			case 3:
				cout << "Environment mapping and shading." << endl ; break ;
			}
		}
	}
	else if (!reality)
	{
		switch(texture)
		{
		case 1:
			cout << "Solid mapping." << endl ; break ;
		case 2:
			cout << "Shading solid mapping." << endl ; break ;
		case 3:
			cout << "Diffuse shading solid mapping and specular shading." << endl ; break ;
		}
	}
	else
	{
		switch (reality)
		{
		case 1:
			cout << "Solid and environment mapping." << endl ; break ;
		case 2:
			cout << "Diffuse shading solid mapping and environment mapping." << endl ; break ;
		case 3:
			cout << "Diffuse shading solid mapping and specular shading environment mapping." << endl ; break ;
		}
	}

	cout << "Texture " ;
	switch (gl_min_filter)
	{
	case GL_NEAREST:
		cout << "point filtering." << endl ; break ;
	case GL_LINEAR:
		cout << "bi-linear filtering." << endl ; break ;
	case GL_NEAREST_MIPMAP_NEAREST:
		cout << "point mip-map point filtering." << endl ; break ;
	case GL_LINEAR_MIPMAP_NEAREST:
		cout << "bi-linear mip-map point filtering." << endl ; break ;
	case GL_NEAREST_MIPMAP_LINEAR:
		cout << "point mip-map linear filtering." << endl ; break ;
	case GL_LINEAR_MIPMAP_LINEAR:
		cout << "bi-linear mip-map linear(tri-linear) filtering." << endl ; break ;
	}
}

// テクスチャ座標セット（-e,-r オプション用環境テクスチャ座標設定）
void TextureCoordListProc(GLfloat x, GLfloat y, GLfloat w, GLfloat h)
{
	glLoadIdentity() ;

	glTranslatef(x, y, 0.0f) ;
	glScalef(w, h, 1.0f) ;
}

// テクスチャの座標、生成関数等セット（-r オプション用テクスチャ切り替えリスト）
void TextureListProc(GLenum tex_mode = GL_SPHERE_MAP, GLfloat x = 0.0f, GLfloat y = 0.0f, GLfloat w = 1.0f, GLfloat h = 1.0f)
{
	if (tex_mode == GL_OBJECT_LINEAR)
	{
		glTexGenfv(GL_S, GL_OBJECT_PLANE, s.v);
		glTexGenfv(GL_S, GL_OBJECT_PLANE, t.v);

		glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR) ;
		glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR) ;

		// ソリッドテクスチャ用に行列をセット
		glMatrixMode(GL_TEXTURE) ;

		TextureCoordListProc(x,y, w,h) ;

		glTranslatef(0.5f, 0.5f, 0.0f) ;
		glScalef(1.0f / s_scale, 1.0f / t_scale, 1.0f) ;
		glRotatef(20.0f, 0.0f,0.0f,1.0f) ;
	}
	else if (tex_mode == GL_SPHERE_MAP)
	{
		glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP) ;
		glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP) ;

		// 環境テクスチャ用に行列をセット
		glMatrixMode(GL_TEXTURE) ;
		TextureCoordListProc(x,y, w,h) ;

/*
		glMatrixMode(GL_TEXTURE) ;
		glLoadIdentity() ;

		glTranslatef(0.5f, 0.0f, 0.0f) ;
		glScalef(0.5f, 1.0f, 1.0f) ;
*/
	}
}

void TextureProc(TRUEIMAGE *image, GLenum tex_mode = GL_SPHERE_MAP)
{
	SetTextureImage(image) ;
	FreeUsedImages() ;

	if (tex_mode == GL_OBJECT_LINEAR)
	{
		glTexGenfv(GL_S, GL_OBJECT_PLANE, s.v);
		glTexGenfv(GL_S, GL_OBJECT_PLANE, t.v);

		glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR) ;
		glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_OBJECT_LINEAR) ;

		// ソリッドテクスチャ用に行列をセット
		glMatrixMode(GL_TEXTURE) ;
		glLoadIdentity() ;

		glTranslatef(0.5f, 0.5f, 0.0f) ;
		glRotatef(20.0f, 0.0f,0.0f,1.0f) ;
		glScalef(1.0f / s_scale, 1.0f / t_scale, 1.0f) ;
	}
	else if (tex_mode == GL_SPHERE_MAP)
	{
		glTexGenf(GL_S, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP) ;
		glTexGenf(GL_T, GL_TEXTURE_GEN_MODE, GL_SPHERE_MAP) ;

		// テクスチャ行列を単位行列に
		glMatrixMode(GL_TEXTURE) ;
		glLoadIdentity() ;
	}

	glEnable(GL_TEXTURE_GEN_S) ;
	glEnable(GL_TEXTURE_GEN_T) ;
}

// ppm 画像の読み込み
void LoadTextureImage(TRUEIMAGE **image, String &name)
{
	FILE   *fp ;
	char   *e_path ;
	String env_path ;

	if (!(fp = fopen(name, "rb")))
	{
		if (!(e_path = getenv(ENV_IMAGE_PATH)))
		{
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T(String("Can't open file ") + name + "."), _T("Loading Image Error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "Can't open file " << name << "." << endl ;
			exit(1) ;
		}
		env_path = e_path ;
		env_path.Cut() ;

#ifdef WIN32
		if (Right(env_path) != '\\') env_path += '\\' ;
#else
		if (Right(env_path) != '/') env_path += '/' ;
#endif

		if (!(fp = fopen(env_path + name, "rb")))
		{
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T(String("Can't open file ") + name + "."), _T("Loading Image Error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "Can't open file " << name << "." << endl ;
			exit(1) ;
		}
	}

	if (!(*image = finputpnm(fp)))
	{
		fclose(fp) ;
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T(env_path + name + " is not ppm format."), _T("Image Format Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << env_path << name << " is not ppm format." << endl ;
		exit(1) ;
	}

	fclose(fp) ;
}

// テクスチャ共通設定
void SetTexture()
{
	glPixelStorei(GL_UNPACK_ALIGNMENT,1) ;

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_S, GL_REPEAT) ;
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_WRAP_T, GL_REPEAT) ;

	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, gl_mag_filter) ;
	glTexParameteri(GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, gl_min_filter) ;

	glTexEnvf(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE) ;
//	glEnable(GL_TEXTURE_2D) ;
}

// イメージを ２の n乗 サイズにスケーリング（最大サイズを越える場合は最大サイズに）
void ScaleTextureImage(TRUEIMAGE ** image, int n = 0)
{
	GLint max_size, width, height, err ;
	TRUEIMAGE *s_image ;

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_size) ;	// テクスチャの最大サイズ
	width  = (*image)->width ;
	height = (*image)->height ;

	if (width  > max_size) width  = max_size ;
	if (height > max_size) height = max_size ;

	if (width == (*image)->width && height == (*image)->height && n == 0) return ;

	if (n > 0) width = height = Pow(2, n) ;
	if (width > max_size || n < 0) width = height = max_size ;

	if (!(s_image = (TRUEIMAGE*)malloc(sizeof(TRUEIMAGE))))
	{
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T("Cant't allocate memory."), _T("glclock error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "Can't allocate memory." << endl ;
		exit(1) ;
	}

	if (!(s_image->dataptr = (unsigned char *)malloc(width * height * 3)))
	{
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T("Cant't allocate memory."), _T("glclock error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "Can't allocate memory." << endl ;
		exit(1) ;
	}

	if (!no_message) cout << "Scaling texture image." << endl ;

	if (err = gluScaleImage(GL_RGB, (*image)->width, (*image)->height, GL_UNSIGNED_BYTE, (*image)->dataptr, width,height, GL_UNSIGNED_BYTE, s_image->dataptr))
	{
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
		FreeImage(&s_image) ;
		exit(1) ;
	}

	if (!no_message) cout << "Using " << width << "x" << height << " image." << endl ;

	s_image->width  = width ;
	s_image->height = height ;

	freeimage(*image) ;
	*image = s_image ;
}

// ２枚のイメージから、左右に分割した１枚のイメージを作成
TRUEIMAGE *CreateImageFrom2Images(TRUEIMAGE* solid_image, TRUEIMAGE* env_image)
{
	GLint     max_size, image_size, width, height, pixels, err ;
	unsigned  char *s_image, *e_image ;
	TRUEIMAGE *image ;

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_size) ;	// テクスチャの最大サイズ

	// 最も大きいサイズに合わせる
	image_size = solid_image->width ;
	image_size = (solid_image->height > image_size ? solid_image->height : image_size) ;
	image_size = (env_image->width > image_size ? env_image->width : image_size) ;
	image_size = (env_image->height > image_size ? env_image->height : image_size) ;

/*
	if (image_size * 2 > max_size) return (TRUEIMAGE *)NULL ;
	else
	{
		for (width = 64 ; width < image_size ; width *= 2) ;
		height = width ;
	}
	pixels = width * height ;
*/
//
	for (width = 64 ; width < image_size ; width *= 2) ;
	height = width ;
	pixels = width * height ;
//

	if (!(s_image = (unsigned char*)malloc(pixels * 3))) return (TRUEIMAGE *)NULL ;
	if (!(e_image = (unsigned char*)malloc(pixels * 3))) return (TRUEIMAGE *)NULL ;

	err = gluScaleImage(GL_RGB, solid_image->width, solid_image->height, GL_UNSIGNED_BYTE, solid_image->dataptr, width,height, GL_UNSIGNED_BYTE, s_image) ;
	if (err)
	{
		free(s_image) ;
		free(e_image) ;
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
		exit(1) ;
	}

	err = gluScaleImage(GL_RGB, env_image->width, env_image->height, GL_UNSIGNED_BYTE, env_image->dataptr, width,height, GL_UNSIGNED_BYTE, e_image) ;
	if (err)
	{
		free(s_image) ;
		free(e_image) ;
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
		exit(1) ;
	}

//	cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;

	if (!(image = (TRUEIMAGE*)malloc(sizeof(TRUEIMAGE)))) return (TRUEIMAGE *)NULL ;

	image->width  = width * 2 ;
	image->height = height ;

	if (!(image->dataptr = (unsigned char *)malloc(pixels * 2 * 3))) return (TRUEIMAGE *)NULL ;

	// イメージのつなぎ合わせ
	for (int y = 0 ; y < height ; y ++)
	{
		int x ;

		// ソリッドイメージから偶数ラスタにデータ入力（左上）
		for (x = 0 ; x < width ; x ++)
		{
			image->dataptr[y * width * 2 * 3 + x * 3] = s_image[y * width * 3 + x * 3] ;
			image->dataptr[y * width * 2 * 3 + x * 3 + 1] = s_image[y * width * 3 + x * 3 + 1] ;
			image->dataptr[y * width * 2 * 3 + x * 3 + 2] = s_image[y * width * 3 + x * 3 + 2] ;

		}

		// 環境イメージから奇数ラスタにデータ入力（右上）
		for (x = 0 ; x < width ; x ++)
		{
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3] = e_image[y * width * 3 + x * 3] ;
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3 + 1] = e_image[y * width * 3 + x * 3+ 1] ;
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3 + 2] = e_image[y * width * 3 + x * 3 + 2] ;

		}
	}

	free(s_image) ;
	free(e_image) ;

	return image ;
}

// ３枚（ソリッド、環境、ソリッド２）のイメージから、左右および上下に分割した１枚のイメージを作成
TRUEIMAGE *CreateImageFrom2Images2(TRUEIMAGE* solid_image, TRUEIMAGE* env_image, TRUEIMAGE* solid2_image = NULL)
{
	GLint     max_size, image_size, width, height, pixels, err ;
	unsigned  char *s_image, *e_image, *s2_image ;
	TRUEIMAGE *image ;

	glGetIntegerv(GL_MAX_TEXTURE_SIZE, &max_size) ;	// テクスチャの最大サイズ

	// 最も大きいサイズに合わせる
	image_size = solid_image->width ;
	image_size = (solid_image->height > image_size ? solid_image->height : image_size) ;
	image_size = (env_image->width > image_size ? env_image->width : image_size) ;
	image_size = (env_image->height > image_size ? env_image->height : image_size) ;
	if (solid2_image)
	{
		image_size = (solid2_image->width > image_size ? solid2_image->width : image_size) ;
		image_size = (solid2_image->height > image_size ? solid2_image->height : image_size) ;
	}
/*
	if (image_size * 2 > max_size) return (TRUEIMAGE *)NULL ;
	else
	{
		for (width = 64 ; width < image_size ; width *= 2) ;
		height = width ;
	}
	pixels = width * height ;
*/
//
	for (width = 64 ; width < image_size ; width *= 2) ;
	height = width ;
	pixels = width * height ;
//

	if (!(s_image = (unsigned char*)malloc(pixels * 3))) return (TRUEIMAGE *)NULL ;
	if (!(e_image = (unsigned char*)malloc(pixels * 3))) return (TRUEIMAGE *)NULL ;
	if (solid2_image)
		if (!(s2_image = (unsigned char*)malloc(pixels * 3))) return (TRUEIMAGE *)NULL ;

	err = gluScaleImage(GL_RGB, solid_image->width, solid_image->height, GL_UNSIGNED_BYTE, solid_image->dataptr, width,height, GL_UNSIGNED_BYTE, s_image) ;
	if (err)
	{
		free(s_image) ;
		free(e_image) ;
		EndProc() ;
#ifdef WIN32
		MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
		exit(1) ;
	}

	err = gluScaleImage(GL_RGB, env_image->width, env_image->height, GL_UNSIGNED_BYTE, env_image->dataptr, width,height, GL_UNSIGNED_BYTE, e_image) ;
	if (err)
	{
#ifdef WIN32
		MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
		cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
		free(s_image) ;
		free(e_image) ;
		EndProc() ;
		exit(1) ;
	}

	if (solid2_image)
	{
		err = gluScaleImage(GL_RGB, solid2_image->width, solid2_image->height, GL_UNSIGNED_BYTE, solid2_image->dataptr, width,height, GL_UNSIGNED_BYTE, s2_image) ;
		if (err)
		{
			free(s_image) ;
			free(e_image) ;
			free(s2_image) ;
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T((char *)gluErrorString((GLenum)err)), _T("GLU Error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "GLU Error: " << (char *)gluErrorString((GLenum)err) << endl ;
			exit(1) ;
		}
	}
	else
		s2_image = s_image ;

	if (!(image = (TRUEIMAGE*)malloc(sizeof(TRUEIMAGE)))) return (TRUEIMAGE *)NULL ;

	image->width  = width  * 2 ;
	image->height = height * 2;

	if (!(image->dataptr = (unsigned char *)malloc(pixels * 2 * 2 * 3))) return (TRUEIMAGE *)NULL ;

	// イメージのつなぎ合わせ
	for (int y = 0 ; y < height ; y ++)
	{
		int x ;

		// ソリッドイメージから偶数ラスタにデータ入力
		for (x = 0 ; x < width ; x ++)
		{
			image->dataptr[y * width * 2 * 3 + x * 3] = s_image[y * width * 3 + x * 3] ;
			image->dataptr[y * width * 2 * 3 + x * 3 + 1] = s_image[y * width * 3 + x * 3 + 1] ;
			image->dataptr[y * width * 2 * 3 + x * 3 + 2] = s_image[y * width * 3 + x * 3 + 2] ;

		}

		// ソリッドイメージから偶数ラスタにデータ入力（左下）
		for (x = 0 ; x < width ; x ++)
		{
			image->dataptr[(y + height) * width * 2 * 3 + x * 3] = s2_image[y * width * 3 + x * 3] ;
			image->dataptr[(y + height) * width * 2 * 3 + x * 3 + 1] = s2_image[y * width * 3 + x * 3 + 1] ;
			image->dataptr[(y + height) * width * 2 * 3 + x * 3 + 2] = s2_image[y * width * 3 + x * 3 + 2] ;

		}

		// 環境イメージから奇数ラスタにデータ入力
		for (x = 0 ; x < width ; x ++)
		{
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3] = e_image[y * width * 3 + x * 3] ;
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3 + 1] = e_image[y * width * 3 + x * 3+ 1] ;
			image->dataptr[y * width * 2 * 3 + width * 3 + x * 3 + 2] = e_image[y * width * 3 + x * 3 + 2] ;

			// 環境イメージから奇数ラスタにデータ入力（右下）
			image->dataptr[(y + height) * width * 2 * 3 + width * 3 + x * 3] = e_image[y * width * 3 + x * 3] ;
			image->dataptr[(y + height) * width * 2 * 3 + width * 3 + x * 3 + 1] = e_image[y * width * 3 + x * 3+ 1] ;
			image->dataptr[(y + height) * width * 2 * 3 + width * 3 + x * 3 + 2] = e_image[y * width * 3 + x * 3 + 2] ;

		}
	}

	free(s_image) ;
	free(e_image) ;
	if (solid2_image)
		free(s2_image) ;

	return image ;
}

void MakeTextureLists()
{
	if (solid && !reality)	// -s オプション時
	{
		if (!no_message) cout << "Setting solid texture from " << solid_file << "." << endl ;
		LoadTextureImage(&solid_image, solid_file) ;
		ScaleTextureImage(&solid_image, tex_size) ;
		TextureProc(solid_image, GL_OBJECT_LINEAR) ;

		glEnable(GL_TEXTURE_2D) ;
	}
	else if (!reality)	// -e オプション時
	{
		if (!no_message) cout << "Setting environment texture from " << env_file << "." << endl ;
		LoadTextureImage(&env_image, env_file) ;

		if (!(create_image = CreateImageFrom2Images(env_image, env_image)))
		{
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T("Can't Create Texture Image."), _T("Createing Image error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "Can't Create Texture Image." << endl ;
			exit(1) ;
		}
		FreeImage(&env_image) ;

		// ガンマコレクション（本体用）
		if (env == 1)
		{
			GammaCollect(create_image, 0.3f, create_image->width / 2) ;	// ガンマコレクション（ガラス用）
			ChangeBright(create_image, 0.7f, create_image->width / 2) ;	// ガンマコレクション（ガラス用）
		}
		else if (!crystal)
		{
			GammaCollect(create_image, 0.3f, create_image->width / 2) ;
		}
		else
		{
			GammaCollect(create_image, 0.3f, 0,0, create_image->width / 2) ;
			GammaCollect(create_image, 0.3f, create_image->width / 2) ;
		}

		ScaleTextureImage(&create_image, tex_size) ;

		TextureProc(create_image, GL_SPHERE_MAP) ;
		TextureListProc(GL_SPHERE_MAP, 0.0f,0.0f, 0.5f,1.0f) ;

		glNewList(AllocAList(ENV_GLASS_TEXTURE_LIST), GL_COMPILE) ;
			TextureCoordListProc(0.5f,0.0f, 0.5f,1.0f) ;
		glEndList() ;

		glEnable(GL_TEXTURE_2D) ;
	}
	else	// -r オプション時（テクスチャの合成）
	{
		int solid2_flag = (sld2_file != String("")) ;

		if (solid2_flag && !no_message) cout << "Setting solid and environment texture from " << solid_file << " and " << sld2_file << " and " << env_file << "." << endl ;
		else if (!no_message) cout << "Setting solid and environment texture from " << solid_file << " and " << env_file << "." << endl ;
		LoadTextureImage(&solid_image, solid_file) ;
		LoadTextureImage(&env_image, env_file) ;
		if (solid2_flag)
			LoadTextureImage(&solid2_image, sld2_file) ;

		if (!(create_image = CreateImageFrom2Images2(solid_image, env_image, solid2_flag ? solid2_image : NULL)))
		{
			EndProc() ;
#ifdef WIN32
			MessageBox(NULL, _T("Can't Create Texture Image."), _T("Createing Image error"), MB_OK | MB_ICONSTOP) ;
#endif
			cerr << "Can't Create Texture Image." << endl ;
			exit(1) ;
		}
		FreeImage(&solid_image) ;
		FreeImage(&env_image) ;
		FreeImage(&solid2_image) ;

		GammaCollect(create_image, 0.3f, create_image->width / 2, 0, create_image->width / 2, create_image->height / 2) ;	// ガンマコレクション（ラップ用）
		ChangeBright(create_image, 0.7f, create_image->width / 2, 0, create_image->width / 2, create_image->height / 2) ;	// ガンマコレクション（ラップ用）

		ScaleTextureImage(&create_image, tex_size) ;
		TextureProc(create_image) ;

		glNewList(AllocAList(SOLID_TEXTURE_LIST), GL_COMPILE) ;
			TextureListProc(GL_OBJECT_LINEAR, 0.0f,0.0f, 0.5f,0.5f) ;
			glMatrixMode(GL_MODELVIEW) ;	// 行列モードをモデルビューに戻す
		glEndList() ;

		glNewList(AllocAList(ENV_TEXTURE_LIST), GL_COMPILE) ;
			TextureListProc(GL_SPHERE_MAP, 0.5f,0.0f, 0.5f,0.5f) ;
			glMatrixMode(GL_MODELVIEW) ;	// 行列モードをモデルビューに戻す
		glEndList() ;

		glNewList(AllocAList(SOLID2_TEXTURE_LIST), GL_COMPILE) ;
			TextureCoordListProc(0.0f,0.5f, 0.5f,0.5f) ;
			glTranslatef(0.5f, 0.5f, 0.0f) ;
			glScalef(1.0f / s_scale, 1.0f / t_scale, 1.0f) ;
		glEndList() ;

		glNewList(AllocAList(CHROME_TEXTURE_LIST), GL_COMPILE) ;
			TextureCoordListProc(0.5f,0.5f, 0.5f,0.5f) ;
		glEndList() ;
	}
}

// 各ディスプレイリスト作成
void MakeDisplayLists()
{
/*
	// 未定義のディスプレイリスト確保
	if (!(base = glGenLists(NM_LISTS)))
	{
		cerr << "Can't allocate Display Lists." << endl ;
		EndProc() ;
		exit(1) ;
	}
*/

	MakeMaterialLists() ;		// 材質リスト作成
	MakeClockNeedleLists() ;	// 時計針リスト
	MakePolyhedronLists() ;		// 正多面体リスト作成
	MakeShellLists() ;			// 時計殻リスト作成
	MakeRoofLists() ;			// 蓋リスト
	MakeBoardLists() ;			// 文字盤リスト作成
	MakeGlassList() ;			// 表面ガラスリスト作成
	MakeSignList() ;			// 右下のサインリスト作成

	if (texture) MakeTextureLists() ;	// テクスチャ生成用リスト作成
	else if (!no_message) cout << "Normal shading." << endl ;
}

// 望遠、広角処理
void SetPerspective(ClockState& st, GLfloat px = 0.0f, GLfloat py = 0.0f)
{
	float pers = 1.0f / st.pers ;

	// クリッピング距離計算
	far_clip = (near_clip = -st.clock_z - 40.0f) + 80.0f ;
	if (near_clip < pers)
		if ((near_clip = pers) >= far_clip) far_clip = near_clip + 0.01f ;

	if (xsize > ysize) { scr_w = (GLfloat)xsize / ysize ; scr_h = 1.0f ; }
	else               { scr_h = (GLfloat)ysize / xsize ; scr_w = 1.0f ; }

	// スクリーンサイズセット（ニア・クリップ面のサイズ）
	scr_w *= st.pers * near_clip ;
	scr_h *= st.pers * near_clip ;

	Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, px,py) ;	// 視野ピラミッド作成
	glMatrixMode(GL_MODELVIEW) ;	// 行列モードをモデルビューに戻す
}

/*
// サインおよびＦＰＳ描画
void DrawSignAndFPS()
{
	glPushAttrib(GL_ENABLE_BIT) ;

		glDisable(GL_LIGHTING) ;
		glDisable(GL_FOG) ;
		glDisable(GL_TEXTURE_2D) ;	// テクスチャＯＦＦ
		glDisable(GL_DEPTH_TEST) ;	// デプステストＯＦＦ（必ず表示）

		glPushMatrix() ;
		glLoadIdentity() ;	// モデルビュー行列を単位行列に

		glMatrixMode(GL_PROJECTION) ;
			glLoadIdentity() ;	// 射影行列を単位行列に

			if (!benchmark)
			{
				// ベンチマークモードではない場合
				glColor3f(currentCL[0]*0.7f, currentCL[0]*0.7f, currentCL[0]*0.7f) ;	// 現在のライト色の７割の輝度で

				// サイン描画
				if (!no_sign) DrawString(sign, (sign_x - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
										 (sign_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
										 GLUT_BITMAP_TIMES_ROMAN_10) ;
				// ＦＰＳ描画
				if (f_prn) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
									  (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
									  GLUT_BITMAP_8_BY_13) ;

				// マウスカーソル描画
				if (voodoo && (DragL || DragR)) DrawCharacter('+', ((mouse_x - 4) - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
															  ((ysize - (mouse_y + 5)) - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;

				glColor3fv(currentCL) ;		// 現在のライト色で

				// サイン描画
				if (!no_sign) DrawString(sign, (sign_x - xsize * 0.5f) / xsize * 2.0f,
										 (sign_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
										 GLUT_BITMAP_TIMES_ROMAN_10) ;
				// ＦＰＳ描画
				if (f_prn) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f,
									  (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
									  GLUT_BITMAP_8_BY_13) ;
				// マウスカーソル描画
				if (voodoo && (DragL || DragR)) DrawCharacter('+', ((mouse_x - 4) - xsize * 0.5f) / xsize * 2.0f,
															  ((ysize - (mouse_y + 5)) - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;
			}
			else
			{
				// ベンチマークモードの場合はＦＰＳのみ表示

				glColor3fv(currentCL) ;		// 現在のライト色で

				// ＦＰＳ描画
				if (f_prn || benchmark) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f,
												   (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
												   GLUT_BITMAP_8_BY_13) ;
			}

		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;
		glPopMatrix() ;

	glPopAttrib() ;
}
*/

// サインおよびＦＰＳ描画
void DrawSignAndFPS()
{
	glPushAttrib(GL_ENABLE_BIT) ;

		glDisable(GL_LIGHTING) ;
		glDisable(GL_FOG) ;
		glDisable(GL_TEXTURE_2D) ;	// テクスチャＯＦＦ
		glDisable(GL_DEPTH_TEST) ;	// デプステストＯＦＦ（必ず表示）

		glPushMatrix() ;
		glLoadIdentity() ;	// モデルビュー行列を単位行列に

		glMatrixMode(GL_PROJECTION) ;
			glLoadIdentity() ;	// 射影行列を単位行列に

			if (!benchmark)
			{
				// ベンチマークモードではない場合
				glColor3f(currentCL[0]*0.7f, currentCL[0]*0.7f, currentCL[0]*0.7f) ;	// 現在のライト色の７割の輝度で

				// サイン描画
				if (!no_sign)
				{
					glRasterPos3f((sign_x - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
								  (sign_y - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;
					glCallList(SIGN_LIST) ;
				}

				// ＦＰＳ描画
				if (f_prn) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
									  (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
									  GLUT_BITMAP_8_BY_13) ;

				// マウスカーソル描画
				if (voodoo && (DragL || DragR)) DrawCharacter('+', ((mouse_x - 4) - xsize * 0.5f) / xsize * 2.0f + 2.0f / xsize,
															  ((ysize - (mouse_y + 5)) - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;

				glColor3fv(currentCL) ;		// 現在のライト色で

				// サイン描画
				if (!no_sign)
				{
					glRasterPos3f((sign_x - xsize * 0.5f) / xsize * 2.0f,
								  (sign_y - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;
					glCallList(SIGN_LIST) ;
				}

				// ＦＰＳ描画
				if (f_prn) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f,
									  (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
									  GLUT_BITMAP_8_BY_13) ;
				// マウスカーソル描画
				if (voodoo && (DragL || DragR)) DrawCharacter('+', ((mouse_x - 4) - xsize * 0.5f) / xsize * 2.0f,
															  ((ysize - (mouse_y + 5)) - ysize * 0.5f) / ysize * 2.0f, 0.0f) ;
			}
			else
			{
				// ベンチマークモードの場合はＦＰＳのみ表示

				glColor3fv(currentCL) ;		// 現在のライト色で

				// ＦＰＳ描画
				if (f_prn || benchmark) DrawString(s_fps, (fps_x - xsize * 0.5f) / xsize * 2.0f,
												   (fps_y - ysize * 0.5f) / ysize * 2.0f, 0.0f,
												   GLUT_BITMAP_8_BY_13) ;
			}

		glPopMatrix() ;
		glMatrixMode(GL_MODELVIEW) ;
		glPopMatrix() ;

	glPopAttrib() ;
}


// モデル描画、行列セット、回転の累積（モーションブラ用）
// これは補助バッファを使わない描画用
void DrawModelMatrixWithOverSampling(ClockState p, ClockState& st, int count)
{
	// 描く順序を決定 とりあえず count の順序で良し
	// 最終的には、端から順に描画の方が良い
	int ratio_no = count ;


	GLfloat f_r = 1.0f - shutter, r_step = shutter / (motion - 1), sp_x = spin_x, sp_y = spin_y, ratio ;

	ratio = f_r + r_step * ratio_no ;
	if (!ratio_no)
	{
		sp_x *= f_r ;
		sp_y *= f_r ;
	}
	else
	{
		sp_x *= r_step ;
		sp_y *= r_step ;
	}

	p.tm.hour   += (st.tm.hour   - p.tm.hour  ) * ratio ;
	p.tm.minute += (st.tm.minute - p.tm.minute) * ratio ;
	p.tm.second += (st.tm.second - p.tm.second) * ratio ;

	p.h_rotate  += (st.h_rotate  - p.h_rotate ) * ratio ;
	p.g_spin    += (st.g_spin    - p.g_spin   ) * ratio ;

	p.roof      += (st.roof      - p.roof     ) * ratio ;

	p.clock_z   += (st.clock_z   - p.clock_z  ) * ratio ;
	p.pers      += (st.pers      - p.pers     ) * ratio ;

	glMatrixMode(GL_PROJECTION) ;
	SetPerspective(p) ;

	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, p.clock_z) ;	// ｚ軸移動

		glPushMatrix() ;

			glLoadIdentity() ;

			glRotatef(sp_x, 0.0f,1.0f,0.0f) ;	// ｙ軸回転
			glRotatef(sp_y, 1.0f,0.0f,0.0f) ;	// ｘ軸回転

			glMultMatrixf(aRotate) ;
			glGetFloatv(GL_MODELVIEW_MATRIX, aRotate) ;

		glPopMatrix() ;

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -p.roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		DrawClock(p, count) ;

	glPopMatrix() ;
}

// モデル描画、行列セット、回転の累積（モーションブラ用）
void DrawModelMatrix(ClockState p, ClockState& st, int count)
{
	GLfloat f_r = 1.0f - shutter, r_step = shutter / (motion - 1), sp_x = spin_x, sp_y = spin_y, ratio ;

	ratio = f_r + r_step * count ;
	if (!count)
	{
		sp_x *= f_r ;
		sp_y *= f_r ;
	}
	else
	{
		sp_x *= r_step ;
		sp_y *= r_step ;
	}

	p.tm.hour   += (st.tm.hour   - p.tm.hour  ) * ratio ;
	p.tm.minute += (st.tm.minute - p.tm.minute) * ratio ;
	p.tm.second += (st.tm.second - p.tm.second) * ratio ;

	p.h_rotate  += (st.h_rotate  - p.h_rotate ) * ratio ;
	p.g_spin    += (st.g_spin    - p.g_spin   ) * ratio ;

	p.roof      += (st.roof      - p.roof     ) * ratio ;

	p.clock_z   += (st.clock_z   - p.clock_z  ) * ratio ;
	p.pers      += (st.pers      - p.pers     ) * ratio ;

	glMatrixMode(GL_PROJECTION) ;
	SetPerspective(p) ;

	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, p.clock_z) ;	// ｚ軸移動

		glPushMatrix() ;

			glLoadIdentity() ;

			glRotatef(sp_x, 0.0f,1.0f,0.0f) ;	// ｙ軸回転
			glRotatef(sp_y, 1.0f,0.0f,0.0f) ;	// ｘ軸回転

			glMultMatrixf(aRotate) ;
			glGetFloatv(GL_MODELVIEW_MATRIX, aRotate) ;

		glPopMatrix() ;

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -p.roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		DrawClock(p) ;

	glPopMatrix() ;
}

// モデル描画、行列セット、回転の累積（アンティエイリアシング＆モーションブラ用）
void DrawModelMatrix(ClockState& p, ClockState& st, int count, ClockState *n)
{
	GLfloat f_r = 1.0f - shutter, r_step = shutter / (motion - 1), sp_x = spin_x, sp_y = spin_y, ratio ;

	ratio = f_r + r_step * count ;
	if (!count)
	{
		sp_x *= f_r ;
		sp_y *= f_r ;
	}
	else
	{
		sp_x *= r_step ;
		sp_y *= r_step ;
	}

	n->tm.hour   = p.tm.hour   + (st.tm.hour   - p.tm.hour  ) * ratio ;
	n->tm.minute = p.tm.minute + (st.tm.minute - p.tm.minute) * ratio ;
	n->tm.second = p.tm.second + (st.tm.second - p.tm.second) * ratio ;

	n->h_rotate  = p.h_rotate  + (st.h_rotate  - p.h_rotate ) * ratio ;
	n->g_spin    = p.g_spin    + (st.g_spin    - p.g_spin   ) * ratio ;

	n->roof      = p.roof      + (st.roof      - p.roof     ) * ratio ;

	n->clock_z   = p.clock_z   + (st.clock_z   - p.clock_z  ) * ratio ;
	n->pers      = p.pers      + (st.pers      - p.pers     ) * ratio ;

	glMatrixMode(GL_PROJECTION) ;
	SetPerspective(p) ;

	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, n->clock_z) ;	// ｚ軸移動

		glPushMatrix() ;

			glLoadIdentity() ;

			glRotatef(sp_x, 0.0f,1.0f,0.0f) ;	// ｙ軸回転
			glRotatef(sp_y, 1.0f,0.0f,0.0f) ;	// ｘ軸回転

			glMultMatrixf(aRotate) ;
			glGetFloatv(GL_MODELVIEW_MATRIX, aRotate) ;

		glPopMatrix() ;

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -n->roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		DrawClock(*n) ;

	glPopMatrix() ;
}

// モデル描画、行列セット（アンティエイリアシングの１～ｎ回目の描画）
void DrawModelMatrixAnti(ClockState& st)
{
	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, st.clock_z) ;	// ｚ軸移動

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -st.roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		DrawClock(st) ;

	glPopMatrix() ;
}


// モデル描画、行列セット（アンティエイリアシングの１～ｎ回目の描画）
// オーバサンプリング用
void DrawModelMatrixAntiWithOverSampling(ClockState& st, int count)
{
	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, st.clock_z) ;	// ｚ軸移動

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -st.roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		DrawClock(st, count) ;

	glPopMatrix() ;
}

// FPSの計算
void FramesPerSecond()
{
	static int  n_tick = 0, o_tick = 0 ;
	static char c_fps[11] = { "0.00 FPS" };

	o_tick = n_tick ;

	if ((n_tick = glutGet((GLenum)GLUT_ELAPSED_TIME)))
		fps = f_cnt / ((float)(n_tick - o_tick) / 1000) ;
	else
		fps = 0.0f ;

#ifdef WIN32
	if (g_pFps) sprintf(g_pFps, "%3.2f", fps) ;
#endif

	// FPS を計算した回数と描画ポリゴンの総計
	if ((++ fps_count) >= 1)
	{
		sum_fps += fps ;
		sum_polygons += f_polygons ;
	}

	if (f_prn && fps_count >= 1) printf("%5.2f FPS  %d TPS  at %d Triangles\n", fps, (int)(r_polygons * fps), r_polygons) ;
	if (fps_count >= 1) sprintf(c_fps, "%5.2f FPS", fps) ;
	s_fps = c_fps ;

	f_cnt = f_polygons = 0 ;
	f_cal_flag = FALSE ;

	timeData.fp_hour   = timeData.n_hour ;
	timeData.fp_minute = timeData.n_minute ;
	timeData.fp_second = timeData.n_second ;

/*
	// CPU パフォーマンスが設定されている場合は
	// FPS に応じて us_sleep 値を再計算
	if (sleepRatio > 0.0f && fps > 0.0f)
	{
		// スリープがなかった場合に１回の描画にかかったミリ秒
		double msecond = 1000.0f / fps - us_sleep ;
		if (msecond > 0.0f)
			us_sleep = (unsigned int)((1.0f / sleepRatio - 1.0f) * msecond) ;
		else
			us_sleep = 0 ;
	}
*/

	// ベンチマーク実行時処理（）
	if (benchmark)
	{
		if (fps_count)
		{
			spin_x = -360.0f / fps ;
			if (spin_x < -30.0f) spin_x = -30.0f ;
		}

		if (benchmark && ((fps_count >= 10 && loop_count >= 80) || (fps_count >= 10 && n_tick >= 80000)))
		{
			EndProc() ;
//			printf("Frames per second: %5.2f\n\n", sum_fps / fps_count) ;
			printf("%5.2f FPS  %d TPS  at %d Triangles\n\n", sum_fps / fps_count, (int)(sum_polygons / (double)fps_count), r_polygons) ;

			// -foutfps オプションでファイルを指定した場合は、ファイルにFPSを追加出力
			if (fout_fps != String(""))
			{
				FILE *fp ;

				if (!(fp = fopen(fout_fps, "a"))) exit(1) ;
				fprintf(fp, "%5.2f FPS  %d TPS  at %d Triangles\n\n", sum_fps / fps_count, (int)(sum_polygons / (double)fps_count), r_polygons) ;
				fclose(fp) ;
			}

			exit(0) ;
		}
	}
}

// 現在の時間から、ＢＧカラーを決定
void SetCurrentBackGroundColor()
{
	// 昼、夕方、夜の色を時間で補間
	float cereal = timeData.t_area->tm_hour + timeData.n_minute / 60.0f + timeData.n_second / 3600.0f, ratio, aratio ;
	if (cereal >= 5.5f && cereal < 6.0f)
	{
		grad_flag = TRUE ;
		aratio = 1.0f - (ratio = (cereal - 5.5f) * 2.0f) ;

		currentBG[0] = bgColor[1].v[0] * ratio + bgColor[2].v[0] * aratio ;
		currentBG[1] = bgColor[1].v[1] * ratio + bgColor[2].v[1] * aratio ;
		currentBG[2] = bgColor[1].v[2] * ratio + bgColor[2].v[2] * aratio ;

		currentLC[0] = lightCl[1].v[0] * ratio + lightCl[2].v[0] * aratio ;
		currentLC[1] = lightCl[1].v[1] * ratio + lightCl[2].v[1] * aratio ;
		currentLC[2] = lightCl[1].v[2] * ratio + lightCl[2].v[2] * aratio ;
	}
	else if (cereal >= 6.0f && cereal <= 6.5f)
	{
		grad_flag = TRUE ;
		aratio = 1.0f - (ratio = (cereal - 6.0f) * 2.0f) ;

		currentBG[0] = bgColor[0].v[0] * ratio + bgColor[1].v[0] * aratio ;
		currentBG[1] = bgColor[0].v[1] * ratio + bgColor[1].v[1] * aratio ;
		currentBG[2] = bgColor[0].v[2] * ratio + bgColor[1].v[2] * aratio ;

		currentLC[0] = lightCl[0].v[0] * ratio + lightCl[1].v[0] * aratio ;
		currentLC[1] = lightCl[0].v[1] * ratio + lightCl[1].v[1] * aratio ;
		currentLC[2] = lightCl[0].v[2] * ratio + lightCl[1].v[2] * aratio ;
	}
	else if (cereal >= 17.5f && cereal < 18.0f)
	{
		grad_flag = TRUE ;
		aratio = 1.0f - (ratio = (cereal - 17.5f) * 2.0f) ;

		currentBG[0] = bgColor[1].v[0] * ratio + bgColor[0].v[0] * aratio ;
		currentBG[1] = bgColor[1].v[1] * ratio + bgColor[0].v[1] * aratio ;
		currentBG[2] = bgColor[1].v[2] * ratio + bgColor[0].v[2] * aratio ;

		currentLC[0] = lightCl[1].v[0] * ratio + lightCl[0].v[0] * aratio ;
		currentLC[1] = lightCl[1].v[1] * ratio + lightCl[0].v[1] * aratio ;
		currentLC[2] = lightCl[1].v[2] * ratio + lightCl[0].v[2] * aratio ;
	}
	else if (cereal >= 18.0f && cereal <= 18.5f)
	{
		grad_flag = TRUE ;
		aratio = 1.0f - (ratio = (cereal - 18.0f) * 2.0f) ;

		currentBG[0] = bgColor[2].v[0] * ratio + bgColor[1].v[0] * aratio ;
		currentBG[1] = bgColor[2].v[1] * ratio + bgColor[1].v[1] * aratio ;
		currentBG[2] = bgColor[2].v[2] * ratio + bgColor[1].v[2] * aratio ;

		currentLC[0] = lightCl[2].v[0] * ratio + lightCl[1].v[0] * aratio ;
		currentLC[1] = lightCl[2].v[1] * ratio + lightCl[1].v[1] * aratio ;
		currentLC[2] = lightCl[2].v[2] * ratio + lightCl[1].v[2] * aratio ;
	}
	else if (cereal > 18.5f || cereal < 5.5f)
	{
		grad_flag = FALSE ;

		currentBG[0] = bgColor[2].v[0] ;
		currentBG[1] = bgColor[2].v[1] ;
		currentBG[2] = bgColor[2].v[2] ;

		currentLC[0] = lightCl[2].v[0] ;
		currentLC[1] = lightCl[2].v[1] ;
		currentLC[2] = lightCl[2].v[2] ;
	}
	else
	{
		grad_flag = FALSE ;

		currentBG[0] = bgColor[0].v[0] ;
		currentBG[1] = bgColor[0].v[1] ;
		currentBG[2] = bgColor[0].v[2] ;

		currentLC[0] = lightCl[0].v[0] ;
		currentLC[1] = lightCl[0].v[1] ;
		currentLC[2] = lightCl[0].v[2] ;
	}

/*
	currentGC[0] = 0.2f + (currentCL[0] = currentLC[0]) ;
	currentGC[1] = 0.2f + (currentCL[1] = currentLC[1]) ;
	currentGC[2] = 0.2f + (currentCL[2] = currentLC[2]) ;
*/
	// とりあえずこのまま
	currentGC[0] = (currentCL[0] = currentLC[0]) ;
	currentGC[1] = (currentCL[1] = currentLC[1]) ;
	currentGC[2] = (currentCL[2] = currentLC[2]) ;

	// クランプ処理（Mesa）
	if (mesa)
	{
		if (currentCL[0] > 1.0f) currentCL[0] = 1.0f ;
		if (currentCL[1] > 1.0f) currentCL[1] = 1.0f ;
		if (currentCL[2] > 1.0f) currentCL[2] = 1.0f ;

		if (currentGC[0] > 1.0f) currentGC[0] = 1.0f ;
		if (currentGC[1] > 1.0f) currentGC[1] = 1.0f ;
		if (currentGC[2] > 1.0f) currentGC[2] = 1.0f ;
	}

	// カラーセット
	if (!saver) glClearColor(currentBG[0], currentBG[1], currentBG[2], currentBG[3]) ;
	glFogfv(GL_FOG_COLOR, currentBG) ;

	// LIGHT0 の色セット
	SetLight(GL_LIGHT0, lpos[0], currentLC, 0.16f / light + 0.02f, TRUE, (reality != 2));	// 0.5f / light??
}

// 時計針の回転
void ClockProc()
{
	float r_ratio ;

	timeData.t = time(NULL) ;
	timeData.t_area = localtime(&timeData.t) ;

	timeData.p_hour   = timeData.n_hour ;
	timeData.p_minute = timeData.n_minute ;
	timeData.p_second = timeData.n_second ;

	timeData.n_hour   = timeData.t_area->tm_hour % 12 ;
	timeData.n_minute = timeData.t_area->tm_min ;
	timeData.n_second = timeData.t_area->tm_sec ;

	// 時間によって時計針の角度を計算
	if (fps <= 1.0f) r_ratio = 1.0f ;
	else            r_ratio = 0.8f / fps + 0.2f ;

	if (timeData.n_hour   < timeData.p_hour  ) now.tm.hour   -= 360.0f ;
	if (timeData.n_minute < timeData.p_minute) now.tm.minute -= 360.0f ;
	if (timeData.n_second < timeData.p_second) now.tm.second -= 360.0f ;

	// ステータス保存（針の回転角度）
	pre.tm = now.tm ;

	now.tm.hour   += ((timeData.n_hour   * 30 + timeData.n_minute * 0.5f) - now.tm.hour   ) * r_ratio ;
	now.tm.minute += ((timeData.n_minute *  6 + timeData.n_second * 0.1f) - now.tm.minute ) * r_ratio ;
	now.tm.second += ((timeData.n_second *  6                           ) - now.tm.second ) * r_ratio ;

	if (f_cnt >= F_COUNT) f_cal_flag = TRUE ;

	// 直前のループから時間が変わっているなら
	if (timeData.n_second != timeData.p_second ||
	    timeData.n_minute != timeData.p_minute ||
	    timeData.n_hour   != timeData.p_hour)
	{
		f_time = (timeData.n_hour   - timeData.fp_hour  ) * 3600 +
				 (timeData.n_minute - timeData.fp_minute) *   60 +
				 (timeData.n_second - timeData.fp_second) ;

		// 指定時間か指定ループが過ぎたらFPS計算
		if (f_cal_flag || f_time >= F_TIME_COUNT) FramesPerSecond() ;
	}

	if (!bg_color) SetCurrentBackGroundColor() ;	// 現在の時間から、ＢＧカラーを決定

	// 秒針だけのモーション用スタートアングルおよびステップ値計算
	if (s_motion) CalcNeedleMotionBlurAngles(pre, now) ;

#ifdef GIFF_DEMO
	now.tm.hour   = GIFF_DEMO_HOUR   * 30 + GIFF_DEMO_MINUTE * 0.5f ;
	now.tm.minute = GIFF_DEMO_MINUTE *  6 + GIFF_DEMO_SECOND * 0.1f ;
	now.tm.second = GIFF_DEMO_SECOND *  6 ;
#endif
}

void CalculateMoving()
{
	if (DragR)
	{
		// Drag to RIGHT MOUSE BUTTON

		// 0.0f～1.0f = 2.0f^3～2.0f^-3（8～1～1/8）
		p_step = pow(2.0f, (0.5f - ((float)mouse_x / xsize)) * 6.0f) ;
		if      (p_step < p_min) p_step = p_min ;
		else if (p_step > p_max) p_step = p_max ;

		p_step = (p_step - now.pers) * t_ratio ;

		z_step = (((float)mouse_y / ysize) - 0.5f) * m_speed + B_DIST ;
		z_step = (z_step - dist_y) * t_ratio ;

		if      (z_step < -t_max) z_step = -t_max ;
		else if (z_step >  t_max) z_step =  t_max ;

		last_x = mouse_x ;
		last_y = mouse_y ;
	}
	else if ((DragL || DragL_t) && (mouse_x != last_x || mouse_y != last_y))
	{
		// Drag to LEFT MOUSE BUTTON

		spin_x = (mouse_x - last_x) * m_speed / xsize ;
		spin_y = (mouse_y - last_y) * m_speed / ysize ;

		last_x = mouse_x ;
		last_y = mouse_y ;

		DragL_t = OFF ;
	}
}

// 時計動作処理
void MoveModel()
{
	loop_count ++ ;	// 時計が動いた回数

	CalculateMoving() ;

	pre.pers    = now.pers ;
	pre.clock_z = now.clock_z ;
	pre.roof    = now.roof ;

	now.roof += (t_roof - now.roof) * t_ratio ;	// 蓋の動き

	now.pers += p_step ;
	p_step *= i_ratio ;

	dist_y += z_step ;
	z_step *= i_ratio ;

#ifndef GIFF_DEMO
	if (!benchmark)
	{
		spin_x *= ir_ratio ;
		spin_y *= ir_ratio ;
	}
#endif

	now.clock_z = dist_y / now.pers * (now.roof + 2.0f) / 3.0f ;	// 時計Ｚ座標

	if (!anti & !motion) SetPerspective(now) ;	// 望遠、広角処理（アンティエイリアシング、モーションブラなしの時）
	ClockProc() ;


	// スクリーンセーバ時は
	// シザーバッファとビューポート位置を設定
	if (saver)
	{
		if (Abs(spin_x) < 1.0f)
			spin_x = Sgn(spin_x) * 1.0f ;

		// viewportX, viewportY コントロール（ただいま暫定値）
		viewportX += viewportVX ;
		viewportY += viewportVY ;

		if (viewportX < 0)
		{
			viewportX = 0 ;
			viewportVX = -viewportVX ;
		}
		else if (viewportX + scissorSize >= is_set_width)
		{
			viewportX = is_set_width - scissorSize ;
			viewportVX = -viewportVX ;
		}

		if (viewportY < 0)
		{
			viewportY = 0 ;
			viewportVY = -viewportVY ;
		}
		else if (viewportY + scissorSize >= is_set_height)
		{
			viewportY = is_set_height - scissorSize ;
			viewportVY = -viewportVY ;
		}

//		viewportX = is_set_width  / 2 - scissorSize / 2 ;
//		viewportY = is_set_height / 2 - scissorSize / 2 ;

		// シザー範囲とビューポートを設定
//		// 3Dfx OpenGL で /* スタートの一回だけはシザー設定なし */
//		if (!(fxOpenGL /* && start*/)) glScissor(viewportX, viewportY, scissorSize, scissorSize) ;
		glScissor(viewportX, viewportY, scissorSize, scissorSize) ;
		glViewport(viewportX + 2, viewportY + 2, scissorSize - 4, scissorSize - 4) ;
	}

//	glutPostRedisplay() ;	// 時計レンダリング
}

// モデル描画、行列セット、回転の累積
void DrawModelMatrix(ClockState& st)
{
	glPushMatrix() ;

		glTranslatef(0.0f, 0.0f, st.clock_z) ;	// ｚ軸移動

		glPushMatrix() ;

			glLoadIdentity() ;

			glRotatef(spin_x, 0.0f,1.0f,0.0f) ;	// ｙ軸回転
			glRotatef(spin_y, 1.0f,0.0f,0.0f) ;	// ｘ軸回転

			glMultMatrixf(aRotate) ;
			glGetFloatv(GL_MODELVIEW_MATRIX, aRotate) ;

		glPopMatrix() ;

		glMultMatrixf(aRotate) ;
		glTranslatef(0.0f, -st.roof * ROOF_MOVE, 0.0f) ;	// ｙ軸移動

		if (stop)
		{
			if (start)
			{
				start = FALSE ;

				glNewList(AllocAList(CLOCK_LIST), GL_COMPILE_AND_EXECUTE) ;
					DrawClock(st) ;
				glEndList() ;
			}
			else
				glCallList(CLOCK_LIST) ;
		}
		else
		{
			DrawClock(st) ;
			if (start) start = FALSE ;
		}

	glPopMatrix() ;
}

// モデル描画、アンティエイリアシング、モーションブラ
void DrawModel()
{
	// 時計の動作（回転・移動等）
	MoveModel() ;

	if (!anti)
	{
		if (!motion)
		{
			glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
//			glClear(GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
//			ClearViewPortWithRect() ;

			DrawModelMatrix(now) ;
		}
		else
		{
			int i ;

//			if (!crystal)
			if (!crystal && texture != 1)
			{
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
				if (shutter != 1.0f || !pre_motion)
				{
					pre_motion = motion ;	// 直前の motion 保存

					DrawModelMatrix(pre, now, 0) ;
					glAccum(GL_LOAD, 1.0f / motion) ;
				}
				else
					glAccum(GL_MULT, 1.0f / motion) ;

				for (i = 1 ; i < motion ; i ++)
				{
					glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
					DrawModelMatrix(pre, now, i) ;
					glAccum(GL_ACCUM, 1.0f / motion) ;
				}
				glAccum(GL_RETURN, 1.0f) ;
			}
			else if (crystal)
			{	// クリスタル時計の場合は単なる加算で良いのでアキュムレーションバッファは使わない
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
				for (i = 0 ; i < motion ; i ++)
					DrawModelMatrix(pre, now, i) ;
			}
			else
			{	// アキュムレーションバッファは使わない
				glDisable(GL_DITHER) ;

				if (shutter != 1.0f || !pre_motion)
				{
					pre_motion = motion ;	// 直前の motion 保存

					glDisable(GL_BLEND) ;
					glDepthFunc(GL_LESS) ;
					glDepthMask(GL_TRUE) ;
					glEnable(GL_DEPTH_TEST) ;

					glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE) ;
					glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア

					// １回目の描画はブレンド OFF で、通常とまったく同じ描画
					DrawModelMatrixWithOverSampling(pre, now, 0) ;
				}
				else if (!DONOT_USE_GL_READ_BUFFER && glut_buff == GLUT_DOUBLE)
				{
					// 前回からの描画を残す（残像処理の）時、ダブルバッファ実行なら
					// 前回のバックバッファ（現在表示されている内容）を、
					// 現在のドローバッファにコピー

					// 読み出すべきバッファ（ドローバッファの逆）を セット
					GLint draw_buffer ;
					glGetIntegerv(GL_DRAW_BUFFER, &draw_buffer) ;
					if (draw_buffer == GL_FRONT)
						draw_buffer = GL_BACK ;
					else
						draw_buffer = GL_FRONT ;

					glReadBuffer((GLenum)draw_buffer) ;

					// ラスタポジションの設定とバッファのコピー
					glPushMatrix() ;
					glLoadIdentity() ;

					glMatrixMode(GL_PROJECTION) ;
					glPushMatrix() ;
					glLoadIdentity() ;

					glDisable(GL_DEPTH_TEST) ;
					glRasterPos3f(-1.0f, -1.0f, 0.0f) ;
					glCopyPixels(0,0, xsize,ysize, GL_COLOR) ;
					glEnable(GL_DEPTH_TEST) ;

					glPopMatrix() ;

					glMatrixMode(GL_MODELVIEW) ;
					glPopMatrix() ;
				}

				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
				glEnable(GL_BLEND) ;
				glDepthFunc(GL_LEQUAL) ;

				for (i = 1 ; i < motion ; i ++)
					DrawModelMatrixWithOverSampling(pre, now, i) ;

				glDepthFunc(GL_LESS) ;
				glDisable(GL_BLEND) ;

				if (dither) glEnable(GL_DITHER) ;
			}
		}
	}
	else
	{
		if (!motion)
		{
			int i ;

			if (!crystal && texture != 1)
			{
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア				glAccum(GL_LOAD, 1.0f / anti) ;
				SetPerspective(now, jitter[0].x, jitter[0].y) ;
				DrawModelMatrix(now) ;
				glAccum(GL_LOAD, 1.0f / anti) ;

				for (i = 1 ; i < anti ; i ++)
				{
					// 透視射影行列セット
					Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[i].x,jitter[i].y) ;

					// 1/anti 描画
					glMatrixMode(GL_MODELVIEW) ;							// 行列モードをモデルビューにセット
					glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
					DrawModelMatrixAnti(now) ;
					glAccum(GL_ACCUM, 1.0f / anti) ;
				}
				glAccum(GL_RETURN, 1.0f) ;
			}
			else if (crystal)
			{	// クリスタル時計の場合は単なる加算で良いのでアキュムレーションバッファは使わない
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア				glAccum(GL_LOAD, 1.0f / anti) ;
				SetPerspective(now, jitter[0].x, jitter[0].y) ;
				DrawModelMatrix(now) ;

				for (i = 1 ; i < anti ; i ++)
				{
					// 透視射影行列セット
					Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[i].x,jitter[i].y) ;

					// 1/anti 描画
					glMatrixMode(GL_MODELVIEW) ;			// 行列モードをモデルビューにセット
					DrawModelMatrixAnti(now) ;
				}
			}
			else
			{	// アキュムレーションバッファは使わない
/*
				float color_weight = 1.0f / anti ;

				currentFG[0] = currentBG[0] * color_weight ;
				currentFG[1] = currentBG[1] * color_weight ;
				currentFG[2] = currentBG[2] * color_weight ;

				glClearColor(0.0f, 0.0f, 0.0f, 1.0f) ;
				glClear(GL_COLOR_BUFFER_BIT) ;	// カラー、デプスバッファクリア

				glFogfv(GL_FOG_COLOR, currentFG) ;
				glEnable(GL_BLEND) ;
				glDepthFunc(GL_LEQUAL) ;

				SetPerspective(now, jitter[0].x, jitter[0].y) ;
				DrawModelMatrix(now) ;

				for (i = 1 ; i < anti ; i ++)
				{
					glFogfv(GL_FOG_COLOR, currentFG) ;

					// 透視射影行列セット
					Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[i].x,jitter[i].y) ;

					// 1/anti 描画
					glMatrixMode(GL_MODELVIEW) ;			// 行列モードをモデルビューにセット
					DrawModelMatrixAnti(now) ;
				}

				glDepthFunc(GL_LESS) ;
				glDisable(GL_BLEND) ;

				glClearColor(currentBG[0], currentBG[1], currentBG[2], currentBG[3]) ;
				glFogfv(GL_FOG_COLOR, currentBG) ;
*/
				glDisable(GL_DITHER) ;

				glDisable(GL_BLEND) ;
				glDepthFunc(GL_LESS) ;
				glDepthMask(GL_TRUE) ;
				glEnable(GL_DEPTH_TEST) ;
				glColorMask(GL_TRUE, GL_TRUE, GL_TRUE, GL_TRUE) ;

				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア

				// １回目の描画はブレンド OFF で、通常とまったく同じ描画
				SetPerspective(now, jitter[0].x, jitter[0].y) ;
//				DrawModelMatrixAntiWithOverSampling(now, 0) ;
				DrawModelMatrix(now) ;

				glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
				glEnable(GL_BLEND) ;
				glDepthFunc(GL_LEQUAL) ;

				for (i = 1 ; i < anti ; i ++)
				{
					// 透視射影行列セット
					Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[i].x,jitter[i].y) ;

					// 1/anti 描画
					glMatrixMode(GL_MODELVIEW) ;			// 行列モードをモデルビューにセット
					DrawModelMatrixAntiWithOverSampling(now, i) ;
				}

				glDepthFunc(GL_LESS) ;
				glDisable(GL_BLEND) ;

				if (dither) glEnable(GL_DITHER) ;
			}
		}
		else
		{
			int        i ;
			ClockState tmp ;

			for (i = 0 ; i < motion ; i ++)
			{
				// 1/motion 描画
				int j ;

				SetPerspective(now, jitter[0].x, jitter[0].y) ;
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
				DrawModelMatrix(pre, now, i, &tmp) ;

				if (!i) glAccum(GL_LOAD,  1.0f / motion / anti) ;
				else    glAccum(GL_ACCUM, 1.0f / motion / anti) ;

//				if (!crystal)
				{
					for (j = 1 ; j < anti ; j ++)
					{
						// 透視射影行列セット
						Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[j].x,jitter[j].y) ;

						// 1/anti/motion 描画
						glMatrixMode(GL_MODELVIEW) ;							// 行列モードをモデルビューにセット
						glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT) ;	// カラー、デプスバッファクリア
						DrawModelMatrixAnti(tmp) ;
						glAccum(GL_ACCUM, 1.0f / motion / anti) ;
					}
					glAccum(GL_RETURN, 1.0f) ;
				}
/*				else
				{	// クリスタル時計の場合は単なる加算で良いのでアキュムレーションバッファは使わない
					for (j = 0 ; j < anti ; j ++)
					{
						// 透視射影行列セット
						Perspective(scr_w,scr_h, near_clip,far_clip, xsize,ysize, jitter[j].x,jitter[j].y) ;

						// 1/anti/motion 描画
						glMatrixMode(GL_MODELVIEW) ;							// 行列モードをモデルビューにセット
						DrawModelMatrixAnti(tmp) ;
					}
				}
*/
			}
		}
	}

	// サイン描画ありまたはFPS表示ONで、さらにスクリーンセーバモードでなければ
	if ((!no_sign || f_prn) /* && !saver*/) DrawSignAndFPS() ;	// サインおよびＦＰＳ描画

	if (glut_buff == GLUT_DOUBLE) glutSwapBuffers() ;	// ドローバッファとビューバッファのスワップ
	else glFlush() ;	// シングルバッッファモード時はリクエストバッファをフラッシュ

	if (us_sleep) u_sleep(us_sleep) ;

	f_cnt ++ ;		// ループ回数カウント

	// 描画したポリゴン数カウント && オーバサンプリング描画した実際のポリゴン数計算
	if (anti)
	{
		if (motion)
			r_polygons = nm_polygons * motion * anti ;
		else
			r_polygons = nm_polygons * anti ;
	}
	else if (motion)
		r_polygons = nm_polygons * motion ;
	else
		r_polygons = nm_polygons ;

	f_polygons += r_polygons ;


	// 前回のステータス保存（ガラスと多面体の回転角度）
	pre.g_spin   = now.g_spin ;
	pre.h_rotate = now.h_rotate ;

	now.g_spin += 1.0f ;		// 表面ガラスの回転
	now.h_rotate += 5.0f ;	// 多面体の回転
}

void Redisplay()
{
	glutPostRedisplay() ;
}

// マウス移動コールバック
void MouseMotion(int x, int y)
{
	mouse_x = x ;
	mouse_y = y ;
}

// ドラッグ ＯＮ，ＯＦＦ
void MouseProc(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON)
	{
		// ドラッグＯＮ時はマウスのドラッグ前の位置に現在の位置を保存
		if      (state == GLUT_DOWN) { DragL = ON  ; last_x = x ; last_y = y ; }
		else if (state == GLUT_UP  ) { DragL = OFF ; DragL_t = ON ; }
	}
	else if (button == GLUT_RIGHT_BUTTON)
	{
		if      (state == GLUT_DOWN) DragR = ON ;
		else if (state == GLUT_UP  ) DragR = OFF ;
	}
	else if (button == GLUT_MIDDLE_BUTTON && state == GLUT_DOWN)
		t_roof = 1.0f - t_roof ;	// スペースで蓋開閉

	mouse_x = x ;
	mouse_y = y ;
}

// ドラッグ ＯＮ，ＯＦＦ
void SpecialKeyProc(int key, int x, int y)
{
	if      (key == GLUT_KEY_LEFT ) spin_x += ((-0.2f * SPEED) - spin_x) * 0.2f ;
	else if (key == GLUT_KEY_RIGHT) spin_x += (( 0.2f * SPEED) - spin_x) * 0.2f ;
	else if (key == GLUT_KEY_UP   ) spin_y += ((-0.2f * SPEED) - spin_y) * 0.2f ;
	else if (key == GLUT_KEY_DOWN ) spin_y += (( 0.2f * SPEED) - spin_y) * 0.2f ;

	last_x = mouse_x = x ;
	last_y = mouse_y = y ;
}

// ウィンドウサイズ（xsize, ysize）によってサインの位置（sign_x, sign_y）を計算
void SetSignPosition()
{
	sign_x = (int)(xsize * 0.97f - 5.0f * sign.Length()) ;
	sign_y = (int)(ysize * 0.03f + 2.0f) ;
}

// ウィンドウサイズ（xsize, ysize）によってFPSの位置（fps_x, fps_y）を計算
void SetFPSPosition()
{
	fps_x = (int)(xsize * 0.03f +  2.0f) ;
	fps_y = (int)(ysize * 0.97f - 12.0f) ;
}


// スクリーンセーバ起動時、何らかのアクションがあった場合

// 総処理
void ExitSaver()
{
	EndProc() ;
	exit(0) ;
#ifdef WIN32
	// IME 出現
	WINNLSEnableIME(NULL,TRUE) ;
#endif
}

// glutPassiveMotionFunc
void ExitSaverWait(int x, int y)
{
	static int preX = -99999, preY ;

	// 画面が出現してから１秒以内は終了しない
//	if (glutGet((GLenum)GLUT_ELAPSED_TIME) < firstReshapeTime + 1000 ||
//		firstReshapeTime == -1) return ;

	// 最初のイベントではなく、前のイベント時より５ドット以上動いていれば終了
	if (preX != -99999 &&
		(Abs(x - preX) > 4 || Abs(y - preY) > 4))
		ExitSaver() ;

	preX = x ;
	preY = y ;
}

// glutMotionFunc
void ExitSaver(int x, int y)
{
	ExitSaver() ;
}

// glutKeyboardFunc
void ExitSaver(unsigned char key, int x, int y)
{
	ExitSaver() ;
}

// glutMouseFunc
void ExitSaver(int key_button, int state, int x, int y)
{
	ExitSaver() ;
}

// glutSpecialFunc
void ExitSaver(int key, int x, int y)
{
	ExitSaver() ;
}


// ウィンドウのコンフィギュレーションイベントハンドラ
void ReshapeWindow(int x, int y)
{
//	if (saver && firstReshapeTime == -1)
//		firstReshapeTime = glutGet((GLenum)GLUT_ELAPSED_TIME) ;

	int screen_y = y ;

	// Voodoo モードまたはスクリーンセーバモードでは
	// 常に手前に表示
#ifdef WIN32
	if (voodoo || saver)
	{
		HWND win ;
		win = FindWindow("GLUT", title) ;
		if (win)
		{
/*			WINDOWPLACEMENT wndpl ;
			wndpl.length = sizeof(WINDOWPLACEMENT) ;
			GetWindowPlacement(win, &wndpl) ;

			SetWindowPos(win, HWND_TOPMOST,
						 wndpl.ptMaxPosition.x,
						 wndpl.ptMaxPosition.y,
						 GetSystemMetrics(SM_CXSCREEN),
						 GetSystemMetrics(SM_CYSCREEN),
						 SWP_NOMOVE | SWP_NOSIZE) ;
*/
			SetWindowPos(win, HWND_TOPMOST,
						 0,0, 0,0,
						 SWP_NOMOVE | SWP_NOSIZE) ;
		}
	}
#endif

	if (saver)
	{
		if (firstReshapeTime == -1)
			firstReshapeTime = glutGet((GLenum)GLUT_ELAPSED_TIME) ;

		// スクリーンセーバモードでは scissorSize に
		// 一度カラーバッファ全体をクリア
		is_set_width  = x ;
		is_set_height = y ;

		scissorSize = (int)(is_set_height * Pow(2.0, clockSize * 3.0) / 7.9999) ;
		if (scissorSize > is_set_height)
			scissorSize = is_set_height ;
		else if (scissorSize < 5)
			scissorSize = 5 ;

		viewportX = is_set_width / 2 - scissorSize / 2 ;
		viewportY = is_set_width / 2 - scissorSize / 2 ;
		viewportVX = 1 ;
		viewportVY = 1 ;

		x = scissorSize ;
		y = scissorSize ;

		glScissor(0, 0, is_set_width, is_set_height) ;
		glViewport(0, 0, is_set_width, is_set_height) ;
		glClear(GL_COLOR_BUFFER_BIT) ;

		// ダブルバッファ時は
		// 現在表示中のバッファもクリアしておく
		if (glut_buff == GLUT_DOUBLE)
		{
			glutSwapBuffers() ;
			glClear(GL_COLOR_BUFFER_BIT) ;
		}
	}
	else if (voodoo)
	{
		x = is_set_width ;
		y = is_set_height ;
		glViewport(0, 0, x, y) ;
	}
	else
	{
		if (full && is_set_width && is_set_height)
		{
			x = is_set_width ;
			y = is_set_height ;
		}
		glViewport(0, screen_y - y, x, y) ;
	}

	glMatrixMode(GL_MODELVIEW) ;
	// Reset Matrix
	glLoadIdentity() ;
	gluLookAt(0.0f,0.0f,0.0f, 0.0f,0.0f,-1.0f, 0.0f,1.0f,0.0f) ;

	// Save Now Window size for Mouse evnet
	xsize = x ;
	ysize = y ;

	if (x < (sign.Length() + 2) * 5 || y < 16) sign_x = NONE ;
	else SetSignPosition() ;
	if (x < 100) fps_x = NONE ;
	else SetFPSPosition() ;

	// shutter == 1.0f でモーション中は、１回目の描画からやり直し（アキュムレーションバッファが使えないため）
	if (motion && shutter == 1.0f) pre_motion = FALSE ;
}

// 時計のクオリティセット
void SetQuality(int q)
{
	clock_hedron = quality[q][0] ;
	clock_div    = quality[q][1] ;
	clock_glass  = quality[q][2] ;
	clock_point  = quality[q][3] ;
	clock_mesh   = quality[q][4] ;
	gold_depth   = quality[q][5] ;
}

// オプション処理＆変数初期化
void InitVar(Option& option)
{
	int    sol ;
	String min_filter, pol_mode, pers_corr ;
	float tex_scale ;

	// コマンドラインオプション
	// OpenGL環境（ドライバ、ビデオカード種別）
	int gl, setEnvFlag = FALSE ;

	gl = option.Get("-MESA", 5) ;
#ifdef MESA
	envOpenGL = MESA_LIB ; setEnvFlag = TRUE ; // Mesa ライブラリでコンパイル時は必ず Mesa モードに
#else
	if (gl) { envOpenGL = MESA_LIB ; setEnvFlag = TRUE ; }
#endif

	gl = option.Get("-3DFXMESA", 9) ;
	if (gl) { envOpenGL = VOODOO_MESA ; setEnvFlag = TRUE ; WIDTH = 640 ; HEIGHT = 480 ; }

	gl = option.Get("-VOODOO", 7) ;
	if (gl) { envOpenGL = VOODOO ; setEnvFlag = TRUE ; WIDTH = 640 ; HEIGHT = 480 ; }

	gl = option.Get("-RUSH", 5) ;
	if (gl) { envOpenGL = VOODOO_RUSH ; setEnvFlag = TRUE ; }

	gl = option.Get("-BANSHEE", 8) ;
	if (gl) { envOpenGL = VOODOO_BANSHEE ; setEnvFlag = TRUE ; }

	gl = option.Get("-RIVA128", 5) ;
	if (gl) { envOpenGL = RIVA ; setEnvFlag = TRUE ; }

	gl = option.Get("-PERMEDIA2", 10) ;
	if (gl) { envOpenGL = PERMEDIA2 ; setEnvFlag = TRUE ; }

	gl = option.Get("-TNTFIX", 4) ;
	if (gl) { envOpenGL = RIVA_TNT_FIX ; setEnvFlag = TRUE ; }

	gl = option.Get("-GENERIC", 8) ;
	if (gl) { envOpenGL = GENERIC ; setEnvFlag = TRUE ; }

	// オプション指定のないデフォルト
	// VOODOO_MODE なら VOODOO
	// それ以外なら GENERIC
	if (!setEnvFlag)
	{
#ifdef VOODOO_MODE
		envOpenGL = VOODOO ;
#else
		envOpenGL = GENERIC ;
#endif
	}

	if (envOpenGL == MESA_LIB || envOpenGL == VOODOO_MESA) mesa = TRUE ;
//	if (envOpenGL == VOODOO_MESA || envOpenGL == VOODOO ||
//		envOpenGL == VOODOO2 || envOpenGL == VOODOO2_SLI) voodoo = TRUE ;
	if (envOpenGL == VOODOO_MESA || envOpenGL == VOODOO) voodoo = TRUE ;

	// PERMEDIA2, RIVA は、αグローを使用しない
	if (envOpenGL == PERMEDIA2 || envOpenGL == RIVA) DONOT_USE_ALPHA_GOURAUD = TRUE ;

	// 3Dfx OpenGL では、glReadBuffer を使えない
//	if (envOpenGL == VOODOO || envOpenGL == VOODOO_RUSH ||
//		envOpenGL == VOODOO2 || envOpenGL == VOODOO2_SLI ||
//		envOpenGL == VOODOO_BANSHEE) DONOT_USE_GL_READ_BUFFER = TRUE ;
	if (envOpenGL == VOODOO || envOpenGL == VOODOO_RUSH ||
		envOpenGL == VOODOO_BANSHEE)
	{
		DONOT_USE_GL_READ_BUFFER = TRUE ;
		fxOpenGL = TRUE ;
	}

	// RIVA TNT でＺバッファにバグが出る場合
	if (envOpenGL == RIVA_TNT_FIX) zOffset = Z_OFFSET_TNT_FIX ;
	else                           zOffset = Z_OFFSET ;


	// ウィンドウサイズ

	xsize = is_set_width  = option.GetInt   ("-width",  IS_SET_WIDTH,  2) ;
	ysize = is_set_height = option.GetInt   ("-height", IS_SET_HEIGHT, 2) ;

	if (!xsize) xsize = WIDTH ;
	if (!ysize) ysize = HEIGHT ;

	full = option.Get("-FULL", 3) ;

	if (voodoo)
	{
		if (!is_set_width)  is_set_width  = WIDTH ;
		if (!is_set_height) is_set_height = HEIGHT ;
		full = TRUE ;
	}

#ifdef WIN32
	bpp = option.GetInt("-bppixel", BPPIXEL, 2) ;
#endif

	// スクリーンセーバ起動オプション
	saver = option.Get("-SAVER", 3) ;
	if (saver)
	{

		full = TRUE ;	// スクリーンセーバ起動時は必ずフルスクリーン
		title = "glclock screen saver" ;

#ifdef WIN32
		// IME 消去
		WINNLSEnableIME(NULL,FALSE) ;
#endif

		// Voodoo モードでスクリーンセーバ時は
		// -w 640 -h 480 がセットされたことにする
		if ((!is_set_width || !is_set_height) && voodoo)
		{
			is_set_width  = xsize = 640 ;
			is_set_height = ysize = 480 ;
		}

		// スクリーンセーバ時の描画サイズ（シザーサイズ）
		// スクリーンセーバ以外のモードでは 1.0f となる
		clockSize = option.GetDouble("-csize", CLOCK_SIZE, 3) ;
	}

	SetSignPosition() ;

	m_speed    = option.GetDouble("-mspeed",    SPEED,     3) ;
	f_prn      = option.Get      ("-FPS",                  2) ;
	anti       = option.GetInt   ("-anti",     ANTI,       2) ;
	motion     = option.GetInt   ("-motion",   MOTION,     2) ;
	s_motion   = option.GetInt   ("-smotion",  S_MOTION,   3) ;
	shutter    = option.GetDouble("-shutter",  SHUTTER,    3) ;
	s_shutter  = option.GetDouble("-sshutter", S_SHUTTER,  3) ;
	lid        = option.Get      ("-NOLID",                3) ;
	bg_color   = option.GetInt   ("-bgcolor",  BG_COLOR,   3) ;
	if (!saver)
		title  = option.GetString("-title",    TITLE_VER,  3) ;
	stop       = option.Get      ("-STOP",                 3) ;
	dither     = option.GetInt   ("-dither",   DITHER,     3) ;
	light      = option.GetInt   ("-light",    LIGHT,      2) ;
	local      = option.Get      ("-LOCAL",                3) ;

	env_file   = option.GetString("-efile",    ENV_FILE,   3) ;
	solid_file = option.GetString("-sfile",    SOLID_FILE, 3) ;
	sld2_file  = option.GetString("-sfile",    SLD2_FILE,   3) ;

	env        = option.GetInt   ("-env",      ENV_TEX,    2) ;
//	if (env == 2) env = 3 ;

	sol        = option.GetInt   ("-solid",    SOLID_TEX,  2) ;
	texture = env ;
	if (sol) texture = solid = sol ;

//	texture    = option.GetInt   ("-texture",  TEXTURE,    2) ;
//	solid      = option.Get      ("-solid",                3) ;

	min_filter = option.GetString("-filter",   MIN_FILTER, 3) ;

	if (min_filter == String(MIN_FILTER))
	{
		int filter ;

		filter = option.Get("-N") ;
		if (filter) min_filter = String("N") ;

		filter = option.Get("-L") ;
		if (filter) min_filter = String("L") ;

		filter = option.Get("-NN") ;
		if (filter) min_filter = String("NN") ;

		filter = option.Get("-LN") ;
		if (filter) min_filter = String("LN") ;

		filter = option.Get("-NL") ;
		if (filter) min_filter = String("NL") ;

		filter = option.Get("-LL") ;
		if (filter) min_filter = String("LL") ;
	}

	spec       = option.GetDouble("-specular", SPECULAR,    3) ;
	crystal    = option.Get      ("-CRYSTAL",               2) ;
	crystal_a  = option.GetDouble("-calpha",   CRYSTAL_A,   3) ;
	pol_mode   = option.GetString("-pmode",    POL_MODE,    3) ;
	reality    = option.GetInt   ("-real",     REALITY,     2) ;
	pers_corr  = option.GetString("-pers",     PERS_CORR,   2) ;
	tex_scale  = option.GetDouble("-texscale", 0.0f,         2) ;
	s_scale    = option.GetDouble("-sscale",   TEX_SCALE,   3) ;
	t_scale    = option.GetDouble("-tscale",   TEX_SCALE,   3) ;
	reflection = option.Get      ("-REFLECT",               2) ;
//	max_tex    = option.Get      ("-maxtex",                3) ;
	tex_size   = option.GetInt   ("-isize",    TEX_SIZE,    2) ;
	u_smooth   = option.GetInt   ("-usmooth",  U_SMOOTH,    2) ;
	v_smooth   = option.GetInt   ("-vsmooth",  V_SMOOTH,    2) ;
	glut_buff  = option.Get      ("-SINGLE",                2) ;
	benchmark  = option.Get      ("-BENCH",                 2) ;
	m_sleep    = option.GetInt   ("-sleep",    M_SLEEP,     3) ;
	sleepRatio = option.GetDouble("-sratio",   SLEEP_RATIO, 3) ;
	n_width    = option.GetDouble("-nwidth",   N_WIDTH,     2) ;
	tex_format = option.GetString("-tformat",  TEX_FORMAT,  3) ;

	zOffset    = option.GetDouble("-zoffset",  zOffset,     2) ;
	if (zOffset > 0.0f) polygon_offset = TRUE ;

	no_sign    = option.Get      ("-NOSIGN",                4) ;
	no_message = option.Get      ("-NOMESG",                4) ;
	fout_fps   = option.GetString("-foutfps",               3) ;


	if ((clock_quality = option.GetInt("-quality", QUALITY, 2)) < 1) clock_quality = 1 ;
	else if (                                     clock_quality > 8) clock_quality = 8 ;
	SetQuality(clock_quality - 1) ;

	clock_hedron = option.GetInt("-hedron", clock_hedron, 4) ;
	clock_div    = option.GetInt("-divide", clock_div,    2) ;
	clock_glass  = option.GetInt("-glass",  clock_glass,  2) ;
	clock_point  = option.GetInt("-bit",    clock_point,  3) ;
	clock_mesh   = option.GetInt("-mesh",   clock_mesh,   3) ;
	gold_depth   = option.GetInt("-gold",   gold_depth,   3) ;

	if (m_sleep <= 0) us_sleep = 0 ;
	else              us_sleep = (unsigned int)m_sleep * 1000 ;

	if (sleepRatio > 0.0f)
	{
		// 最低でも１０％
		if      (sleepRatio < 0.1f) sleepRatio = 0.1f ;
		// １００％超過の場合は指定なしと見なす
		else if (sleepRatio > 1.0f) sleepRatio = 0.0f ;
	}

	if      (n_width < 0.0f) n_width = 0.0f ;
	else if (n_width > 3.0f) n_width = 3.0f ;

	// ダブル or シングルバッファ
	if (glut_buff) glut_buff = GLUT_SINGLE ;
	else           glut_buff = GLUT_DOUBLE ;

	// ソリッドテクスチャスケール
	if (tex_scale) { s_scale = t_scale = tex_scale ; }
	if (s_scale == 0.0f) s_scale = TEX_SCALE ;
	if (t_scale == 0.0f) t_scale = TEX_SCALE ;

	if (tex_size > 30) tex_size = 30 ;

	// anti を適正な値に
	switch(anti)
	{
	case 1: anti = 2 ; break ;
	case 7: anti = 8 ; break ;
	case 10:
	case 11: anti = 12 ; break ;
	case 13:
	case 14:
	case 15: anti = 16 ; break ;
	default:
		if (anti < 0) anti = 0 ;
		else if (anti > 16) anti = 16 ;
		break ;
	}

	if (motion   < 2) motion   = 0 ;
	if (s_motion < 2) s_motion = 0 ;

//	if      (light < 0) light = 0 ;
	if      (light < 1) light = 1 ;
	else if (light > 5) light = 5 ;

	if (clock_div < 3) clock_div = 3 ;
	if (clock_div < 6 && gold_depth >= 1) gold_depth = 0 ;

	if      (clock_glass < 0) clock_glass = 0 ;
	else if (clock_glass > 3) clock_glass = 3 ;

	if (anti)   default_anti   = anti ;
	else        default_anti   = N_ANTI ;
	if (motion) default_motion = motion ;
	else        default_motion = N_MOTION ;
	pre_motion = 0 ;
	if (s_motion) pre_s_motion = s_motion ;
	else          pre_s_motion = N_MOTION ;

	// 表面グラスの法線のずらしレート
	if (local) norm_ratio = 0.5f ;
	else       norm_ratio = 1.0f ;

	n_golden = clock_div ;
	if (n_golden > 8) n_golden = 8 ;
	if (clock_div == 3) n_golden = 0 ;

	if      (String("N")  == min_filter) { gl_min_filter = gl_mag_filter = GL_NEAREST ; }
	else if (String("L")  == min_filter) { gl_min_filter = gl_mag_filter = GL_LINEAR ; }
#ifdef WIN32
	else if (String("NN") == min_filter) { gl_min_filter = gl_mag_filter = GL_NEAREST ; }
	else if (String("LN") == min_filter) { gl_min_filter = gl_mag_filter = GL_LINEAR ; }
#else
	else if (String("NN") == min_filter) { gl_min_filter = GL_NEAREST_MIPMAP_NEAREST ; gl_mag_filter = GL_NEAREST ; }
	else if (String("LN") == min_filter) { gl_min_filter = GL_LINEAR_MIPMAP_NEAREST ; gl_mag_filter = GL_LINEAR ; }
#endif
	else if (String("NL") == min_filter) { gl_min_filter = GL_NEAREST_MIPMAP_LINEAR ; gl_mag_filter = GL_NEAREST ; }
	else                                 { gl_min_filter = GL_LINEAR_MIPMAP_LINEAR ; gl_mag_filter = GL_LINEAR ; }

	if      (String("P")  == pol_mode) gl_pol_mode = GL_POINT ;
	else if (String("L")  == pol_mode) gl_pol_mode = GL_LINE ;
	else                               gl_pol_mode = GL_FILL ;

	gl_pers_corr = GetHintMode(pers_corr) ;

	if (reality < 0) reality = 0 ;
	if (reality)
	{
//		if (reality > 3) reality = 3 ;
		if (reality > 2) reality = 2 ;
		solid = 1 ;
		texture = 3 ;
	}

	if (solid) solid = 1 ;
	if      (texture <= 0) { texture = 0 ; solid = 0 ; }	// テクスチャなしなら solid = 0 に
	else if (texture >  3) texture = 3 ;

	if (crystal < 0) crystal = 0 ;
	if (crystal > 2) crystal = 2 ;
	if (crystal) texture = 3 ;	// クリスタルなら texture = 3 に

	// テクスチャマッピング時と、時計が６角形以下の時は glass != 1 に
	if (clock_glass == 1 && (texture || clock_div <= 6)) clock_glass = 2 ;

	radius_ratio = RadiusRatio() ;

	if (solid && texture == 3) specular = 0.0f ;
	else                       specular = 1.0f ;

	if (!env_file.Search(".ppm"))   env_file   += ".ppm" ;
	if (!solid_file.Search(".ppm")) solid_file += ".ppm" ;
	if (sld2_file != String("") && !sld2_file.Search(".ppm")) sld2_file += ".ppm" ;


	// 環境マッピングを使用する場合は、メッシュの座標値を多少変更
	if ((texture && !solid) || reality)
	{
		s_v[4][0] = 16.0f ; s_v[4][1] = 3.7f ;	// -e -r の時 s_v[4] = (16.3f, 3.4f) に
		s_v[8][0] = 18.6f ; s_v[8][1] = 1.3f ;	// -e -r の時 s_v[8] = (19.0f, 1.1f) に
	}

	s.Unit() ;
	t = UnitNormal(s, l) ;

	// 初期化
	t_ratio		= T_RATIO ;
	i_ratio		= I_RATIO ;
	t_max		= T_MAX ;
	p_min		= P_MIN ;
	p_max		= P_MAX ;
	ir_ratio	= IR_RATIO ;
	fog_mode	= FOG_MODE ;
	fog_density	= FOG_DENSITY ;

	spin_x = SPIN_X ;
	spin_y = SPIN_Y ;
	dist_y = B_DIST ;

	last_x = mouse_x = xsize / 2 ;
	last_y = mouse_y = ysize / 2 ;

	if (lid) t_roof = 0.0f ;
	else     t_roof = 1.0f ;

	p_step = z_step = 0.0f ;
	DragL = DragR = 0 ;

	now.h_rotate = 0.0f ;
	now.g_spin = 0.0f ;
	now.pers = pre.pers = 1.0f ;
	now.clock_z = pre.clock_z = B_DIST ;
	now.roof = pre.roof = 0.0f ;

	// FPS 関連
	f_cnt = 1 ;
	f_time = 1 ;
	f_cal_flag = FALSE ;

	int h_polygons = 8 ;
	if (clock_hedron) h_polygons = 20 ;

	nm_polygons = (n_s_vtx[clock_mesh] - 3 + (!lid ? n_r_vtx[clock_mesh] - 2 : 0)) * clock_div * 2
				+ (2 + (!lid ? 1 : 0)) * clock_div
				+ Pow(4, gold_depth + 1) * n_golden + 28 * 3 + h_polygons * 12
				+ clock_point * 3 * 48 + 8 ;

	if (!solid && (texture == 2) && !crystal) // -e 2
		nm_polygons *= 2 ;
	else if (!solid && (texture == 3) && !crystal) // -e 3
		nm_polygons *= 2 ;
	else if (texture == 3 && solid && !crystal && !reality) // -s 3
		nm_polygons *= 2 ;
	else if (texture == 3 && reality) // -r 1 or 2
	{
		nm_polygons += (n_s_vtx[clock_mesh] - 3 + (!lid ? n_r_vtx[clock_mesh] - 2 : 0)) * clock_div * 2
					+ (2 + (!lid ? 1 : 0)) * clock_div + clock_point * 3 * 48 + 8 ;
		if (reflection) nm_polygons += ((2 * 2 + 1) * clock_div) + 28 * 3 + h_polygons * 12 + clock_point * 3 * 48 * 2 + 8 * 2 ; // -R
	}

	// バックグラウンドカラー
	if (bg_color > 4) bg_color = 0 ;
	currentBG[0] = bgColor[bg_color].v[0] ;
	currentBG[1] = bgColor[bg_color].v[1] ;
	currentBG[2] = bgColor[bg_color].v[2] ;
	currentBG[3] = 1.0f ;

	// LIGHT0 カラー
	currentGC[0] = 0.2f + (currentCL[0] = currentLC[0] = lightCl[0].v[0]) ;
	currentGC[1] = 0.2f + (currentCL[1] = currentLC[1] = lightCl[0].v[1]) ;
	currentGC[2] = 0.2f + (currentCL[2] = currentLC[2] = lightCl[0].v[2]) ;
	currentGC[3] = currentCL[3] = currentLC[3] = 1.0f ;

	// クランプ
	if (mesa)
	{
		if (currentCL[0] > 1.0f) currentCL[0] = 1.0f ;
		if (currentCL[1] > 1.0f) currentCL[1] = 1.0f ;
		if (currentCL[2] > 1.0f) currentCL[2] = 1.0f ;

		if (currentGC[0] > 1.0f) currentGC[0] = 1.0f ;
		if (currentGC[1] > 1.0f) currentGC[1] = 1.0f ;
		if (currentGC[2] > 1.0f) currentGC[2] = 1.0f ;
	}

	timeData.t = time(NULL) ;
	timeData.t_area = localtime(&timeData.t) ;

	timeData.p_hour   = timeData.n_hour   = timeData.t_area->tm_hour % 12 ;
	timeData.p_minute = timeData.n_minute = timeData.t_area->tm_min ;
	timeData.p_second = timeData.n_second = timeData.t_area->tm_sec ;

//	FramesPerSecond(FALSE) ;
	FramesPerSecond() ;
	f_cal_flag = TRUE ;

	if (stop) now.roof = pre.roof = 1.0f ;

#ifdef WIN32
	g_hFileMap = OpenFileMapping(FILE_MAP_ALL_ACCESS, FALSE, "GLCLOCK") ;
	if (g_hFileMap)
		g_pFps = (char*)MapViewOfFile(g_hFileMap, FILE_MAP_ALL_ACCESS, 0, 0, 0) ;
#endif

#ifdef GIFF_DEMO
	spin_x = GIFF_SPIN_X ;
#endif
}

// glut 初期化
void InitWindow(Option& option)
{
	int argc = option.ArgC(), x = 0, y = 0 ;
	// Window Setup
#if defined WIN32 // && defined VOODOO_MODE
	int cw, cy ;
	SetDisplayMode(xsize, ysize, cw, cy) ;
	SetDisplayBPP(bpp, cw, cy) ;
#endif

// jun
// glutInit don't work well. Is it no need for BeOS?
//	glutInit(&argc, option.ArgV()) ;

	glutInitDisplayMode(glut_buff | GLUT_RGB | GLUT_DEPTH | GLUT_ACCUM) ;

	if (!no_message)
	{
		if (glut_buff == GLUT_SINGLE) cout << "Single buffer mode." << endl ;
		else                          cout << "Double buffers mode." << endl ;
	}

	if ((x = option.GetInt("-xposition", NONE, 3)) != NONE &&
	    (y = option.GetInt("-yposition", NONE, 3)) != NONE)
		glutInitWindowPosition(x, y) ;

	glutInitWindowSize(xsize, ysize) ;
	winIDglut = glutCreateWindow(title) ;
	if (saver) glutSetCursor(GLUT_CURSOR_NONE) ;

//	int winID = glutCreateWindow(title) ;
//	glutCreateSubWindow(winID, 0,0, 160,160) ;
//	glutSetWindow(winID) ;

	if (full) glutFullScreen() ;
/*
#ifdef WIN32
	if (saver)
	{
		HWND win ;
		win = FindWindow("GLUT", title) ;
		if (win)
		{
			SetWindowPos(win, HWND_NOTOPMOST,
						 0, 0,
						 GetSystemMetrics(SM_CXSCREEN),
						 GetSystemMetrics(SM_CYSCREEN),
						 SWP_NOREDRAW | SWP_NOMOVE) ;
		}
	}
#endif
*/
}

// デプスバッファセット
void SetDepthBuffer()
{
	glClearDepth(1.0f) ;
	glEnable(GL_DEPTH_TEST) ;
	glDepthFunc(GL_LESS) ;
}

// 光源セット
void SetLightModel()
{
	GLfloat	amb = 0.1f / light + 0.02f ;
	GLfloat	wamb[] = { amb, amb, amb, 1.0f } ;
	GLint	sFlag = (reality != 2) ;

	if (texture != 1 && (env != 2)) glEnable(GL_LIGHTING);
	glLightModeli(GL_LIGHT_MODEL_LOCAL_VIEWER, local) ;
	glLightModeli(GL_LIGHT_MODEL_TWO_SIDE, 1) ;

	if (env == 1 || env == 2) return ;

	// ワールド環境光 
	glLightModelfv(GL_LIGHT_MODEL_AMBIENT, wamb) ;

	if (light >= 5) glEnable(GL_LIGHT4) ;
	if (light >= 4) glEnable(GL_LIGHT3) ;
	if (light >= 3) glEnable(GL_LIGHT2) ;
	if (light >= 2) glEnable(GL_LIGHT1) ;
	if (light >= 1) glEnable(GL_LIGHT0) ;

	SetLight(GL_LIGHT0, lpos[0], lcol[0], amb, TRUE, sFlag) ;	// LIGHT0 セット
	SetLight(GL_LIGHT1, lpos[1], lcol[1], amb, TRUE, sFlag) ;	// LIGHT1 セット
	SetLight(GL_LIGHT2, lpos[2], lcol[2], amb, TRUE, sFlag) ;	// LIGHT2 セット
	SetLight(GL_LIGHT3, lpos[3], lcol[3], amb, TRUE, sFlag) ;	// LIGHT3 セット
	SetLight(GL_LIGHT4, lpos[4], lcol[4], amb, TRUE, sFlag) ;	// LIGHT4 セット
}

// フォグセット
void SetFog()
{
	glEnable(GL_FOG) ;
	glFogfv(GL_FOG_COLOR,	currentBG) ;
	glFogf(GL_FOG_MODE,		fog_mode) ;
	glFogf(GL_FOG_DENSITY,	fog_density) ;
}

// GL 関連セット
void SetGL()
{
	if (saver)
		glClearColor(0.0f, 0.0f, 0.0f, 1.0f) ;
	else
		glClearColor(currentBG[0], currentBG[1], currentBG[2], currentBG[3]) ;

	glShadeModel(GL_SMOOTH) ;
	glCullFace(GL_BACK) ;
	glEnable(GL_CULL_FACE) ;

	if (saver)
		glEnable(GL_SCISSOR_TEST) ;

	// Reset Matrix
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity() ;
	gluLookAt(0.0f,0.0f,0.0f, 0.0f,0.0f,-1.0f, 0.0f,1.0f,0.0f) ;

	glPolygonMode(GL_FRONT_AND_BACK, gl_pol_mode) ;
	glHint(GL_PERSPECTIVE_CORRECTION_HINT, gl_pers_corr) ;

//	if (clock_glass == 1) glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA) ;
//	else if (texture == 3 && solid) glBlendFunc(GL_ONE, GL_ONE) ;
//	else glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_COLOR) ;
//	else glBlendFunc(GL_ONE, GL_ONE) ;

	glBlendFunc(GL_ONE, GL_ONE) ;

	if (dither) glEnable(GL_DITHER) ;
	else        glDisable(GL_DITHER) ;

	if (texture) SetTexture() ;

	SetDepthBuffer() ;
	SetLightModel() ;
	SetFog() ;

#ifdef GL_VERSION_1_1
	if (polygon_offset) glPolygonOffset(-zOffset, -1.0f) ;
#endif
}

// 累積回転行列初期化
void InitRotate()
{
	glMatrixMode(GL_MODELVIEW) ;
	glLoadIdentity() ;

	glRotatef(ROTATE_Y, 0.0f,1.0f,0.0f) ;
	glRotatef(ROTATE_X, 1.0f,0.0f,0.0f) ;

#ifdef GIFF_DEMO
	glRotatef(-6.0f, 0.0f,1.0f,0.0f) ;
#endif

	glGetFloatv(GL_MODELVIEW_MATRIX, aRotate) ;
}


void ScreenShot()
{
	// 読み込みバッファを、現在の書き込みバッファにセット
	GLenum drawBuffer ;
	glGetIntegerv(GL_DRAW_BUFFER, (GLint *)(&drawBuffer)) ;
	glReadBuffer(drawBuffer) ;

	TRUEIMAGE *image ;
	image = (TRUEIMAGE *)malloc(sizeof(TRUEIMAGE)) ;
	if (!image) return ;
	image->dataptr = (unsigned char *)malloc(sizeof(unsigned char) * xsize * ysize * 3) ;
	if (!image->dataptr) return ;

	image->width  = xsize ;
	image->height = ysize ;

	glReadPixels(0,0, image->width,image->height, GL_RGB, GL_UNSIGNED_BYTE, image->dataptr) ;

	// OpenGL はゼロが下のため反転
	ReverseCoordinates(image, FALSE, TRUE) ;

	FILE *scrout ;
	scrout = fopen("glclock_shot.ppm", "wb") ;
	if (scrout)
	{
		outputppm(image, scrout, "glclock screen shot") ;
	}
	fclose(scrout) ;

	freeimage(image) ;
}


void CreateRoofGradation()
{
	int i, div = clock_div / 4 ;
	if (!div) div = 1 ;

	rgrad = new Vector3d[ngrad = div * 4] ;

	for (i = 0 ; i < 4 ; i ++)
	{
		int j ;
		for (j = 0 ; j < div ; j ++)
		{
			rgrad[i * div + j] = (rcol[i] * (div - j) + rcol[(i + 1) % 4] * j) / div ;
		if      (reality == 1) rgrad[i * div + j] *= 0.5f ;
		else if (reality == 2) rgrad[i * div + j] *= 0.7f ;
		}
	}


	float color_weight = 1.0f / default_anti ;
	rgrad_anti = new Vector3d[ngrad = div * 4] ;

	for (i = 0 ; i < 4 ; i ++)
	{
		int j ;
		for (j = 0 ; j < div ; j ++)
		{
			rgrad_anti[i * div + j] = (rcol[i] * (div - j) + rcol[(i + 1) % 4] * j) / div * color_weight ;
			if      (reality == 1) rgrad_anti[i * div + j] *= 0.5f ;
			else if (reality == 2) rgrad_anti[i * div + j] *= 0.7f ;
		}
	}

	color_weight = 1.0f / default_motion ;
	rgrad_motion = new Vector3d[ngrad = div * 4] ;

	for (i = 0 ; i < 4 ; i ++)
	{
		int j ;
		for (j = 0 ; j < div ; j ++)
		{
			rgrad_motion[i * div + j] = (rcol[i] * (div - j) + rcol[(i + 1) % 4] * j) / div * color_weight ;
			if      (reality == 1) rgrad_motion[i * div + j] *= 0.5f ;
			else if (reality == 2) rgrad_motion[i * div + j] *= 0.7f ;
		}
	}
}

// 初期化
void Initialize(Option& option)
{
	InitVar(option) ;
	if (!no_message) StartingMessage ;

	InitWindow(option) ;
	SetGL() ;
	InitRotate() ;
	CreateRoofGradation() ;

	if (anti) jitter = CreateSampleJitter(anti) ;
	if (!jitter) anti = 0 ;
}

// キーボードイベントハンドラ
void HandleKey(unsigned char key, int x, int y)
{
	// ベンチマーク時は ESC キー入力以外は受け付けない
    if (benchmark)
	{
		if (key == 0x1b)
		{
			EndProc() ;
			exit(0) ;
		}
		else return ;
	}

    switch (key)
	{
	case 0x1b:	// ESC で終了
		EndProc() ;
		exit(0) ;

	case ' ':	// スペースで蓋開閉
		t_roof = 1.0f - t_roof ;
		break ;

	case 's':	// 's' または 'S' で停止
	case 'S':
		spin_x *= 0.1f ;
		spin_y *= 0.1f ;
		break ;

	case 'a':	// 'a' または 'A' でアンティエイリアシング
	case 'A':
		if (!anti)
		{
			anti = default_anti ;
			if (!jitter) jitter = CreateSampleJitter(anti) ;

			// VOODOO では両方かけるとやばい
			if (voodoo) motion = OFF ;
		}
		else
			anti = OFF ;
		break ;

	case 'm':	// 'm' または 'M' でモーションブラー
	case 'M':
		pre_motion = motion ;		// 直前の motion 値を記録
		if (!motion)
		{
			motion = default_motion ;

			// VOODOO では両方かけるとやばい
			if (voodoo) anti = OFF ;
		}
		else
			motion = OFF ;
		break ;

	case 'n':	// 'n' または 'N' で秒針だけモーションブラー
	case 'N':
		if (!s_motion) s_motion = pre_s_motion ;
		else           s_motion = OFF ;
		break ;

	case 'f':	// 'f' または 'F' でＦＰＳ表示
	case 'F':
		if (!f_prn) f_prn = ON ;
		else        f_prn = OFF ;
		break ;

#ifdef GIFF_DEMO
	case 'g':
	case 'G':
		Redisplay() ;
#endif

	case 'c':	// 'c' または 'C' でスクリーンキャプチャ
	case 'C':
		ScreenShot() ;
		break ;

	}
}


// glut コールバック登録
void SetCallback()
{
	glutDisplayFunc(DrawModel) ;
	glutReshapeFunc(ReshapeWindow) ;

	if (saver)
	{
		glutKeyboardFunc(ExitSaver);

		glutMouseFunc(ExitSaver) ;
		glutSpecialFunc(ExitSaver) ;
		glutMotionFunc(ExitSaver) ;

		glutPassiveMotionFunc(ExitSaverWait) ;

		glutIdleFunc(Redisplay) ;
	}
	else
	{
		glutKeyboardFunc(HandleKey);

#ifndef GIFF_DEMO
		if (!benchmark)
		{
			glutMouseFunc(MouseProc) ;
			glutSpecialFunc(SpecialKeyProc) ;
			glutMotionFunc(MouseMotion) ;
		}
		glutIdleFunc(Redisplay) ;
#endif
	}
}

void SignalIntProcedure(int sig)
{
	EndProc() ;
	exit(1) ;
}

//jun
int main(int argc, char**argv)
{
	Option option(argc, argv) ;
	signal(SIGINT, SignalIntProcedure) ;
	Initialize(option) ;
	MakeDisplayLists() ;
	SetCallback() ;
	start = TRUE ;
	DrawModel() ;	// ステータス保存のため、一度コール

	glutMainLoop() ;
	return 0 ;
}

// メイン
/*
#if !defined WIN32 || defined WIN32_CONSOLE_APP
int main(int argc, char** argv)
{
#ifdef WIN32
	// スクリーンセーバモードで起動中のものがあれば
	// その場で終了
	HWND win ;
	win = FindWindow("GLUT", "glclock screen saver") ;
	if (win) return FALSE ;
#endif

	Option option(argc, argv) ;

	signal(SIGINT, SignalIntProcedure) ;

	Initialize(option) ;

	MakeDisplayLists() ;

	SetCallback() ;

	start = TRUE ;
	DrawModel() ;	// ステータス保存のため、一度コール

	glutMainLoop() ;
	return 0 ;
}

#else
// Windows メイン
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
	// スクリーンセーバモードで起動中のものがあれば
	// その場で終了
	HWND win ;
	win = FindWindow("GLUT", "glclock screen saver") ;
	if (win) return FALSE ;

	Option option(__argc, __argv) ;

	signal(SIGINT, SignalIntProcedure) ;

	Initialize(option) ;
	MakeDisplayLists() ;

	SetCallback() ;
	start = TRUE ;
	DrawModel() ;	// ステータス保存のため、一度コール

	glutMainLoop() ;
	return 0 ;
}
#endif
*/

